package org.eso.ohs.phase2.apps.masktracker;

import org.apache.log4j.Logger;
import org.eso.ohs.core.dbb.client.DbbSelectionList;
import org.eso.ohs.core.dbb.sql.DbbSqlChunk;
import org.eso.ohs.core.dbb.sql.DbbSqlOperator;
import org.eso.ohs.core.utilities.TextUtils;
import org.eso.ohs.dfs.Mask;
import org.eso.ohs.dfs.Queue;
import org.eso.ohs.phase2.apps.ot.dbb.BrowserConfig;

/**
 * The QueueItemsBView class is a DB search engine used for 
 * displaying queues of OBs according to a user-definable set of 
 * properties
 * @author G Passera
 * @author Tim Canavan 
 * @author cmavros Add call to unsubscribe execution action.
 * @author cmavros 1709/OT Call ExecutionSequenceAction 
 *               class to implement progress bar
 *
 * @version $Id: MaskManQueueBrowser.java,v 1.22 2007/10/11 11:43:12 pnunes Exp $
 *
 * @author cmavros Add call to unsubscribe execution action.
 * @author cmavros 1709/OT Call ExecutionSequenceAction 
 *               class to implement progress bar
 *
 * @version $Id: MaskManQueueBrowser.java,v 1.22 2007/10/11 11:43:12 pnunes Exp $
 *
 */

public class MaskManQueueBrowser extends DefaultMaskBrowser {

    private static Logger stdlog_ =
	Logger.getLogger(MaskManQueueBrowser.class );
  
   


  /**
   * Default constructor
   *
   */
    public MaskManQueueBrowser(Queue newQueue,
    		MaskExecSequence maskExecSequence,
    		MaskQueueView mkView) {
        super(newQueue,maskExecSequence,mkView);
        appendRows();
    }

    private void appendRows() {
        DbbSqlOperator op_in = null;
        try {
            op_in = new DbbSqlOperator("in");
        }
        catch( Exception e ) { 
            stdlog_.error( e ); 
        }
        String label_name = "Status";
        String column_name = "mask_status";
        DbbSqlChunk c = new DbbSqlChunk(BrowserConfig.masks, column_name, label_name, op_in, String.class);
        Object[] statusValues = {Mask.NO_MASK,Mask.PENDING_MANUFACTURED,Mask.MASK_REMANUFACTURE};
        String[] statusDispValues = {Mask.getDisplayStatusValue(Mask.NO_MASK),
                                     Mask.getDisplayStatusValue(Mask.PENDING_MANUFACTURED),
                                     Mask.getDisplayStatusValue(Mask.MASK_REMANUFACTURE)};
        DbbSelectionList status = new DbbSelectionList(label_name, c,statusValues, statusDispValues);
        rowPanel_.addWidget(status);
        status.set("(" + "'" + TextUtils.quoteSqlString(Mask.NO_MASK) + "'"+ ",'" + 
	               TextUtils.quoteSqlString(Mask.PENDING_MANUFACTURED) + "'" + 
	               ",'" + TextUtils.quoteSqlString(Mask.MASK_REMANUFACTURE) + "'"  + ")");
        //status.getList().addSelectionInterval(0,2);
        status.fireDbbWidgetAction();
	    getDbbView().setWherePanel(rowPanel_, "North");
    }
}
