package org.eso.ohs.phase2.apps.ot.actions;

import java.awt.event.ActionEvent;

import javax.swing.AbstractAction;
import javax.swing.JTable;

import org.eso.ohs.core.gui.widgets.ErrorMessages;
import org.eso.ohs.core.utilities.ObjectIOException;
import org.eso.ohs.dfs.CalibrationBlock;
import org.eso.ohs.persistence.Config;
import org.eso.ohs.persistence.Media;
import org.eso.ohs.persistence.ObjectManager;
import org.eso.ohs.persistence.ObjectNotFoundException;
import org.eso.ohs.phase2.apps.ot.dbb.OTDbbView;
import org.eso.ohs.phase2.apps.ot.gui.OBTreeView;

public class DisplayOBAction extends AbstractAction {

    private OTDbbView otDbbView_;

    private OBTreeView treeView_;

    private JTable table_;

    public DisplayOBAction(OTDbbView otDbbView, OBTreeView treeView) {
        super("Display");
        if (otDbbView == null || treeView == null) {
            throw new IllegalArgumentException("OtdbbView is "+otDbbView+" ObTreeView is "+treeView);
        }
        otDbbView_ = otDbbView;
        treeView_ = treeView;
        table_ = otDbbView.getJTable();
    }

    public void actionPerformed(ActionEvent ev) {
        long[] selectedOBsId = otDbbView_.getAllSelectedOBIds();
        if (selectedOBsId.length > 0) {
            try {
                CalibrationBlock cb = null;
                ObjectManager objMgr = ObjectManager.getObjectManager();
                Class c = otDbbView_.getClassForId(
                        Config.getCfg().uniqueToTableId(selectedOBsId[0]));
                cb = (CalibrationBlock) objMgr.getBusObj(Media.DBASE,
                        selectedOBsId[0], c);
                treeView_.updateView(cb);
            } catch (ObjectIOException ex) {
                ErrorMessages.announceIOError(table_, ex);
            }

            catch (ObjectNotFoundException ex) {
                ErrorMessages.announceNoObject(table_, ex);
            }

        }
    }

}
