package org.eso.ohs.phase2.apps.ot.actions;

import java.awt.event.ActionEvent;

import javax.swing.JFrame;
import javax.swing.JOptionPane;

import org.apache.log4j.Logger;
import org.eso.ohs.core.gui.baseaction.ActionSuperclass;
import org.eso.ohs.core.gui.utilities.Utilities;
import org.eso.ohs.core.utilities.ObjectIOException;
import org.eso.ohs.phase2.apps.ot.gui.OTMainView;
import org.eso.ohs.phase2.apps.ot.gui.RepositoryBrowserView;

/**
 * Action class to display the contents of the database.
 *
 * <p>
 * $Id: ShowDbaseAction.java,v 1.9 2006/04/27 13:21:57 pnunes Exp $
 * <br>
 * @author Bob Kemp
 */

public class ShowDbaseAction extends ActionSuperclass {

   /** Standard log channel */
   private static Logger stdlog_ =
       Logger.getLogger( ShowDbaseAction.class );

    /**
     * Constructs a ShowDbaseAction action.
     */
    public ShowDbaseAction(OTMainView mwdw) {
	super(mwdw, "Repository Browser");
    }

    /**
     * Event handler for the ShowDbaseAction action.
     * 
     * @param ev       user-initiated ActionEvent to quit.
     */
    public void actionPerformedImpl(ActionEvent evt) {
	JFrame frm;

	

	try {
	    frm = RepositoryBrowserView.getDbaseWindow();
        Utilities.setScreenSize(frm);
	    frm.setVisible(true);
	}
	catch (ObjectIOException e) {
	    // announceIOError(e);
	    stdlog_.error(e);	// Info for ESO User Support.
	    JOptionPane.showMessageDialog(
		null,
		new Object[] {
		    "Your objects in the ESO database could not be displayed.",
		    "This is usually because the server at ESO"
			+ " cannot be contacted"
			+ " for some reason.",
		    " ",
		    "Check your Internet connection to ESO"
			+ " and try again.",
		    "If error persists, contact ESO User Support.",
		},
		"Connection Error",
		JOptionPane.WARNING_MESSAGE
	    );
	}
    }

}


