package org.eso.ohs.phase2.apps.ot.gui;

import javax.swing.JFrame;

import org.eso.ohs.persistence.dbase.phase2.QueueManager;
import org.eso.ohs.phase2.apps.ot.wizard.OrangEngine;
import org.eso.ohs.phase2.apps.ot.wizard.OrangGUI;
import org.eso.ohs.phase2.apps.ot.wizard.OrangWizard;
import org.eso.ohs.phase2.orang.OrangModel;
import org.eso.ohs.phase2.orang.OrangModelDefault;
import org.eso.ohs.phase2.orang.OrangWidgetsData;

/**
 * This class contains instances of the necessary objects to run orang
 * 
 * @author pnunes 27.02.2006
 *
 */
public class Orang {
	
	private OrangEngine orang = null;
    private OrangModel model = null;
	private OrangWidgetsData data = null;
	private OrangGUI orangGUI = null;    
	private OrangWizard wizard = null;
	
	private JFrame parentFrame = null; 
	
	
	public Orang(JFrame parent) {
		parentFrame = parent;		
	}
	
	private void init() {
		
		
		// OrangEngine created as singleton because the QueueManager 
		// is a singleton and it would keep the reference to the listener
		// till the closing of the application.
		// OrangEngine listens to ob execution events.
		if (orang == null) {
			orang = new OrangEngine();
			QueueManager.addOBListener(orang);        
		}		
		
		if ( data == null )
			data = new OrangWidgetsData();
		
		if ( model == null) 
			model = new OrangModelDefault(data);

		
	}
	
	
	public void showWizard() {
		init();
		StartWizardSubThread wizard = new StartWizardSubThread();  
        Thread newThread = new Thread(wizard);
        newThread.start();
	}
	
	public void showOrangGUIStandard() {
		init();		
		if (orangGUI == null) {
			orangGUI = new OrangGUI(model, orang);		

		}
		
		orangGUI.showStandard();        
	}
	
	
	public void showOrangGUISmall() {
		init();		
		if (orangGUI == null) {
			orangGUI = new OrangGUI(model, orang);		

		}
		
		orangGUI.showSmall();        
	}
	
	
	/**
     * Class StartWizardSubThread
     *
     * Run the wizard in anothere subthread in order 
     * to have a non modal behavior 
     *
     * @version $Revision: 1.3 $
     * @author ddorigo, Nov 3, 2005
     */
    
    // $Id: Orang.java,v 1.3 2006/03/07 08:55:31 pnunes Exp $
    private class StartWizardSubThread implements Runnable {
        /* (non-Javadoc)
         * @see java.lang.Runnable#run()
         */
        public void run() {          	
        	wizard = new OrangWizard(orang);        	
            wizard.showWizard(parentFrame, "ORANG Wizard", false);      
        }
    }

}
