package org.eso.ohs.phase2.apps.ot.wizard;

import java.awt.BorderLayout;
import java.awt.FlowLayout;

import javax.swing.JPanel;

import org.eso.ohs.core.gui.widgets.OHSWizard;
import org.eso.ohs.core.gui.widgets.OHSWizardPage;
import org.eso.ohs.phase2.orang.OrangModel;
import org.eso.ohs.phase2.orang.OrangWidgetsData;

/**
 * This is the algorithm chooser wizard page
 * 
 * @author pnunes
 */
public class AlgorithmChooserPage extends OHSWizardPage {

	
	private static final String RANK_ALGORITHM_TITLE = "Step 4: choose ranking algorithm";
	private AlgorithmChooserPanel chooserPanel;
	private StatusPanel statusPanel;	
	
	public AlgorithmChooserPage (OHSWizard controller, OrangWidgetsData dataWidgets) {
		super(controller);
		
		initializePage(dataWidgets);
	}
	
	protected boolean isReady() {
		return(chooserPanel.isReady());
	}
	
	
	  /**
     * Initializer
     */
    protected void initializePage(OrangWidgetsData dataWidgets) {
    	    	
    	BorderLayout layout  = new BorderLayout();
	    setLayout(layout);		    

	    // title panel
	    add(OrangGUICommon.getWizardTitlePanel(RANK_ALGORITHM_TITLE),BorderLayout.NORTH);    	
    	    	
    	// weather panel
    	JPanel dummyPanel = new JPanel();
    	dummyPanel.setLayout(new FlowLayout(FlowLayout.LEFT));
    	
    	chooserPanel = new AlgorithmChooserPanel();
    	dummyPanel.add(chooserPanel);
    	
    	add(dummyPanel,BorderLayout.CENTER);
    	
    	
    	statusPanel = new StatusPanel();
    	add(statusPanel, BorderLayout.SOUTH);
        
                
        listenTo(chooserPanel.getComboBoxAlgorithm());
        chooserPanel.initData(dataWidgets);
     
    }

    
    public void updateModel(OrangModel model) {
    	chooserPanel.updateModel(model);
	}
   

	public void setInfo(String visibilityInfo) {
		statusPanel.setInfo(visibilityInfo);
		
	}

}
