package org.eso.ohs.phase2.apps.ot.wizard;

import java.awt.BorderLayout;
import java.awt.FlowLayout;

import javax.swing.JPanel;

import org.eso.ohs.core.gui.widgets.OHSWizard;
import org.eso.ohs.core.gui.widgets.OHSWizardPage;
import org.eso.ohs.phase2.orang.OrangModel;
import org.eso.ohs.phase2.orang.OrangWidgetsData;

public class OBVisibilityPage extends OHSWizardPage {
    
         
    private static final String TITLE_VISIBILITY = "Step 3: tune visibility computation constraints";
	private OBVisibilityPanel visibilityPanel;
    private StatusPanel statusPanel;
    private OrangWidgetsData dataWidgets;

    /**
     * Default constructor
     * @param defaultData 
     */
    public OBVisibilityPage(OHSWizard controller, OrangWidgetsData defaultData) {
        super(controller);
        dataWidgets = defaultData;
        visibilityPanel = new OBVisibilityPanel();
        initializePanel();
    }        
    
   
      
    /**
     * Initializer
     */
    protected void initializePanel() {
    	
    	BorderLayout layout  = new BorderLayout();
	    setLayout(layout);		    

	    // title panel
	    add(OrangGUICommon.getWizardTitlePanel(TITLE_VISIBILITY),BorderLayout.NORTH);    	
    	
    	
    	// weather panel
    	JPanel dummyPanel = new JPanel();
    	dummyPanel.setLayout(new FlowLayout(FlowLayout.LEFT));
    	
    	JPanel visibilityP = visibilityPanel.createPanel();
    	dummyPanel.add(visibilityP);
    	
    	add(dummyPanel,BorderLayout.CENTER);
    	
    	
    	statusPanel = new StatusPanel();
    	add(statusPanel, BorderLayout.SOUTH);
    	
    	
    	
    	
    	
    	listenTo(visibilityPanel.getSpinnerToleranceAirmass());
    	listenTo(visibilityPanel.getSpinnerToleranceFLI());
    	listenTo(visibilityPanel.getSpinnerToleranceMoonDistance());
    	listenTo(visibilityPanel.getSpinnerToleranceMoonAngle());
    	listenTo(visibilityPanel.getSpinnerToleranceSunAngle());
    	visibilityPanel.getSpinnerToleranceSunAngle().setValue(new Integer(-18));
    	
    	
    	listenTo(visibilityPanel.getRadioButtonInactiveFLI());
    	listenTo(visibilityPanel.getRadioButtonInactiveMoonDistance());
        listenTo(visibilityPanel.getRadioButtonInactiveSunAngle());
        listenTo(visibilityPanel.getRadioButtonInactiveMoonAngle());
        listenTo(visibilityPanel.getRadioButtonInactiveTimeInterval());
        listenTo(visibilityPanel.getRadioButtonInactiveSidTimeInt());
        listenTo(visibilityPanel.getRadioButtonInactiveZenith());

        listenTo(visibilityPanel.getRadioButtonActiveFLI());
        listenTo(visibilityPanel.getRadioButtonActiveMoonDistance());
        listenTo(visibilityPanel.getRadioButtonActiveSunAngle());
        listenTo(visibilityPanel.getRadioButtonActiveMoonAngle());
        listenTo(visibilityPanel.getRadioButtonActiveTimeInterval());
        listenTo(visibilityPanel.getRadioButtonActiveSidTimeInt());
        listenTo(visibilityPanel.getRadioButtonActiveZenith());
        
        visibilityPanel.getRadioButtonActiveFLI().doClick();
        visibilityPanel.getRadioButtonActiveMoonDistance().doClick();
        visibilityPanel.getRadioButtonActiveSunAngle().doClick();
        visibilityPanel.getRadioButtonActiveMoonAngle().doClick();
        visibilityPanel.getRadioButtonInactiveTimeInterval().doClick();
        visibilityPanel.getRadioButtonInactiveSidTimeInt().doClick();
        visibilityPanel.getRadioButtonActiveZenith().doClick();
        
    }
    
    
    
    public void updateModel(OrangModel model) {
    	visibilityPanel.updateModel(model);
	}

	protected boolean isReady() {
		return(visibilityPanel.isReady());
	}

	public void setInfo(String weatherInfo) {
		statusPanel.setInfo(weatherInfo);
		
	}




  
}
