package org.eso.ohs.phase2.apps.ot.wizard;

import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;

import javax.swing.ButtonGroup;
import javax.swing.JComboBox;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JRadioButton;
import javax.swing.JTextField;

import org.eso.ohs.core.gui.utilities.Utilities;
import org.eso.ohs.core.gui.widgets.OHSButtonGroup;
import org.eso.ohs.dfs.Seeing;
import org.eso.ohs.dfs.WindInfo;
import org.eso.ohs.dfs.SkyTransparency;
import org.eso.ohs.phase2.apps.ot.gui.SkyTransparencyCellRenderer;
import org.eso.ohs.phase2.orang.OrangModel;
import org.eso.ohs.phase2.orang.OrangWidgetsData;

public class OBWeatherPanel extends JPanel {

    private ButtonGroup buttongroupSeeing = new OHSButtonGroup(OrangGUICommon.BUTTONGROUP_SEEING);
    private ButtonGroup buttongroupWind = new OHSButtonGroup(OrangGUICommon.BUTTONGROUP_WIND);
	private ButtonGroup buttongroupSky = new OHSButtonGroup(OrangGUICommon.BUTTONGROUP_SKY);
	private JComboBox comboFieldSkyTransparency = new JComboBox();	

    private JLabel labelSeeing = new JLabel();
    private JLabel labelWind = new JLabel();

	private JLabel labelSkyTransparency = new JLabel();
    private JRadioButton radioButtonActiveSeeing = new JRadioButton();
    private JRadioButton radioButtonActiveWind = new JRadioButton();
	private JRadioButton radioButtonActiveSky = new JRadioButton();
    private JRadioButton radioButtonInactiveSeeing = new JRadioButton();
    private JRadioButton radioButtonInactiveWind = new JRadioButton();
	private JRadioButton radioButtonInactiveSky = new JRadioButton();
    private JTextField textFieldSeeing = new JTextField();
    private JTextField textFieldWind = new JTextField();
	private String valString;

	public OBWeatherPanel () {
		init();
	}
	

	public void init() {
		
		
		setName("jpanel");
		GridBagLayout gridBagLayout = new GridBagLayout();
		setLayout(gridBagLayout);
				
		GridBagConstraints gridBagConstraints ; 
        
    
		//****************************************Seeing
		labelSeeing.setName("labelSeeing");
		labelSeeing.setText("Seeing");
		labelSeeing.setToolTipText("The Seeing  is between 0.2 and 2");       
		gridBagConstraints = OrangGUICommon.getGridBagConstraints(0, 1, GridBagConstraints.WEST,1,5,0,0);               
		add(labelSeeing, gridBagConstraints);
		
		
		radioButtonInactiveSeeing.setActionCommand("Inactive");
		radioButtonInactiveSeeing.setName("radioButtonInactiveSeeing");
		radioButtonInactiveSeeing.setText("Inactive");
		buttongroupSeeing.add(radioButtonInactiveSeeing);
		
		gridBagConstraints = OrangGUICommon.getGridBagConstraints(1, 1, GridBagConstraints.WEST,1,5,0,0);          
		add(radioButtonInactiveSeeing, gridBagConstraints);
		
		radioButtonActiveSeeing.setActionCommand("Active");
		radioButtonActiveSeeing.setName("radioButtonActiveSeeing");
		radioButtonActiveSeeing.setText("Active");
		buttongroupSeeing.add(radioButtonActiveSeeing);
		gridBagConstraints = OrangGUICommon.getGridBagConstraints(2, 1, GridBagConstraints.WEST,1,5,0,0);     
		add(radioButtonActiveSeeing, gridBagConstraints);
		
		textFieldSeeing.setName("textFieldSeeing");
		textFieldSeeing.setColumns(15);
		gridBagConstraints = OrangGUICommon.getGridBagConstraints(3, 1, GridBagConstraints.WEST,1,5,0,0);      
		add(textFieldSeeing, gridBagConstraints);
		
		
		labelSkyTransparency.setName("labelSkyTransparency");
		labelSkyTransparency.setText("Sky transparency");
		gridBagConstraints = OrangGUICommon.getGridBagConstraints(0, 2, GridBagConstraints.WEST,1,5,0,0);      
		add(labelSkyTransparency, gridBagConstraints);      
		
		radioButtonInactiveSky.setActionCommand("Inactive");
		radioButtonInactiveSky.setName("radioButtonInactiveSky");
		radioButtonInactiveSky.setText("Inactive");
		buttongroupSky.add(radioButtonInactiveSky);
		gridBagConstraints = OrangGUICommon.getGridBagConstraints(1, 2, GridBagConstraints.WEST,1,5,0,0);    
		add(radioButtonInactiveSky, gridBagConstraints);
		
		radioButtonActiveSky.setActionCommand("Active");
		radioButtonActiveSky.setName("radioButtonActiveSky");
		radioButtonActiveSky.setText("Active");
		buttongroupSky.add(radioButtonActiveSky);
		gridBagConstraints = OrangGUICommon.getGridBagConstraints(2, 2, GridBagConstraints.WEST,1,5,0,0);     
		add(radioButtonActiveSky, gridBagConstraints);
		
		comboFieldSkyTransparency.setName("comboFieldSkyTransparency");
		gridBagConstraints = OrangGUICommon.getGridBagConstraints(3, 2, GridBagConstraints.WEST,1,5,0,0);        
		add(comboFieldSkyTransparency, gridBagConstraints);

        //****************************************Wind
        labelWind.setName("labelWind");
        labelWind.setText("Wind direction");
        labelWind.setToolTipText("The Wind direction is between -180 and 180 degrees");       
        gridBagConstraints = OrangGUICommon.getGridBagConstraints(0, 3, GridBagConstraints.WEST,1,5,0,0);               
        add(labelWind, gridBagConstraints);
        
        
        radioButtonInactiveWind.setActionCommand("Inactive");
        radioButtonInactiveWind.setName("radioButtonInactiveWind");
        radioButtonInactiveWind.setText("Inactive");
        buttongroupWind.add(radioButtonInactiveWind);
        
        gridBagConstraints = OrangGUICommon.getGridBagConstraints(1, 3, GridBagConstraints.WEST,1,5,0,0);          
        add(radioButtonInactiveWind, gridBagConstraints);
        
        radioButtonActiveWind.setActionCommand("Active");
        radioButtonActiveWind.setName("radioButtonActiveWind");
        radioButtonActiveWind.setText("Active");
        buttongroupWind.add(radioButtonActiveWind);
        gridBagConstraints = OrangGUICommon.getGridBagConstraints(2, 3, GridBagConstraints.WEST,1,5,0,0);     
        add(radioButtonActiveWind, gridBagConstraints);
        
        textFieldWind.setName("textFieldWind");
        textFieldWind.setColumns(15);
        gridBagConstraints = OrangGUICommon.getGridBagConstraints(3, 3, GridBagConstraints.WEST,1,5,0,0);      
        add(textFieldWind, gridBagConstraints);
        
		
        
        //*********************
        
        
        
        radioButtonActiveSeeing.setSelected(true);
        radioButtonInactiveWind.setSelected(true);
	    radioButtonActiveSky.setSelected(true);
        radioButtonActiveSeeing.doClick();
        radioButtonInactiveWind.doClick();
	    radioButtonActiveSky.doClick();

	}

	protected boolean isReady() {
	
		valString = new String();
		
        boolean seeingOk = false;
        boolean windOk = false;
	    boolean skyOk = false;
	      
        if (radioButtonInactiveSeeing
                .isSelected()) {
            seeingOk = true;
        } else { // seeing value to be entered
            if (Seeing.isValidSeeing(textFieldSeeing.getText())) {
                seeingOk = true;
            }
        } 
        if (radioButtonInactiveWind
                .isSelected()) {
            windOk = true;
        } else { // wind value to be entered
            if (WindInfo.isValidWind(textFieldWind.getText())) {
                windOk = true;
            }
        } 
        
	    if (radioButtonInactiveSky
	            .isSelected()) {
	        skyOk = true;
	    } else { // seeing value to be entered
	        if (SkyTransparency
	                .isValidSky((String) comboFieldSkyTransparency
	                        .getSelectedItem())) {
	            skyOk = true;
	        }
	    }
	    
        if (!seeingOk) {
            valString = valString + "\n Invalid seeing.";

        }    
        if (!windOk) {
            valString = valString + "\n Invalid wind direction. The value must be an integer between -180 and 180";

        }
	    
	    if (!skyOk) {
			valString = valString + "\n Invalid sky transparency.";

		}
	    
	    boolean result = seeingOk && skyOk && windOk;
	    return result;
	}	


	public JComboBox getComboFieldSkyTransparency() {
		return comboFieldSkyTransparency;
	}

    public JRadioButton getRadioButtonActiveSeeing() {
        return radioButtonActiveSeeing;
    }

    public JRadioButton getRadioButtonActiveWind() {
        return radioButtonActiveWind;
    }

	public JRadioButton getRadioButtonActiveSky() {
		return radioButtonActiveSky;
	}

    public JRadioButton getRadioButtonInactiveSeeing() {
        return radioButtonInactiveSeeing;
    }
    public JRadioButton getRadioButtonInactiveWind() {
        return radioButtonInactiveWind;
    }

	public JRadioButton getRadioButtonInactiveSky() {
		return radioButtonInactiveSky;
	}

    public JTextField getTextFieldSeeing() {
        return textFieldSeeing;
    }
    public JTextField getTextFieldWind() {
        return textFieldWind;
    }
    
	public void initData( OrangWidgetsData defaultData) {
		String[] skyTranspList = defaultData.getSkyTranspList();
	    getComboFieldSkyTransparency()
	            .setRenderer(new SkyTransparencyCellRenderer());
	    Utilities.addItems(getComboFieldSkyTransparency(), skyTranspList);
	}

	/**
	 * Assigns the current gui state to the model properties 
	 * 
	 * @param model
	 */
	public void updateModel(OrangModel model) {
        
        boolean seeingActive = radioButtonActiveSeeing.isSelected();
        model.setSeeingEnabled(seeingActive);
        
        boolean windActive = radioButtonActiveWind.isSelected();
        model.setWindEnabled(windActive);
    	
		boolean skyTranspEnabled = radioButtonActiveSky.isSelected();
		model.setSkyTranspEnabled(skyTranspEnabled);
        
		String seeing;
        if (seeingActive) {
        	seeing = textFieldSeeing.getText();
        } else {        		        	
        	seeing =  new Double(Seeing.MIN_SEEING).toString();
        }
        model.setSeeing(seeing);
        
        
        String wind = textFieldWind.getText();
        if (WindInfo.isValidWind(wind)) {
        	model.setWind(Integer.parseInt(wind));
        }
        

		String skyTransp; 
			
		if (skyTranspEnabled) {
			skyTransp = (String)comboFieldSkyTransparency.getSelectedItem();
		} else {
			skyTransp = SkyTransparency.PHOTOMETRIC;
		}
		model.setSkyTransp(skyTransp);		
		
	}
	
	public String getValidationString() {
		if ( valString != null ) 
			return valString;
		else
			return "";
			
	}

}
