package org.eso.ohs.phase2.apps.ot.wizard;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Font;
import java.awt.GridBagConstraints;
import java.awt.Insets;

import javax.swing.ImageIcon;
import javax.swing.JLabel;
import javax.swing.JPanel;

import com.jeta.forms.components.image.ImageComponent;

public class OrangGUICommon {
    
        
	public static final String COMBO_BOX_INSTRUMENT = "comboBoxInstrument";
	public static final String COMBO_BOX_ALGORITHM = "comboBoxAlgorithm";
	public static final String SPINNER_TOLERANCE_AIRMASS = "spinnerToleranceAirmass";
	public static final String SPINNER_TOLERANCE_MOON_ANGLE = "spinnerToleranceMoonAngle";
	public static final String SPINNER_TOLERANCE_MOON_DISTANCE = "spinnerToleranceMoonDistance";
	public static final String SPINNER_TOLERANCE_FLI = "spinnerToleranceFLI";
	public static final String SPINNER_TOLERANCE_SUN_ANGLE = "spinnerToleranceSunAngle";
	public static final String INACTIVE = "Inactive";
	public static final String ACTIVE = "Active";
	public static final String BUTTONGROUP_FLI = "buttongroupFli";
	public static final String BUTTONGROUP_MOON_D = "buttongroupMoonD";
	public static final String BUTTONGROUP_SUN = "buttongroupSun";
	public static final String BUTTONGROUP_MOON_A = "buttongroupMoonA";
	public static final String BUTTONGROUP_SID_TIME = "buttongroupSidTime";
	public static final String BUTTONGROUP_TIME_INT = "buttongroupTimeInt";
	public static final String BUTTONGROUP_SKY = "buttongroupSky";
    public static final String BUTTONGROUP_SEEING = "buttongroupSeeing";
    public static final String BUTTONGROUP_WIND = "buttongroupWind";
	public static final String BUTTONGROUP_STREHL = "buttongroupStrehl";
    public static final String FIELD_SEEING = "textFieldSeeing";
    public static final String FIELD_WIND = "textFieldWind";
	public static final String FIELD_SKY_TRANSPARENCY = "comboFieldSkyTransparency";
	public static final String FIELD_STREHL_RATIO = "textFieldStrehlRatio";
	public static final String TELESCOPE_QUEUES_COMMAND = "Telescope today queues";
	public static final String INSTRUMENT_QUEUES_COMMAND = "Instrument today queues";
	public static final String QUEUES_COMMAND = "Queues";
	public static final String COMBO_BOX_TELESCOPE = "comboBoxTelescope";
	public static final String COMBO_BOX_QUEUES = "comboBoxQueues";
	public static final String OB_SELECTION_GROUP = "obSelectionGroup";
	public static final String DATE_START = "startTimeTextField";
	public static final String DURATION = "durationComboBox";
	public static final String STEP_INTERVAL = "stepComboBox";
	public static final String LIST_BOX_QUEUES = "listBoxQueues";
	public static final String TIMELINE_ALGORITHM = "cbTimelineAlgorithm";
	public static final String BUTTONGROUP_ZENITH = "zenithSelectionGroup";
	
	
	public static JPanel getWizardTitlePanel(String titleText) {
		
		// top panel
		String title = "ORANG Wizard";
								
		JPanel top = getTopPanel(title);
		
		//bottom panel
		JPanel bottom = new JPanel();
		
		JLabel labelPageTitle = new JLabel();
		labelPageTitle.setFont(new Font("sansserif", Font.ITALIC, 11));
	    labelPageTitle.setName("labelPageTitle");
	    labelPageTitle.setText(titleText);	    
	    bottom.add(labelPageTitle);
		
	    
	    // put them together
	    
	    JPanel panel = new JPanel(new BorderLayout());
	    panel.add(top,BorderLayout.NORTH);
	    panel.add(bottom,BorderLayout.WEST);
	    

		return panel;
	}

	private static JPanel getTopPanel(String title) {
		JPanel top = new JPanel();
		
		JLabel labelTitle = new JLabel();
		ImageComponent orange = new ImageComponent();
		
		BorderLayout layout = new BorderLayout();

		top.setLayout(layout);

		orange.setIcon(loadImage("orangeSmall.gif"));
		orange.setName("orange");
		top.add(orange, BorderLayout.WEST);

		labelTitle.setBackground(new Color(255, 255, 255));
		labelTitle.setFont(new Font("sansserif", Font.BOLD, 18));
		labelTitle.setName("labelTitle");
		labelTitle.setText(title);
		top.add(labelTitle, BorderLayout.CENTER);

		top.setOpaque(true);
		top.setBackground(Color.WHITE);
		return top;
	}
	
	public static JPanel getOrangTitlePanel() {
		String title = "ORANG";
		
		JPanel panel = getTopPanel(title);
		
		return panel;
	}

	

    /**
	 * Helper method to load an image file from the CLASSPATH
	 * 
	 * @param imageName
	 *            the package and name of the file to load relative to the
	 *            CLASSPATH
	 * @return an ImageIcon instance with the specified image file
	 * @throws IllegalArgumentException
	 *             if the image resource cannot be loaded.
	 */
    private static ImageIcon loadImage(String imageName) {
        String imagePath = "org/eso/ohs/icons/"+imageName;
        try {
        	OrangGUICommon guiCommon = new OrangGUICommon();
            ClassLoader classloader = guiCommon.getClass().getClassLoader();
            java.net.URL url = classloader.getResource(imagePath);
            if (url != null) {
                ImageIcon icon = new ImageIcon(url);
                return icon;
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
        throw new IllegalArgumentException("Unable to load image: " + imagePath);
    }
    
    public static GridBagConstraints getGridBagConstraints(int x, int y, int anchor,
    		int insetTop, int insetLeft, int insetBottom, int InsetRight) {
    	GridBagConstraints gridBagConstraints = new GridBagConstraints();
    	gridBagConstraints.gridx = x;
    	gridBagConstraints.gridy = y;
    	gridBagConstraints.anchor = anchor;
    	gridBagConstraints.insets = new Insets(insetTop, insetLeft, insetBottom, InsetRight);    	
    	return gridBagConstraints;
	}
        
    
    
    
	public OrangGUICommon() {
        super();
    }

}
