package org.eso.ohs.phase2.apps.ot.wizard;

import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;

import javax.swing.JComboBox;
import javax.swing.JLabel;
import javax.swing.JPanel;

import org.eso.ohs.phase2.orang.OrangModel;


/**
 * 
 * Timeline panel,  allows the user to compute and show a timeline
 * based on the current list of visible OBs
 * @author pnunes
 *
 */
public class TimelinePanel extends JPanel {

    private JLabel labelAlgorithm = new JLabel();
    private JComboBox cbTimelineAlgorithm = new JComboBox();
	private String valString;
        
    
    
    public TimelinePanel () {
    	createPanel();
    }
    
    public JPanel createPanel() {

    	GridBagLayout layout = new GridBagLayout();
        setLayout( layout );
        
        GridBagConstraints gridBagConstraints ;        	   

        labelAlgorithm.setName( "labelAlgorithm" );
        labelAlgorithm.setText( "Algorithm" );
        
        gridBagConstraints = OrangGUICommon.getGridBagConstraints(0, 1, GridBagConstraints.WEST,1,5,0,0);
        add( labelAlgorithm, gridBagConstraints );

        cbTimelineAlgorithm.setName( OrangGUICommon.TIMELINE_ALGORITHM );
        gridBagConstraints = OrangGUICommon.getGridBagConstraints(1, 1, GridBagConstraints.WEST,1,5,0,0);
        add( cbTimelineAlgorithm, gridBagConstraints );

        return this;
    }


    public void initData() {
		// We hard-code here the list of algorithms
        // (for the time being...)
        String[] algoritmList = new String[1];
        algoritmList[0] = "Early-greedy";
        for( int i = 0; i < algoritmList.length; i++ ) {
        	getCbTimelineAlgorithm().addItem( algoritmList[i] );
        }
	}
    
	public JComboBox getCbTimelineAlgorithm() {
		return cbTimelineAlgorithm;
	}

	public void updateModel(OrangModel model) {
		String algorithm = (String)cbTimelineAlgorithm.getSelectedItem();
		model.setTimelineAlgorithm(algorithm);
		
	}

	protected boolean isReady() { 
        if ( cbTimelineAlgorithm.getSelectedIndex()< 0) {
           	valString = "\nNo algorithm selected.";
           	return(false);
           	
        } else {
        	return(true);
        }
    }
	
	public String getValidationString() {
		if ( valString != null ) 
			return valString;
		else
			return "";
			
	}

}
