package org.eso.ohs.phase2.apps.p2pp.actions;

import java.awt.event.ActionEvent;

import javax.swing.JFrame;
import javax.swing.JOptionPane;

import org.apache.log4j.Logger;
import org.eso.ohs.core.gui.baseaction.ActionSuperclass;
import org.eso.ohs.dfs.FindingChart;
import org.eso.ohs.dfs.ObservationBlock;
import org.eso.ohs.persistence.ObjectSelector;

/**
 * @author tcanavan
 *
 * To change this generated comment edit the template variable "typecomment":
 * Window>Preferences>Java>Templates.
 * To enable and disable the creation of type comments go to
 * Window>Preferences>Java>Code Generation.
 */
public class ClearFindingCharts extends ActionSuperclass {

    private static Logger stdlog_ =
        Logger.getLogger(ClearFindingCharts.class);

    /**  
      * Static reference to file chooser dialog
      */

    private ObjectSelector objSelector_;

    /**
     * Construct an AttachFindingCharts action.
     * 
     * @param device      medium containing the parent directy.
     * @param  folderView  GUI view of (summary information in) the folder
     */

    public ClearFindingCharts(ObjectSelector objSelector) {
        super((JFrame) objSelector, "Clear Finding Chart");
        objSelector_ = objSelector;
    }
    /**
     * @see org.eso.ohs.core.gui.baseaction.ActionSuperclass#actionPerformedImpl(java.awt.event.ActionEvent)
     */
    public void actionPerformedImpl(ActionEvent ev) {

        ObservationBlock ob =
            (ObservationBlock) objSelector_.getDisplayedObject();
            
        int option =
            JOptionPane.showConfirmDialog(
                (JFrame)objSelector_,
                "Are you sure you wish to clear the finding chart for this OB ?",
                "Clear",
                JOptionPane.OK_CANCEL_OPTION,
                JOptionPane.QUESTION_MESSAGE,
                null);

        switch (option) {
            case JOptionPane.CLOSED_OPTION :
                return;
            case JOptionPane.CANCEL_OPTION :
                return;
        }
            
            
        FindingChart[] fcCharts = ob.getFindingCharts();
        if (fcCharts == null || fcCharts.length == 0) {
            JOptionPane.showMessageDialog(
                (JFrame) objSelector_,
                new Object[] { "There are no finding charts to be detached." },
                "Finding Charts not found",
                JOptionPane.ERROR_MESSAGE);
            return;

        }

        ob.setFindingCharts(null);
    }
}