package org.eso.ohs.phase2.apps.p2pp.actions;

import java.awt.event.ActionEvent;

import javax.swing.JComponent;

import org.eso.ohs.core.gui.baseaction.ActionSuperclass;
import org.eso.ohs.persistence.ObjectContainer;

/**
 * Action class to create a business object in the chosen directory.
 * 
 * <p>
 * $Id: SelectAllAction.java,v 1.5 2005/02/11 10:31:49 tcanavan Exp $
 */

public class SelectAllAction extends ActionSuperclass {
    /** view of the folder in which the OB is to be created */
    ObjectContainer folderView_;


    /**
     * Constructs a create BusinessObject action.
     * 
     * @param device      medium containing the parent directory.
     * @param folderView  GUI view of (summary information in) the folder.
     */
    public SelectAllAction(ObjectContainer folderView) {
	super((JComponent)folderView, "Select All");

	folderView_ = folderView;
    }

    /**
     * Event handler for the create BusinessObject action.
     * 
     * @param ev       user-initiated ActionEvent to create an OD.
     */
    public void actionPerformedImpl(ActionEvent ev) {      
	folderView_.selectAllObjects();
    }

}

