package org.eso.ohs.phase2.apps.p2pp.actions;

import java.awt.event.ActionEvent;

import javax.swing.JFrame;
import javax.swing.JOptionPane;

import org.apache.log4j.Logger;
import org.eso.ohs.core.gui.baseaction.ActionSuperclass;
import org.eso.ohs.core.utilities.ObjectIOException;
import org.eso.ohs.persistence.Media;
import org.eso.ohs.persistence.OHSApplication;
import org.eso.ohs.phase2.apps.p2pp.DbaseWindow;
import org.eso.ohs.phase2.apps.p2pp.MainWindow;
import org.eso.ohs.phase2.apps.p2pp.P2PP;

/**
 * Action class to display the contents of the database.
 * <br>
 * @author Bob Kemp
 * @version $Revision: 1.10.4.1 $
 */
public class ShowDbaseAction extends ActionSuperclass {

    public static final String cvsID_ = "$Id: ShowDbaseAction.java,v 1.10.4.1 2007/07/20 11:58:33 pnunes Exp $";

    private static Logger stdlog_ = Logger.getLogger(ShowDbaseAction.class);

    /**
     * Constructs a ShowDbaseAction action.
     */
    public ShowDbaseAction(MainWindow mwdw) {
        //super(mwdw, "View ESO Database");
        super(mwdw, "Check-out...");
    }

    /**
     * Event handler for the ShowDbaseAction action.
     *
     * @param ev       user-initiated ActionEvent to quit.
     */
    public void actionPerformedImpl(ActionEvent evt) {

        if (!OHSApplication.ensureAuthenticated()) {
            return;
        }

        try {
            JFrame frame = DbaseWindow.getDbaseWindow(Media.DBASE);
            P2PP.setScreenSize(frame);
            frame.setVisible(true);
        } catch (ObjectIOException e) {
            // announceIOError(e);
            stdlog_.error(e);
            JOptionPane.showMessageDialog(
                null,
                new Object[] {
                    "Your objects in the ESO database could not be displayed.",
                    "This is usually because the server at ESO"
                        + " cannot be contacted"
                        + " for some reason.",
                    " ",
                    "Check your Internet connection to ESO" + " and try again.",
                    "If error persists, contact ESO User Support.",
                    },
                "Connection Error",
                JOptionPane.WARNING_MESSAGE);
        }
    }
}

