package org.eso.ohs.phase2.apps.p2pp.dbb;

import org.eso.ohs.core.dbb.client.Coordinate;

/**
 *  A transducer to convert set/get of String values into set/get
 *  on an int property.  The target property's name is given to the
 *  constructor.
 *
 *  <p>
 *  For example, users will call it's
 *  setValue/getValue methods.  Those calls will be translated into
 *  calls to setX/getX on the object given to the constructor.
 *
 *  <p>
 * $Id: Declination.java,v 1.6 2005/04/11 13:53:44 tcanavan Exp $
 */

public class Declination extends Coordinate {

  public void checkBounds(int sign, int hours, int minutes,
			  int seconds, int milliSecs) {
    if (hours > 90 || minutes >= 60
	|| seconds >= 60 || milliSecs >= 1000) {
      throw new IllegalArgumentException("Illegal time value");
    }
    if (hours == 90 && (minutes != 0 || seconds != 0 || milliSecs != 0)) {
        throw new IllegalArgumentException("Illegal time value");
    }
  }

}

