package org.eso.ohs.phase2.apps.p2pp.views;

import java.awt.BorderLayout;
import java.awt.Dimension;
import java.awt.GridLayout;
import java.beans.PropertyChangeEvent;
import java.beans.PropertyChangeListener;
import java.util.HashMap;
import java.util.Iterator;
import java.util.Set;

import javax.swing.JComboBox;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JTextField;

import org.eso.ohs.core.docview.gui.DocView;
import org.eso.ohs.core.gui.models.BoNameModel;
import org.eso.ohs.core.gui.models.FloatRangeModel;
import org.eso.ohs.core.gui.models.IntRangeModel;
import org.eso.ohs.dfs.BusinessObject;
import org.eso.ohs.dfs.ConstraintSet;
import org.eso.ohs.instruments.Instrument;
import org.eso.ohs.instruments.InstrumentConstraintConfig;
import org.eso.ohs.instruments.InstrumentConstraintMetaData;
import org.eso.ohs.instruments.InstrumentList;
import org.eso.ohs.persistence.Config;

/**
 * This is a specialised JPanel with subcomponents linked to the
 * given Target object's fields.  When this component is
 * displayed, changes to it will be reflected in the Target
 * object.  Likewise changes to the Target object will be
 * reflected in the displayed fields.  Some fields of an Target
 * may not be visible.  Some fields may not be modifiable.
 * 
 * <p>
 * $Id: CSView.java,v 1.13 2006/04/27 13:25:00 pnunes Exp $
 * <br>
 * @author Bob Kemp
 */

public class CSView extends ObjectView implements PropertyChangeListener {

    /** ObservationDescription currently being displayed, or null */
    private ConstraintSet currentCS_;

    /* GUI component for the Name field */
    private DocView fieldName_;

    /* GUI component for the Sky transparency */
    private DocView fieldSkyTransparency_;

    /* GUI component for Air Mass */
    private DocView fieldAirmass_;

    /* GUI component for Fractional Lunar Illumination */
    private DocView fieldFLI_;

    /* GUI component for Moon Angular Distance*/
    private DocView fieldMoonAngularDistance_;

    /* GUI component for fieldSeeing*/
    private DocView fieldSeeing_;

    /* GUI component for field Telescope Temperature*/
    private DocView fieldTelTemp_;

    /* GUI component for field Strehl Ratio */
    private DocView fieldStrehlRatio_;

    private boolean createGUI = false;

    private JPanel leftCol1;

    private JPanel leftCol2;

    private JPanel rightCol1;

    private JPanel rightCol2;

    private HashMap<String, DocView> docViewList = new HashMap<String, DocView>();
    
    
    private String instrument_;
    
    private float ipVersion_=0;

    /**
     * Construct the JPanel and add the subcomponents and listeners, etc.
     * Some fields of an CS may not be visible.
     * Some fields may not be modifiable.
     * 
     * <p> Initially, no CS is displayed.
     */
    public CSView() {
        JLabel lab;
        JComboBox gComboBox;
        JTextField tf;
        Dimension d;

        setLayout(new BorderLayout());
        GridLayout outerGrid = new GridLayout(1, 0);
        JPanel outerPanel = new JPanel(outerGrid);
        add(outerPanel, BorderLayout.NORTH);
        JPanel leftPanel = new JPanel();
        JPanel rightPanel = new JPanel();
        leftPanel.setLayout(new BorderLayout());
        rightPanel.setLayout(new BorderLayout());
        outerPanel.add(leftPanel);
        outerPanel.add(rightPanel);
        leftCol1 = new JPanel();
        leftCol2 = new JPanel();
        leftCol1.setLayout(new GridLayout(0, 1));
        leftCol2.setLayout(new GridLayout(0, 1));
        leftPanel.add(leftCol1, BorderLayout.WEST);
        leftPanel.add(leftCol2, BorderLayout.CENTER);
        rightCol1 = new JPanel();
        rightCol2 = new JPanel();
        rightCol1.setLayout(new GridLayout(0, 1));
        rightCol2.setLayout(new GridLayout(0, 1));
        rightPanel.add(rightCol1, BorderLayout.WEST);
        rightPanel.add(rightCol2, BorderLayout.CENTER);

        //        lab = new JLabel("Name: ");
        //        lab.setHorizontalAlignment(JLabel.RIGHT);
        //        leftCol1.add(lab);
        //          
        //    
        //        tf = new JTextField(Config.getCfg().getMaxNameLength());
        //        tf.setDocument(new BoNameModel());
        //        fieldName_ = new DocView(tf);     
        //        leftCol2.add(fieldName_);      
        //    
        //        lab = new JLabel("Sky Transparency: ");
        //        lab.setHorizontalAlignment(JLabel.RIGHT);
        //        leftCol1.add(lab);                     
        //        gComboBox = new JComboBox(ConstraintSet.getValidSkyTransparency());
        //        gComboBox.setSelectedIndex(0);
        //        fieldSkyTransparency_ = new DocView(gComboBox);
        //        leftCol2.add(fieldSkyTransparency_);
        //        
        //    
        //        lab = new JLabel("Seeing: ");
        //        lab.setHorizontalAlignment(JLabel.RIGHT);
        //        leftCol1.add(lab);
        //       
        //        tf = new JTextField();
        //        tf.setToolTipText(" Enter value between range : 0.2..2.0");
        //        tf.setDocument(new SeeingModel());
        //        fieldSeeing_ = new DocView(tf);
        //        //fieldSeeing_.setToolTipText();
        //        leftCol2.add(fieldSeeing_);
        //            
        //        lab = new JLabel("Airmass : ");
        //        lab.setHorizontalAlignment(JLabel.RIGHT);
        //        rightCol1.add(lab);   
        //        tf = new JTextField();
        //        tf.setDocument(new AirmassModel());
        //        tf.setToolTipText(" Enter value between range : 1.0..5.0");
        //        fieldAirmass_ = new DocView(tf);
        //        rightCol2.add(fieldAirmass_);    
        //
        //        lab = new JLabel("Lunar Illumination : ");
        //        lab.setHorizontalAlignment(JLabel.RIGHT);
        //        rightCol1.add(lab);
        //        tf = new JTextField();
        //        tf.setDocument(new FliModel());
        //        tf.setToolTipText(" Enter value between range : 0.0..1.0");
        //        fieldFLI_ = new DocView(tf);
        //        rightCol2.add(fieldFLI_);
        //
        //
        //        lab = new JLabel("Moon Angular Distance : ");
        //        lab.setHorizontalAlignment(JLabel.RIGHT);
        //        rightCol1.add(lab);
        //        tf = new JTextField();
        //        tf.setDocument(new MoonAngularModel());
        //        tf.setToolTipText(" Enter value between range : 0..180");
        //        fieldMoonAngularDistance_ = new DocView(tf);
        //        rightCol2.add(fieldMoonAngularDistance_);
        // 
        //        lab = new JLabel("Strehl R. % (NACO only) : ");
        //        lab.setHorizontalAlignment(JLabel.RIGHT);       
        //        leftCol1.add(lab);
        //       
        //        tf = new JTextField();
        //        tf.setToolTipText(" NACO Only: enter %  0.0 < ratio < 100.0");
        //        tf.setDocument(new StrehlRatioModel());
        //        fieldStrehlRatio_ = new DocView(tf);
        //        leftCol2.add(fieldStrehlRatio_);

        setEnabled(false);
        setObject(null);
    }

    /**
     * Enable or disable the fields of this panel and any nested panels.
     * 
     * @param enable    True if the fields are to be enabled, false otherwise.
     */
    public void setEnabled(boolean enable) {
        super.setEnabled(enable);
        if(fieldName_ != null)
           fieldName_.setEnabled(enable);
        Instrument inst = null;   
        InstrumentConstraintConfig[] instConfig=null;
        if(InstrumentList.getInstance() != null) {
            if(currentCS_ != null && instrument_ != null) {
                inst =
                    InstrumentList.getInstance().getInstrument(instrument_, ipVersion_);
                    instConfig = inst.getCsConfList();
                
            }
               
        }
        Set<String> set = docViewList.keySet();
        Iterator<String> iterator = set.iterator();
        while (iterator.hasNext()) {
            String property = iterator.next().toString();
            DocView item = docViewList.get(property);
            item.setEnabled(enable);
            if(inst != null) {
                for(int i=0;i<instConfig.length;i++) {
                    if(!instConfig[i].getPafKeyword().equals("None")&&
                       property.equals(instConfig[i].getName())) {
                           item.setEnabled(false);                                                  
                       }
                          
                }
                
            }
        }
    }

    /**
     * Handle a change in the property value for the associated
     * BusinessObject.  Enable or disable changes to the fields,
     * according to whether they are allowed to be modified.
     * 
     * @param ev    Property Change Event
     */
    public void propertyChange(PropertyChangeEvent ev) {
        setEnabled(isAllowedToModify(currentCS_));
    }

    /**
     * Returns a reference to the currently displayed CS.
     * 
     * @return reference to a CS.
     */
    public BusinessObject getObject() {
        return currentCS_;
    }

    /**
     * Updates the DocView components to refer to the correct CS.
     * 
     * @param newCS     ConstraintSet object to be displayed.
     */
    public void setObject(BusinessObject newCS) {
        setObject((ConstraintSet) newCS);
    }
    
    
    public void setObject(ConstraintSet cs,boolean recreateGUI,String instrument, float ipVersion) {
        if (cs == currentCS_) {
            return; // nothing to do -- just return
        }
        if(recreateGUI) {
            createGUI(cs,instrument,ipVersion);
        }
        setObject(cs);
        
    }

    /**
    * Creates a component with subcomponents linked to the
    * CS object's fields.  When the returned component is
    * displayed, changes to it will be reflected in the CS
    * object.  Some fields of a CS may not be visible.
    * Some fields may not be modifiable.
    * 
    * @param cs     CS object to be displayed.
    */
    public void setObject(ConstraintSet cs) {        
        if (currentCS_ != null) {
            currentCS_.removePropertyChangeListener(this);
            removeDocViewListeners();
        }
        currentCS_ = cs;        
        setEnabled(cs != null && !cs.isCheckedIn());
        if(currentCS_ != null) {
            fieldName_.setObjectProperty(cs, "Name");
            currentCS_.addPropertyChangeListener(this);
            currentCS_.addPropertyChangeListener(fieldName_);
            Set<String> set = docViewList.keySet();
            Iterator<String> iterator = set.iterator();
            while (iterator.hasNext()) {
                String property = iterator.next().toString();
                DocView item = docViewList.get(property);
                item.setObjectProperty(cs, property);
                currentCS_.addPropertyChangeListener(item);
            }
            fieldName_.requestFocus();
            
        }
    }

    private void removeDocViewListeners() {
        Set<String> keyList = docViewList.keySet();
        Set<String> set = docViewList.keySet();
        Iterator<String> iterator = set.iterator();
        currentCS_.removePropertyChangeListener(fieldName_);
        while (iterator.hasNext()) {
            DocView item = docViewList.get(iterator.next());
            currentCS_.removePropertyChangeListener(item);
        }
    }

    /**
     * Create the gui for the constraint sets
     * @return boolean
     */
    public boolean isCreateGUI() {
        return createGUI;
    }

    /**
     * Set the fact that the constraint gui has been
     * build
     * @param b
     */
    public void setCreateGUI(boolean b) {
        createGUI = b;
    }

    public void createGUI(ConstraintSet cs,String instrument, float ipVersion) {
        instrument_ = instrument;
        ipVersion_ = ipVersion;
        
        if (currentCS_ != null) {
            removeDocViewListeners();
        }     
            leftCol1.removeAll();
            leftCol2.removeAll();
            rightCol1.removeAll();
            rightCol2.removeAll();
            docViewList.clear();
        //}
        Instrument inst =
            InstrumentList.getInstance().getInstrument(instrument, ipVersion);
        InstrumentConstraintConfig[] instConfig = inst.getCsConfList();
        JLabel lab = new JLabel("Name: ");
        lab.setHorizontalAlignment(JLabel.RIGHT);
        leftCol1.add(lab);
        JTextField tf = new JTextField(Config.getCfg().getMaxNameLength());
        tf.setDocument(new BoNameModel());
        fieldName_ = new DocView(tf);
        leftCol2.add(fieldName_);
        for (int i = 0; i < instConfig.length; i++) {
            lab = new JLabel(instConfig[i].getLabel() + ": ");
            placeLabel(lab, i);
            InstrumentConstraintMetaData metaData = instConfig[i].getMetaData();
            String type = metaData.getBaseType();
            if (type.equals("integer")) {
                tf = new JTextField();
                int minInclusive = (int) metaData.getMinInclusive();
                int maxInclusive = (int) metaData.getMaxInclusive();
                tf.setDocument(
                    new IntRangeModel(
                        metaData.getPattern(),
                        minInclusive,
                        maxInclusive));
                tf.setToolTipText(
                    " Enter value between range : "
                        + minInclusive
                        + ".."
                        + maxInclusive);
                DocView docView = new DocView(tf);
                docViewList.put(instConfig[i].getName(), docView);
                placeComponent(i, docView);
                if(!instConfig[i].getPafKeyword().equals("none"))
                    docView.setEnabled(false);
            }
            if (type.equals("float")) {
                tf = new JTextField();
                float minInclusive = (float) metaData.getMinInclusive();
                float maxInclusive = (float) metaData.getMaxInclusive();
                tf.setDocument(
                    new FloatRangeModel(
                        metaData.getPattern(),
                        minInclusive,
                        maxInclusive));
                tf.setToolTipText(
                    " Enter value between range : "
                        + minInclusive
                        + ".."
                        + maxInclusive);
                DocView docView = new DocView(tf);
                docViewList.put(instConfig[i].getName(), docView);
                placeComponent(i, docView);
                if(!instConfig[i].getPafKeyword().equals("none"))
                    docView.setEnabled(false);

            }
            if (type.equals("string")
                && metaData.getAllowedValues().length > 1) {
                JComboBox box = new JComboBox(metaData.getAllowedValues());
                DocView docView = new DocView(box);
                docViewList.put(instConfig[i].getName(), docView);
                if(!instConfig[i].getPafKeyword().equals("none"))
                    docView.setEnabled(false);
                placeComponent(i, docView);
            }
        }

    }

    private void placeLabel(JLabel lab, int i) {
        if (i == 0) {
            rightCol1.add(lab);
        } else {
            if (i % 2 == 0)
                rightCol1.add(lab);
            else
                leftCol1.add(lab);
        }
    }

    private void placeComponent(int i, DocView docView) {
        if (i == 0) {
            rightCol2.add(docView);
        } else {
            if (i % 2 == 0)
                rightCol2.add(docView);
            else
                leftCol2.add(docView);
        }
    }
} 