#!/vlt/MAR2001/tcltk/bin/tclsh



proc Usage {} {

    puts "loadMagazine.tcl <tty> <baud rate> <A|B|C|R>"
    exit 1
}

proc checkBaudRate {baud} {

    switch $baud   { 
	"1200"     { set returnCode "ok" }
	"2400"     { set returnCode "ok" }
	"4800"     { set returnCode "ok" }
	"9600"     { set returnCode "ok" }
	"19200"    { set returnCode "ok" }
	"38400"    { set returnCode "ok" }
	"57600"    { set returnCode "ok" }
	"115200"   { set returnCode "ok" }
	"230400"   { set returnCode "ok" }
	default    { set returnCode "error"}
    }

    return $returnCode
}

proc checkArgs {} {
    global argc argv ttyPort baud control

    if {$argc != 3} { Usage }
    
    set ttyPort     [lindex $argv 0]
    set baud        [lindex $argv 1]
    set control     [lindex $argv 2]
    
    if {![file exists $ttyPort] || ![file writable $ttyPort] || \
	    ![file readable $ttyPort] } {
	puts "Port $ttyPort does not exists or is not read/writable"
	exit 1
    }
    
    if {[checkBaudRate $baud] == "error"} {
	puts "Baud rate: $baud is not supported"
	exit 1
    }
}

proc action {} {
    global ttyPort baud control

    set tty  [open $ttyPort r+]
    fconfigure $tty  -mode $baud,n,8,1
    set opSystem [exec uname]

    if {$opSystem == "HP-UX"} {
	exec stty raw $baud cs8 cread crts clocal rtsxoff ctsxon < $ttyPort
    } elseif {$opSystem == "SunOS"} {
	exec stty raw $baud cs8 cread crtscts clocal crtsxoff < $ttyPort
    } else {
	#Use the same of Solaris...for the moment...
	exec stty raw $baud cs8 cread crtscts clocal crtsxoff < $ttyPort
    }
    
    switch $control {
	"A"   {set string "04"}
	"B"   {set string "01"}
	"C"   {set string "02"}
	"R"   {set string "03"}
	default        {Usage}
	}
    set command "GTHP$string"
    puts  "Im sending: $command"
    puts  $tty "$command"
    flush $tty
    
set buffer [read $tty 3]
puts "Answer is: $buffer"


}

checkArgs
action

exit 0




