#!/bin/csh -f


set OS=`uname -s`
switch ($OS)
  case HP-UX:
    set RSH='remsh'
    breaksw
  case Linux:
    set RSH='/usr/bin/ssh'
    breaksw
  default:
    echo "Unknown OS=$OS"
    exit 1
endsw

if ( $#argv < 2 ) then
  echo "Usage: loop.sh LS|UT0|UT1|UT2|UT3|UT4|VLTI|VISTA|DFO|PARANAL command"
  echo "Usage: loop.sh OlasWSs|UserWSs|PipelineWSs|AstoWSs command"
  exit 1
endif


set remote_user
if ( "$1" == "-l" ) then
  set remote_user="-l $2"
  shift
  shift
endif

set ARG1=$1
shift

set bon =  "[1m"
set boff = "[0m"
set noglob =  1

switch (${ARG1})
   case VISTA:
      set LIST = ( wvcdhs wvcpl wvcarc )
      breaksw
   case VLTI:
      set LIST = ( wvgdhs wvgpl wvgarc )
      breaksw
   case UT0:
      set LIST = ( wu0dhs2 wg0arc wg0off2 wu0rpl wu0pl2 sagan tupi )
      breaksw
   case LS:
      set LIST = ( wg5dhs wg5pl wg5off w3p6off w3p6dhs w2p2dhs w2p2off w2p2pl )
      breaksw
   case UT1:
      set LIST = ( wu1dhs wgsoff1 wu1pl  )
      breaksw
   case UT2:
      set LIST = ( wu2dhs wgsoff2 wu2pl  )
      breaksw
   case UT3:
      set LIST = ( wu3dhs wgsoff3 wu3pl  )
      breaksw
   case UT4:
      set LIST = ( wu4dhs wgsoff4 wu4pl  )
      breaksw
   case AstoWSs:
      set LIST = ( wgsarc1 wgsarc2 )
      breaksw
   case OlasWSs:
      set LIST = ( wu1dhs wu2dhs wu3dhs wu4dhs wvgdhs wvcdhs )
      breaksw
   case OlasLSs:
      set LIST = ( wg5dhs w2p2dhs w3p6dhs )
      breaksw
   case PipelineWSs:
      set LIST = ( wu1pl wu2pl wu3pl wu4pl wvgpl wvcpl)
      breaksw
   case PipelineLSs:
      set LIST = ( wg5pl w2p2pl )
      breaksw
   case UserWSs:
      set LIST = ( wgsoff1 wgsoff2 wgsoff3 wgsoff4 wvgoff )
      breaksw
   case UserLSs:
      set LIST = ( wg5off w2p2off w3p6off )
      breaksw
   case DFO:
      set LIST = ( dfo21 dfo22 dfo23 dfo24 dfo25 dfo26 dfo27 dfo28 dfo29 dfo30 dfo31 dfo32 dfo33 )
      breaksw
   case PARANAL:
      set LIST = ( wu1dhs wu1pl wgsoff1 wu2dhs wu2pl wgsoff2 wu3dhs wu3pl wgsoff3 wgsoff3 wu4dhs wu4pl wgsoff4 wvgdhs wvgpl wvgoff wvcdhs wvcpl wvcoff wgsarc1 wgsarc2)
      breaksw
   default:
      echo "Usage: loop.sh LS|UT0|UT1|UT2|UT3|UT4|VLTI|VISTA|DFO|PARANAL command"
      echo "Usage: loop.sh OlasWSs|UserWSs|PipelineWSs|AstoWSs command"
      exit 1
endsw

foreach machine (${LIST})
	echo "$bon$machine $boff"
	$RSH $machine $remote_user -n $*
end
