#!/bin/bash 
#
# $Id: arControl.sh,v 1.1 2008/09/30 08:21:54 cguirao Exp $
#
# dataTransfer.sh: starts/stops Archive Replicator processes
#
# chkconfig: 2345 95 05
#
# description: Starts and stops the Archive Replicator daemons
#
# processname: ArchiveReplicator bbcp
#

# Source function library.

OWNER=XXXXXX

#
# Check the OWNER user exist 
#
id $OWNER > /dev/null
if [ $? -ne 0 ]; then  
  exit 1
fi

# Source function library.
. /etc/rc.d/init.d/functions 


RETVAL=0

start() {
        echo -n $"Starting Archive Replicator: "
	daemon --user $OWNER arControl start
        RETVAL=$?
        echo
        [ $RETVAL -eq 0 ] && touch /var/lock/subsys/ArchiveReplicator
        return $RETVAL
}

stop() {
        echo -n $"Shutting down Archive Replicator: "
	daemon --user $OWNER arControl stop
        RETVAL=$?
        echo
	[ $RETVAL -eq 0 ] && rm -f /var/lock/subsys/ArchiveReplicator
        return $RETVAL
}


# See how we were called.
case "$1" in
  start)
	start
	;;
  stop)
	stop
	;;
  status)
	status ArchiveReplicator
	;;
  restart)
	stop
	start
	;;
  *)
	echo "Usage: $0 {start|stop|status|restart}"
	exit 1
esac

exit $RETVAL
