#!/bin/bash 
#
# $Id: dataTransfer.sh,v 1.2 2008/05/27 08:47:15 cguirao Exp $
#
# dataTransfer.sh: starts/stops Data Transfer processes
#
# chkconfig: 2345 95 05
#
# description: Starts and stops the Data Transfer daemons
#
# processname: dhsSubscribe, ADO, DTS, NTS and AR 
#

# Source function library.

OWNER=XXXXXX

#
# Check the OWNER user exist 
#
id $OWNER > /dev/null
if [ $? -ne 0 ]; then  
  exit 1
fi

# Source function library.
. /etc/rc.d/init.d/functions 


RETVAL=0

start() {
        echo -n $"Starting dataTransfer: "
	daemon --user $OWNER datatransferControl start
        RETVAL=$?
        echo
        [ $RETVAL -eq 0 ] && touch /var/lock/subsys/dataTransfer
        return $RETVAL
}

stop() {
        echo -n $"Shutting down dataTransfer: "
	daemon --user $OWNER datatransferControl stop
        RETVAL=$?
        echo
	[ $RETVAL -eq 0 ] && rm -f /var/lock/subsys/dataTransfer
        return $RETVAL
}


# See how we were called.
case "$1" in
  start)
	start
	;;
  stop)
	stop
	;;
  status)
	status dhsSubcribe
	status ArchiveDataOrganizer
	status NetworkTransferScheduler
	status ArchiveReplicator
	status DiskTransferScheduler
        status watchdog-DhsSubscribe

	;;
  restart)
	stop
	start
	;;
  *)
	echo "Usage: $0 {start|stop|status|restart}"
	exit 1
esac

exit $RETVAL
