// -*-c++-*-
#ifndef _ArcDbConnect_h_
#define _ArcDbConnect_h_

/*
 * E.S.O. - VLT project/ESO Archive
 *
 * $Id: ArcDbConnect.h,v 1.2 2004/10/26 15:23:53 nferguso Exp $
 *
 * ArcDbconnect.h - class definitions for class ArcDbConnect, a generic class 
 * for connecting to the database reading a connection file
 *
 * who                  when       what
 * -------------------  --------   ----------------------------------------
 * Elisabetta Angeloni  26 Jan 98  Created
 */

extern "C" int   stdecrypt( char *inbuf, char *outbuf );

#include <stdlib.h>
#include <stcrypt.h>
#include <sybconnection.h>
#include "DfsCString.h"
#include "DfsTValSlist.h"

// Class internal to the ORO library used for connecting to the database
// by reading the connection keyword(Server, database, user, password) from
// a file
class ArcDbConnect{
    
public: 
    
    DfsCString dbServer_; // Sybase Server
    DfsCString dbName_;   // Database name
    DfsCString dbUser_;   // User name
    DfsCString dbPasswd_; // User password
    
    int connect(DfsCString dbAlias, SybaseConnection& Dbase, DfsCString& errorMsg);
    
    int connect(DfsCString dbUser, DfsCString dbPasswd,
		DfsCString dbServer, DfsCString dbName,
		SybaseConnection& Dbase, DfsCString& errorMsg);
    
}; // end of definition of class ArcDbConnect

typedef DfsTValSlist<ArcDbConnect> ArcConnectList;

#endif /* _ArcDbConnect_h_ */
