// -*-c++-*-

//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// COPYRIGHT (c) European Southern Observatory
// LICENSE:   ESO internal use only
//
// PROJECT:   VLT Data Flow System
// AUTHOR:    C.Moins - ESO/SDD/DFS
// SUBSYSTEM: DFS Archive System
//
// $Name: arcsys-1_2_8 $
// $Revision: 1.2 $
//
//-----------------------------------------------------------------------------

#ifndef FILE_COPY_H
#define FILE_COPY_H
#include "RawDataProduct.h"

using namespace std;

/// Namespace storing file copy operations
/**
 * Namespace providing file copy operations.
 */
namespace DPPackerCopy
{
  
  ///\brief Performs a local or remote file copy in a local or remote directory
  /**
   * \param destHost host where the machine shall be copied
   * \param destDir directory where the file shall be stored
   * \param pdataFile file to be copied
   * return 0 if the operation was successful, -1 otherwise
  */
  int copyFile(string destHost,
	       string destDir,
	       RawDataProduct::pRawDataProduct pdataFile );
}

#endif // FILE_COPY_H
