// -*-c++-*-

//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// COPYRIGHT (c) European Southern Observatory
// LICENSE:   ESO internal use only
// 
// PROJECT:   VLT Data Flow System
// AUTHOR:    Christophe Moins- ESO/DMD/DFS
// SUBSYSTEM: arcsys - Archive Systems
//
// $Revision: 1.1 $
// $Log: ReplicationAgentServiceStub.h,v $
// Revision 1.1  2006/12/19 14:05:06  cmoins
// adding of a stub class to perform offline tests
//
// Revision 1.3  2006/12/18 14:46:18  cmoins
// Management of the database connection at the service layer
//
// Revision 1.2  2006/12/14 14:00:30  cmoins
// cvs header adding
//
//
// Stub Data access service layer to NgasFile and ReplicationRequest objects
// 
//------------------------------------------------------------------------------

#ifndef REPLICATION_AGENT_SERVICE_SYB_H
#define REPLICATION_AGENT_SERVICE_SYB_H

#include "ReplicationAgentService.h"
#include "NgasFileDAOStub.h"
#include "ReplicationRequestDAOStub.h"
#include "ServiceConnectionStub.h"

/// Stub Data access service layer to NgasFile and ReplicationRequest objects
/**
 * The goal of this class is to perform coordinated actions on NgasFile 
 * and ReplicationRequest objects independently from the database
 */
typedef ReplicationAgentService<NgasFileDAOStub,ReplicationRequestDAOStub,
                                ServiceConnectionStub> ReplicationAgentServiceStub;

#endif //REPLICATION_AGENT_SERVICE_SYB_H
