// -*-c++-*-

//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// COPYRIGHT (c) European Southern Observatory
// LICENSE:   ESO internal use only
// 
// PROJECT:   VLT Data Flow System
// AUTHOR:    Christophe Moins- ESO/DMD/DFS
// SUBSYSTEM: arcsys - Archive Systems
//
// $Revision: 1.3 $
// $Log: ReplicationAgentServiceSyb.h,v $
// Revision 1.3  2006/12/18 14:46:18  cmoins
// Management of the database connection at the service layer
//
// Revision 1.2  2006/12/14 14:00:30  cmoins
// cvs header adding
//
//
// Sybase Data access service layer to NgasFile and ReplicationRequest objects
// 
//------------------------------------------------------------------------------

#ifndef REPLICATION_AGENT_SERVICE_SYB_H
#define REPLICATION_AGENT_SERVICE_SYB_H

#include "ReplicationAgentService.h"
#include "NgasFileDAOSyb.h"
#include "ReplicationRequestDAOSyb.h"
#include "ServiceConnectionSyb.h"

/// Sybase Data access service layer to NgasFile and ReplicationRequest objects
/**
 * The goal of this class is to perform coordinated actions on NgasFile 
 * and ReplicationRequest objects stored in a sybase repository
 */
typedef ReplicationAgentService<NgasFileDAOSyb,ReplicationRequestDAOSyb,
                                ServiceConnectionSyb> ReplicationAgentServiceSyb;

#endif //REPLICATION_AGENT_SERVICE_SYB_H
