// -*-c++-*-

//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// COPYRIGHT (c) European Southern Observatory
// LICENSE:   ESO internal use only
// 
// PROJECT:   VLT Data Flow System
// AUTHOR:    Christophe Moins- ESO/DMD/DFS
// SUBSYSTEM: arcsys - Archive Systems
//
// $Revision: 1.3 $
// $Log: StorageServiceSyb.h,v $
// Revision 1.3  2007/07/05 09:19:31  cmoins
// DFS04059 : adding of MediaTypeDAO as a template parameter
//
// Revision 1.2  2007/04/27 15:42:20  cmoins
// use of MediaActionDAO
//
// Revision 1.1  2007/04/25 15:20:48  cmoins
// creation of a sybase based service layer for media requests
//
//
//
// 
//------------------------------------------------------------------------------

#ifndef STORAGE_SERVICE_SYB_H
#define STORAGE_SERVICE_SYB_H

#include "StorageService.h"
#include "MediaDAO.h"
#include "MediaFileDAO.h"
#include "MediaActionDAO.h"
#include "MediaTypeDAO.h"
#include "KeyDAO.h"
#include "ServiceConnectionSyb.h"

/**
 * Data access service layer that deals with information about media requests 
 * and the files they are associated to.
 * It uses the Sybase api to connect to the database and a sql based DAO classes
 */
typedef StorageService<ServiceConnectionSyb,
                       MediaDAO,
		       MediaFileDAO,
		       MediaActionDAO,
		       MediaTypeDAO,
		       KeyDAO> 
StorageServiceSyb;

#endif //STORAGE_SERVICE_SYB_H
