// -*-c++-*-

//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// COPYRIGHT (c) European Southern Observatory
// LICENSE:   ESO internal use only
// 
// PROJECT:   VLT Data Flow System
// AUTHOR:    Jens Knudstrup - ESO/DMD/DFS
// SUBSYSTEM: DFS Archive System
//
// $Name: arcsys-1_2_8 $
// $Revision: 1.6 $
// $Log: StringUtils.h,v $
// Revision 1.6  2006/08/08 15:29:22  jknudstr
// -
//
//-----------------------------------------------------------------------------

#ifndef STRINGUTILS_H
#define STRINGUTILS_H


// C++ includes
#include <exception>

// STL includes
#include <string>
#include <vector>

// Local includes
#include <ArcSysEx.h>


using namespace std;


namespace ArcSys 
{

    /// Function to split a string into tokens according to the defined
    /// delimeter character.
    void split(const string&    in,
	       const string     delim,
	       vector<string>&  out);  

    /// Lowercase the given string.
    string lower(const string& str);

}

#endif // STRINGUTILS_H

// EOF

