// -*-c++-*-

//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// COPYRIGHT (c) European Southern Observatory
// LICENSE:   ESO internal use only
// 
// PROJECT:   VLT Data Flow System
// AUTHOR:    Stefano Zampieri - ESO/DMD/DFS
// SUBSYSTEM: arcsys - Archive Systems
//
// $Revision: 1.1 $
// $Log: SybUtils.h,v $
// Revision 1.1  2006/06/01 09:38:54  szampier
// first check-in
//
// 
// 
// Sybase Error Handler
// 
//------------------------------------------------------------------------------

#ifndef SYB_UTILS_H
#define SYB_UTILS_H

// ACE includes
#include <ace/Singleton.h>
#include <ace/Thread_Mutex.h>

// DFS includes
#include <sybconnection.h>

// Local includes
#include <DfsLog.h>

namespace ArcSys
{
  /// Sybase Connection Singleton
  typedef ACE_Singleton<SybaseConnection, ACE_Thread_Mutex> SybConnSingleton;
  
  /// Simple sybase error handler. Logs the sybase error.
  void SimpleErrorHandler(const SybaseStatus& status);
  
}


#endif
