//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ 
//COPYRIGHT (c) 2003 European Southern Observatory 
//LICENSE 
// 
//PROJECT: VLT Data Flow System 
//AUTHOR: Olivier Chuzel - ESO/DMD/DFS 
//SUBSYSTEM: DFO tools 
// 
// 13/04/04 OC Initial coding
//
//-----------------------------------------------------------------------------
#ifndef TDFSUTILSCOMMON_H
#define TDFSUTILSCOMMON_H

#include <list>
#include <string>
#include <sstream>

typedef void t_dfs_void;
typedef int t_return_code;
typedef int t_int_32;
typedef int t_dfs_int;

typedef char t_dfs_char;
typedef long t_long;
typedef long t_dfs_long;
typedef double t_double;
typedef double t_dfs_double;
typedef bool t_dfs_bool;

typedef std::ostream  t_dfs_ostream;
typedef std::ifstream t_dfs_ifstream;

typedef std::ofstream t_dfs_ofstream;

enum t_type {APPLI_NO_TYPE = -1, APPLI_INT=0, APPLI_LONG, APPLI_FLOAT, APPLI_STRING, APPLI_BOOL};
//enum t_dfs_log_level {APPLI_NO_LOG_LEVEL = -1, APPLI_TRACE=0, APPLI_DEBUG, APPLI_INFO, APPLI_WARN, APPLI_ERROR, APPLI_FATAL};

enum t_out_format {APPLI_NO_FORMAT = -1, APP_ASCII_FORMAT=0, APP_XML_FORMAT, APP_HTML_FORMAT};

typedef std::string t_fits_file_dir_name;
typedef std::list<t_fits_file_dir_name> t_fits_file_dir_name_lst;
typedef std::list<t_fits_file_dir_name>::iterator t_fits_file_dir_name_itr;

typedef std::string t_fits_file_name;
typedef std::list<t_fits_file_name> t_fits_file_name_lst;
typedef t_fits_file_name_lst::iterator t_fits_file_name_lst_itr;

typedef std::string t_command_line_argument;

typedef std::string                      t_file_path;
typedef std::list<t_file_path>           t_file_path_lst;
typedef t_file_path_lst::iterator t_file_path_lst_itr;

typedef std::string t_pattern;

typedef std::string t_key_word;
typedef std::string t_fits_keyword;
typedef std::list<t_fits_keyword> t_fits_keyword_lst;
typedef t_fits_keyword_lst::iterator t_fits_keyword_lst_itr;

typedef std::string t_table_name;
typedef std::string t_expression;
typedef std::list<t_expression> t_expression_lst;
typedef t_expression_lst::iterator t_expression_lst_itr;
typedef t_expression_lst::const_iterator t_expression_lst_const_itr;
typedef std::string t_matched;
typedef std::string t_retrieve_str;
typedef std::list<t_retrieve_str> t_str_lst;
typedef t_str_lst::iterator t_str_lst_itr;

typedef int t_indice;
typedef int t_cardinal;
typedef std::list<t_cardinal> t_cardinal_lst;
typedef t_cardinal_lst::iterator t_cardinal_lst_itr;
typedef std::list<t_cardinal_lst> t_cardinal_lst_lst;
typedef t_cardinal_lst_lst::iterator t_cardinal_lst_lst_itr;

typedef std::string t_fits_query;
typedef int t_conf_file_indice;

typedef char t_format;

typedef std::stringstream DfsStringStream;

#endif //TDFSUTILSCOMMON_H

