// -*-c++-*-

//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// COPYRIGHT (c) European Southern Observatory
// LICENSE:   ESO internal use only
// 
// PROJECT:   VLT Data Flow System
// AUTHOR:    Jens Knudstrup - ESO/DMD/DFS
// SUBSYSTEM: DFS Archive System
//
// $Name: arcsys-1_2_8 $
// $Revision: 1.5 $
// $Log: Utils.h,v $
// Revision 1.5  2006/10/12 13:49:12  jknudstr
// -
//
// Revision 1.4  2006/08/08 15:29:22  jknudstr
// -
//
//-----------------------------------------------------------------------------

#ifndef UTILS_H
#define UTILS_H


// C includes
#include <time.h>

// Local includes
#include <ArcSysEx.h>


using namespace std;


namespace ArcSys 
{
    /// Make the calling thread sleep for the specified number of seconds.
    void sleep(const float sleepTime);

    /// Gets the total and available size of the given filesystem, in MB.
    int getFilesystemInfo(const char*  path,
			  float*       totalSize, 
			  float*       availSize);
}

#endif // UTILS_H

// EOF

