#ifndef utilLog_H
#define utilLog_H
/******************************************************************************
 *
 * E.S.O. - Archive System
 *
 * "@(#) $Id: utilLOG.h,v 1.1 2004/09/21 12:45:40 cguirao Exp $"
 *
 * Who       When      What
 * --------  --------  ----------------------------------------------
 * jknudstr  05/08/99  Created
 */

/************************************************************************
 *
 *----------------------------------------------------------------------
 */

#ifndef __cplusplus
#error This is a C++ include file and cannot be used from plain C
#endif

#include "utilTYPES.h"
#include "utilHASH.h"
#include "utilERROR.h"

#define utilLOG_AUTO_FLUSH_SZ  100


class utilLOG 
{
  public:
    utilLOG();
    ~utilLOG();

    void SetVerboseLevel(const int level);
    int  GetVerboseLevel();
    
    void SetLogFile(const char  *filename);
    char *GetLogFile();
    
    void SetLogLevel(const int level);
    int  GetLogLevel();

    void        SetLogCaching(const utilLOGICAL caching);
    utilLOGICAL GetLogCaching();

    utilSTAT LogFlush();

    utilSTAT LogFlushError(const utilERR_SEVERITY  severity,
			   utilERROR               &error);

    utilSTAT LogError(const utilERR_SEVERITY  severity,
		      utilERROR               &error);
    
    utilSTAT LogError(const utilERR_SEVERITY  severity,
		      ccsSTACK_ELEM           *error);
    
    void Log(int          level,
	     const char   *fileLine,
	     const char   *logFormat, ...);
    
    utilSTAT WriteLog(const char *log);

  private:
    static utilLOGICAL   initialized_;
    static int           verboseLevel_;
    static int           logLevel_;
    static utilLOGICAL   logCaching_;
    static slxFILENAME   logFile_;
    static utilHASH      logCache_;
    static ccsERROR      tmpErr_;
};


#undef INFO
#define INFO(level, msg, arg...) { \
    Log(level, __OSLX_DBG__, msg, ## arg); \
}

#endif /*!utilLog_H*/

// --- oOo ---
