#!/bin/sh
#/***********************************************************************/
#/* dfslogPurgeArchiveMessages.sh                                       */
#/*                                                                     */
#/* This script is intended to be run periodically, archiving messages  */
#/* and purging messages from the archive_message table which are over  */
#/* 30 days old.                                                        */
#/*                                                                     */
#/* All "important" messages are moved to the archive_message table     */
#/* prior to deleting from the recent_message table. To edit the        */
#/* definition of "important messages", one must edit the               */
#/* copy_messages_to_archive stored procedure in the dfslog database.   */
#/*                                                                     */
#/* This SQL script must be run as the "dfslog_dbo" or "sa" SYBASE user.*/
#/*                                                                     */
#/* To run the script, use a command similar to the following:          */
#/*                                                                     */
#/* isql -U<usr> -S<server> -P <psswd> -i dfslogPurgeArchiveMessages.sql*/
#/*                                                                     */
#/* Revision Log:                                                       */
#/*                                                                     */
#/* Date           Who                Comment                           */
#/*---------------------------------------------------------------------*/
#/* Apr 29 1999    N. Kornweibel      Original version.                 */
#/* May 27 1999    N. Kornweibel      Added DUMP TRAN dfslog WITH NO_LOG*/
#/* Jan 27 2001    J. Parra           converted to POSIX shell for cron */
#/*                                                                     */
#/***********************************************************************/

. /opt/sybase/SYBASE.sh
. /data/sybase/SCRIPTS/CRON/DBA_VARIABLES.sh

P=`cat /opt/sybase/.dfslog`
log=$DBA_LOGDIR/dfslogPurgeArchiveMessages.out


$SYBASE/OCS-12_0/bin/isql -Udfslog_dbo -S$DSQUERY -P$P >> $log 2>&1 <<EOF
USE dfslog
EXECUTE delete_old_archive_messages @numDaysToKeep=30
go
EOF
#/* end of script */
