package org.eso.ohs.core.dbb.client;

import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.ArrayList;

import org.eso.ohs.core.dbb.server.DbbQuery;
import org.eso.ohs.core.dbb.server.DbbQueryImpl;
import org.eso.ohs.core.dbb.server.DbbSqlEngine;
import org.eso.ohs.core.utilities.ObjectIOException;

public class BasicPaginationOpt extends Paginator {

	String sqlNormal = null;
	String sqlReverse = null;
	
	public BasicPaginationOpt(SqlElements elements, String url, String userId, String password, String database) throws ObjectIOException, SQLException {
		super(elements, url, userId, password, database);
		sql = buildQuery();
		count = countItems();	
		sqlReverse = this.sql + orderByRev;
		sqlNormal = this.sql + orderBy;
	}
	
	public BasicPaginationOpt(DbbSqlEngine dbbEngine){
		super(dbbEngine);
		//Chiamare la costruzione della query standard qui!!!!
		sql = null;
		count = -1;	
		sqlReverse = null;
		sqlNormal = null;
	}

	private String buildQuery() {
		StringBuffer result = new StringBuffer();
		StringBuffer bufCount = new StringBuffer();
		
		result.append("SELECT ");
		bufCount.append("SELECT count(*) ");
		ArrayList<Object> select = elements.getSelect();
		for (int i = 0; i < select.size(); i++){
			result.append(select.get(i)).append(", ");
		}
		result.delete(result.length()-2, result.length()-1);
		
		result.append("FROM ");
		bufCount.append("FROM ");
		ArrayList<Object> from = elements.getFrom();
		for (int i = 0; i < from.size(); i++){
			result.append(from.get(i)).append(", ");
			bufCount.append(from.get(i)).append(", ");
		}
		result.delete(result.length()-2, result.length()-1);
		bufCount.delete(bufCount.length()-2, bufCount.length()-1);
		
		result.append("WHERE ");
		bufCount.append("WHERE ");
		
		ArrayList<Object> where = elements.getWhere();
		for (int i = 0; i < where.size(); i++){
			result.append(where.get(i)).append(", ");
			bufCount.append(where.get(i)).append(", ");
		}
		result.delete(result.length()-2, result.length()-1);
		bufCount.delete(bufCount.length()-2, bufCount.length()-1);
		sql = result.toString();
		sqlCount =  bufCount.toString();
		
		result.append("ORDER BY ");
		
		//Normal orderBy Clause
		ArrayList<Object> orderBy = elements.getOrderBy();
		StringBuffer tmp = new StringBuffer();
		for (int i = 0; i < orderBy.size(); i++){
			tmp.append(orderBy.get(i)).append(", ");
		}
		tmp.delete(tmp.length()-2, tmp.length()-1);
		this.orderBy = tmp.toString();
		
//		Normal orderByReversed Clause
		tmp = new StringBuffer();
		for (int i = 0; i < orderBy.size(); i++){
			String str = orderBy.get(i).toString();
			if ( str.indexOf("ASC") > 0){
				str = str.replaceAll("ASC", "DESC");
			}else{
				str = str.replaceAll("DESC", "ASC");
			}
			tmp.append(str).append(", ");
		}
		tmp.delete(tmp.length()-2, tmp.length()-1);
		this.orderByRev = tmp.toString();
		
		return result.toString();
	}

	public DbbQuery moveTo(int pageNumber, int pageSize) throws SQLException {
		DbbQuery result = null;
		if (count >= 0){
			int totalPages = (count + (pageSize - 1))/pageSize;
			int startRow = 0;
			int endRow = 0;
			setReversed(false);
			String sql = null;
			
			//the page is in the first half od the result set?
			if (pageNumber > totalPages/2 + 1){
				pageNumber = totalPages - pageNumber;
				setReversed(true);
				sql = this.sqlReverse;
				startRow = pageSize * (pageNumber - 1) + 2;
				endRow = startRow + pageSize - 1;
			}else{
				sql = this.sqlNormal;
				startRow = pageSize * (pageNumber - 1) + 1;
				endRow = startRow + pageSize - 1;
			}
			
			System.out.println("Using query: " + sql);
			
			/*Statement stmt = con.createStatement();
			String setRowCount = "set rowcount " + endRow;
			System.out.println(setRowCount);
			stmt.execute(setRowCount);
			System.out.println(sql);
			stmt = con.createStatement();*/
			//ResultSet queryResult = db.execQuery(sql, stmt);
			ResultSet queryResult = session.execSql(sql, endRow);
			
			result = new DbbQueryImpl(queryResult, session, startRow);
		}
	
		return result;
	}
	
	public void setSqlQuery(String sql){
		this.sqlNormal = new String(sql);
		
		//reverse the order by
		
		this.sqlReverse = new String(sql);
		sqlReverse = sqlReverse.replaceAll("ASC", "tempDesc");
		sqlReverse = sqlReverse.replaceAll("DESC", "ASC");
		sqlReverse = sqlReverse.replaceAll("tempDesc", "DESC");	
	}
	
	public void setSqlCount(String sql){
		sqlCount = sql;
		count = countItems();	
	}
}
