package org.eso.ohs.core.dbb.client;

// $Id: DbbDetailedView.java,v 1.2 2006/04/26 09:26:44 tcanavan Exp $

import java.awt.BorderLayout;
import java.util.Vector;

import javax.swing.Box;
import javax.swing.BoxLayout;
import javax.swing.JButton;
import javax.swing.JPanel;
import javax.swing.border.EtchedBorder;
import javax.swing.border.TitledBorder;

public abstract class DbbDetailedView extends JPanel {

    /** Border that surrounds the panel when displaying a title. */
    private TitledBorder titled_ = null;

    protected Vector<JButton> buttonList_ = new Vector<JButton>();
    protected JPanel viewPanel_ = null;
    protected JPanel buttonPanel_ = null;
    
    //----------------------------------------
    // Constructors
    //----------------------------------------

    public DbbDetailedView() {
	this(null);
    }

    public DbbDetailedView(String label) {
	/* Call the JPanel constructor. */
	super(true);
	setOpaque(true);
	
	EtchedBorder etched = new EtchedBorder();

	if(label == null || label.equals("")) {
	    this.setBorder(etched);
	}
	else {
	    titled_ = new TitledBorder(etched, 
				       label,
				       TitledBorder.LEFT,
				       TitledBorder.TOP);

	    this.setBorder(titled_);
	}

	buildInternalPanels();
    }
    
    //----------------------------------------
    // Private methods
    //----------------------------------------

    private void buildInternalPanels() {
	
	/* Layout manager. */
	setLayout(new BorderLayout());
	
	/* Create the view panel at the center */
	viewPanel_ = new JPanel(true);
	add(viewPanel_, "Center");
	
	/* Create the button panel at the south */
	buttonPanel_ = new JPanel(true);
	add(buttonPanel_, "South");
	
	buttonPanel_.setLayout(new BoxLayout(buttonPanel_, BoxLayout.X_AXIS));
    }
    
    //----------------------------------------
    // Protected methods
    //----------------------------------------

    protected void addButton(JButton new_button) {
	buttonPanel_.add(new_button);
	buttonList_.addElement(new_button);
    }
    
    protected void addButtonSpace() {
	buttonPanel_.add(Box.createGlue());  
    }
    
    //----------------------------------------
    // Public methods
    //----------------------------------------

    public abstract Object getObject();
    public abstract void setObject(Object object);
}
