package org.eso.ohs.core.dbb.client;

// $Id$


/**
 *  A transducer to convert set/get of String values into set/get
 *  on an int property.  The target property's name is given to the
 *  constructor. The renderer is applied to a Dec obj
 *
 *  <p>
 *  For example, users will call it's
 *  setValue/getValue methods.  Those calls will be translated into
 *  calls to setX/getX on the object given to the constructor.
 *
 *  <p>
 */


public class DbbHtmlTextPattern implements DbbDataType {
	/** Default zero coordinate */
    private final static String DEFAULT_ANGLE_ = "-00:00:00.000";
	public final static String SQL_WILD_CARD = "%";
    //----------------------------------------
    // Public methods
    //----------------------------------------


    /**
     * Converts data to a String from the meta-level equivalent of the
     * actual property's type, i.e. from a java.lang.Long
     * to a long int. 
     *
     * @param value	value of the property.
     */
    public String fromDatabaseData(Object obj) {
    	String result = (String) obj;
	
	return result;
    }


    /**
     * Converts data from a String to a meta-level equivalent of the
     * actual property's type, i.e. to a java.lang.Integer
     * representing an int.
     *
     * @param value the new value of the property.
     */
    public Object toDatabaseData(String value) {
    	
    		String text = value;
    		if(text != null && text.length() > 0)  
    		    text = "\'"+ SQL_WILD_CARD + text + SQL_WILD_CARD + "\'";  
    		
    		text = text.toLowerCase();
    		/*if (!isCaseSensitive){
    			text = text.toLowerCase();
    		}*/
    		return text;  	    
    }

		/** @return the display data type */
		public Class getDataType() {
			return String.class;
		}
		
		
		/** @return the database data type */
		public Class getDatabaseType() {
			return String.class;
		}
		
		/** @return the display data type length */
		public int getDataTypeLength() {
			return DEFAULT_ANGLE_.length();
		}
}

