package org.eso.ohs.core.dbb.client;

// $Id$


/**
 *  A transducer to convert set/get of String values into set/get
 *  on an int property.  The target property's name is given to the
 *  constructor. The renderer is applied to a Dec obj
 *
 *  <p>
 *  For example, users will call it's
 *  setValue/getValue methods.  Those calls will be translated into
 *  calls to setX/getX on the object given to the constructor.
 *
 *  <p>
 */


public class DbbHtmlYesNo implements DbbDataType {
	/** Default zero coordinate */
    private final static String DEFAULT_ANGLE_ = "-00:00:00.000";
	public final static String SQL_WILD_CARD = "%";
    //----------------------------------------
    // Public methods
    //----------------------------------------


    /**
     * Converts data to a String from the meta-level equivalent of the
     * actual property's type, i.e. from a java.lang.Long
     * to a long int. 
     *
     * @param value	value of the property.
     */
    public String fromDatabaseData(Object obj) {
    	String result = "";
    	Integer a = (Integer) obj;
		if (a.intValue() == 0){
			result = "No";
		}else{
			result = "Yes";
		}
	
	return result;
    }


    /**
     * Converts data from a String to a meta-level equivalent of the
     * actual property's type, i.e. to a java.lang.Integer
     * representing an int.
     *
     * @param value the new value of the property.
     */
    public Object toDatabaseData(String value) {
    		Integer result = null;
    		String text = value;  		
    		text = text.toLowerCase();
    		if (text.equals("yes")){
    			result = new Integer(1);
    		} else {
    			result = new Integer(0);
    		}
    		return result;  	    
    }

		/** @return the display data type */
		public Class getDataType() {
			return String.class;
		}
		
		
		/** @return the database data type */
		public Class getDatabaseType() {
			return String.class;
		}
		
		/** @return the display data type length */
		public int getDataTypeLength() {
			return DEFAULT_ANGLE_.length();
		}
}

