package org.eso.ohs.core.dbb.client;

import javax.swing.JTextField;

import org.eso.ohs.core.dbb.sql.DbbSqlChunk;
import org.eso.ohs.core.gui.models.IntModel;

public class DbbIntegerTextField extends DbbTextField {


  /** Create a DbbTextField object.
   * 
   * @param labeltext	Label text to be displayed.
   * @param chunk	DbbSqlChunk object
   *  */
  public DbbIntegerTextField(String labeltext, 
				 DbbSqlChunk chunk) {

    super(labeltext, chunk);
    JTextField tf = (JTextField)widget_;
    tf.setDocument(new IntModel());
  }

  /** 
   * Get the widget value.
   *
   * @return The currently displayed string value. 
   */
  public String get() {

    String str = ((JTextField) widget_).getText();
    int val = 0;

    if(str.equals(""))
      return str;

    try{
        val = Integer.parseInt(str);
    } catch (NumberFormatException e) {
        val = 0;
    }
    return(Integer.toString(val));
  }
}
