package org.eso.ohs.core.dbb.client;

import java.util.ArrayList;

import org.eso.ohs.core.dbb.server.DbbOrderingClauseInfo;


public class DbbSqlPagingInfo {
	
	String[] columnsName = null;
	Class[] columnsType = null;
	int columnsCount = 0;
	String positioningSqlString = null;
	String fetchingSqlString = null;
	String countingSqlString = null;
	DbbOrderingClauseInfo orderingClauseInfo = null;
	ArrayList selectPaginationInfo = null;
	
	int pageNumber = 0;
	int pageSize = 0;
	public ArrayList getSelectPaginationInfo() {
		return selectPaginationInfo;
	}
	public void setSelectPaginationInfo(ArrayList selectPaginationInfo) {
		this.selectPaginationInfo = selectPaginationInfo;
	}
	public int getColumnsCount() {
		return columnsCount;
	}
	public void setColumnsCount(int columnsCount) {
		this.columnsCount = columnsCount;
	}
	public String[] getColumnsName() {
		return columnsName;
	}
	public void setColumnsName(String[] columnsName) {
		this.columnsName = columnsName;
	}
	public Class[] getColumnsType() {
		return columnsType;
	}
	public void setColumnsType(Class[] columnsType) {
		this.columnsType = columnsType;
	}
	public String getFetchingSqlString() {
		return fetchingSqlString;
	}
	public void setFetchingSqlString(String fetchingSqlString) {
		this.fetchingSqlString = fetchingSqlString;
	}
	public int getPageNumber() {
		return pageNumber;
	}
	public void setPageNumber(int pageNumber) {
		this.pageNumber = pageNumber;
	}
	public int getPageSize() {
		return pageSize;
	}
	public void setPageSize(int pageSize) {
		this.pageSize = pageSize;
	}
	public String getPositioningSqlString() {
		return positioningSqlString;
	}
	public void setPositioningSqlString(String positioningSqlString) {
		this.positioningSqlString = positioningSqlString;
	}
	public String getCountingSqlString() {
		return countingSqlString;
	}
	public void setCountingSqlString(String countingSqlString) {
		this.countingSqlString = countingSqlString;
	}
	/**
	 * 
	 * @return true if all the informations required by the 
	 * pagination system have been collected
	 */
	public boolean isReady(){
		boolean result = true;
		
		if (columnsName == null){
			throw new IllegalArgumentException("columnName array is null");
		
		}else if (columnsType == null){
			throw new IllegalArgumentException("columnType array is null");
		
		}else if ((columnsCount != columnsName.length) ||  (columnsCount != columnsType.length)){
			throw new IllegalArgumentException("size mismatch!");
			
		}else if (positioningSqlString == null){
			throw new IllegalArgumentException("positioning is null");
		
		}else if (positioningSqlString.length() <= 0){
			throw new IllegalArgumentException("positioning is empty");
			
		}else if (fetchingSqlString == null){
			throw new IllegalArgumentException("fetching is null");
			
		}else if (fetchingSqlString.length() <= 0){
			throw new IllegalArgumentException("fetching is empty");
			
		}else if (countingSqlString == null){
			throw new IllegalArgumentException("counting is null");
			
		}else if (countingSqlString.length() <= 0){
			throw new IllegalArgumentException("fetching is empty");
			
		}else if (pageSize <=0){
			throw new IllegalArgumentException("pageSize must be > 0");
			
		}else if (pageNumber <=0){
			throw new IllegalArgumentException("pageNumber must be > 0");
		}
		return result;
	}
	public DbbOrderingClauseInfo getOrderingClauseInfo() {
		return orderingClauseInfo;
	}
	public void setOrderingClauseInfo(DbbOrderingClauseInfo orderingClauseInfo) {
		this.orderingClauseInfo = orderingClauseInfo;
	}

}
