package org.eso.ohs.core.dbb.client;

import java.sql.Connection;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;

import org.apache.log4j.Logger;
import org.eso.ohs.core.dbb.server.DbbQuery;
import org.eso.ohs.core.dbb.server.DbbSession;
import org.eso.ohs.core.dbb.server.DbbSqlEngine;
import org.eso.ohs.core.dbb.server.DbbSqlEngineImpl;
import org.eso.ohs.core.utilities.ObjectIOException;

public abstract class Paginator {

	
	SqlElements elements = null;
	Statement stmt = null;
	Connection con = null;
	DbbSession session = null;
	boolean reversed = false;
	int count = 0;
	String sql = null;
	String sqlCount = null;
	String orderBy = null;
	String orderByRev = null;
	
	protected static Logger stdlog = Logger.getLogger(Paginator.class);
	
	
	public Paginator(SqlElements elements, String url, String userId, String  password, String database) throws ObjectIOException, SQLException{
		
		session = new DbbSession(url, database, userId, password);
		this.elements = elements;
	}
	public Paginator(DbbSqlEngine dbbEngine){
		
		session = ((DbbSqlEngineImpl)dbbEngine).getSession();
	}
	
	public int countItems()  {
		int result = 0;
		
		try {
			System.out.println("Count query " + sqlCount);
			 ResultSet rs = session.execSql(sqlCount);
			while (rs.next()) {
	            result = rs.getInt(1);
	        }
	        rs.close();
		} catch (SQLException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}

        session.releaseCurrentConnection();
		
		return result;
	}
	
	public Statement getStatement() {
		return stmt;
	}
	public void releaseResource(){
		
		session.releaseCurrentConnection();
	}
	abstract public DbbQuery moveTo(int pageNumber, int pageSize) throws SQLException;
	public boolean isReversed() {
		return reversed;
	}
	public void setReversed(boolean reversed) {
		this.reversed = reversed;
	}
	public int getCount() {
		return count;
	}
	public void setCount(int count) {
		this.count = count;
	}
	/*public DBdataHelper getDb() {
		return db;
	}*/
	public SqlElements getElements() {
		return elements;
	}
	public String getOrderBy() {
		return orderBy;
	}
	public String getOrderByRev() {
		return orderByRev;
	}
	public String getSql() {
		return sql;
	}
	public String getSqlCount() {
		return sqlCount;
	}	
	
	public void setSqlCount(String sql){}
	
	public void setSqlQuery(String sql){}
	
}
