package org.eso.ohs.core.docview.gui;

import java.awt.Color;

import org.eso.ohs.core.docview.datatrans.Adaptor;
/**
 * Interface that must be implemented for any GuiAdaptor that
 * bridges between a DocView and a GUI component, eg JTextField.
 *
 * <p>
 * $Id: GuiAdaptor.java,v 1.1 2004/02/17 12:38:00 tcanavan Exp $
 * <br>
 * @author Bob Kemp
 */
public interface GuiAdaptor extends Adaptor {

    /**
     * Has the GUI components internal state been modified
     * since the connected Java object was last updated?
     * 
     * @return		true if it has been modified, false otherwise
     */
    public boolean isModified();

    /**
     * Flags the GUI component as modified or not.
     * 
     * @param modified	true to mark the component as modified, false otherwise
     */
    public void setModified(boolean modified);

    /**
     * Enable or disable the GUI component.
     * 
     * @param enabled	true to enable the component, false otherwise
     */
    public void setEnabled(boolean enabled);

    public void setForeground(Color bg);

}

