package org.eso.ohs.core.gui.models;

/**
 * A Document model to only permit the input of an epoch.
 * 
 * <p>
 * $Id: EpochModel.java,v 1.1 2004/02/17 10:35:21 tcanavan Exp $
 */

public class EpochModel extends InputMaskModel {

    /**
     * The regular expression describing legal buffer values.
     * Looking for values like: 2000.0
     */
    private final static String legalValuesPattern_ =
	"\\d{0,4}(\\.\\d?)?";

    /**
     * Constructor for the model.
     */
    public EpochModel() {
	super(legalValuesPattern_);
    }

}

