package org.eso.ohs.core.gui.utilities;

import java.io.ByteArrayInputStream;
import java.io.InputStream;

import javax.print.Doc;
import javax.print.DocFlavor;
import javax.print.DocPrintJob;
import javax.print.PrintException;
import javax.print.PrintService;
import javax.print.PrintServiceLookup;
import javax.print.ServiceUI;
import javax.print.SimpleDoc;
import javax.print.attribute.DocAttributeSet;
import javax.print.attribute.HashDocAttributeSet;
import javax.print.attribute.HashPrintRequestAttributeSet;
import javax.print.attribute.PrintRequestAttributeSet;
import javax.swing.text.html.HTMLDocument;


/**
 * Class PrintReport
 *
 *  This class uses DocumentRenderer class to print
 *
 * @version $Revision: 1.2 $
 * @author pnunes, Feb 17, 2005
 */

// $Id: PrintManager.java,v 1.2 2005/02/24 10:28:38 pnunes Exp $ 
public class PrintManager {

    
    public PrintManager() {
        
    }
    
    
    /**
     * Prints an HTMLDocument
     * 
     * @param htmlDocument
     */
    public void printHTML( HTMLDocument htmlDocument ) {                 
        DocumentRenderer DocumentRenderer = new DocumentRenderer();
        DocumentRenderer.print(htmlDocument);

              
    }
    
    
    public static void printHTML( String htmlString ) throws PrintException {

        DocFlavor flavor = DocFlavor.INPUT_STREAM.AUTOSENSE;
        PrintService[] services = PrintServiceLookup.lookupPrintServices(
                DocFlavor.INPUT_STREAM.AUTOSENSE, null);
        PrintRequestAttributeSet attributes = new HashPrintRequestAttributeSet();
        PrintService defaultService = PrintServiceLookup.lookupDefaultPrintService();
        
        PrintService service =   ServiceUI.printDialog(null, 200, 200,
                services, defaultService, flavor, attributes);

        if (service != null) {
            DocPrintJob job = service.createPrintJob();
            InputStream fis = new ByteArrayInputStream(htmlString.getBytes());
            DocAttributeSet das = new HashDocAttributeSet();
            Doc doc = new SimpleDoc(fis, flavor, das);
            job.print(doc, attributes);
            //Thread.sleep(10000);
        }
    }
    
    public static void main( String [] args ) throws PrintException {
        String html = "<html><head><meta content='text/html; charset=UTF-8' http-equiv='Content-Type'><title>Enter the title of your HTML document here</title></head><body><p>Enter the body text of your HTML document here</p></body></html>";
        PrintManager.printHTML(html);
        
        
    }

    
}
    






