package org.eso.ohs.core.gui.widgets;

import java.awt.Color;
import java.awt.GridBagConstraints;
import java.awt.GridLayout;
import java.awt.Insets;

import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JProgressBar;

import org.apache.log4j.Logger;

/**
 *
 * @author  pnunes
 * 
 * Created on December 7, 2005, 2:34 PM
 */
public class ProgressPanel extends JPanel implements ProgressModelListener {
    
	private JLabel labelStatus;
    private JProgressBar progressBar;
    
    private static Logger stdlog_ =
        Logger.getLogger(ProgressPanel.class);
	
    /** Creates new form ProgressPanel */
    public ProgressPanel(int min, int max, String msg) {
        initComponents(min, max, msg);
    }
    
    public ProgressPanel(ProgressModel model) {
    	initComponents(model.getMinimum(),model.getMaximum(),model.getMsg());
    }
       
       
    private void initComponents(int min, int max, String msg) {
    	//setLayout(new GridBagLayout());
    	
    	setLayout(new GridLayout());
        labelStatus = new JLabel();
        progressBar = new JProgressBar(min,max);
        progressBar.setForeground(Color.LIGHT_GRAY.darker());   
        
		progressBar.setStringPainted(false);	
		progressBar.setOpaque(true);
        setMessage(msg);        
        
        GridBagConstraints gridBagConstraints = new GridBagConstraints();        
        gridBagConstraints.insets = new Insets(0, 5, 0, 5);
        //add(labelStatus,gridBagConstraints);
        add(labelStatus);
        
        gridBagConstraints.insets = new Insets(0, 5, 0, 5);
        gridBagConstraints = new GridBagConstraints();            
        //add(progressBar,gridBagConstraints);
        add(progressBar);
        

    }
    
    public void setMessage(String msg) {
    	labelStatus.setText(msg);
    }
    
    public void setMin(int min) {
    	progressBar.setMinimum(min);
    }
    
    public void setMax(int max) {
    	progressBar.setMaximum(max);
    }
    
    public void setValue(int value) {
    	progressBar.setValue(value);      	
    	//stdlog_.debug("Set value to:" + value);
    	//notify();
    }

	public void modelChanged(ProgressModelEvent e) {		
		stdlog_.debug("Set value to:" + e.getValue());
		setValue(e.getValue());	
	}
    
    
    
    
}
