/*
 * Created on Sep 15, 2004
 */
package org.eso.ohs.core.utilities;

import java.util.Calendar;
import java.util.Date;

/**
 * Utility class -- really a wrapper for java.util.Date
 *
 * @author ddorigo
 * @version $Revision: 1.4 $
 */

// $Id: DateContainer.java,v 1.4 2006/03/06 10:57:22 ddorigo Exp $

public class DateContainer {

    private int day_ = 0;
    private String month_ = "";
    private int year_ = 0;

    /**
     * @param day
     * @param month
     * @param year
     */
    public DateContainer( int day, String month, int year ) {
        setDay( day );
        setMonth( month );
        setYear( year );
    }

    /**
     * @param day_ The day_ to set.
     */
    public void setDay( int day_ ) {
        this.day_ = day_;
    }

    /**
     * @return Returns the day_.
     */
    public int getDay() {
        return day_;
    }

    /**
     * @param month_ The month_ to set.
     */
    public void setMonth( String month_ ) {
        this.month_ = month_;
    }

    /**
     * @return Returns the month_.
     */
    public String getMonth() {
        return month_;
    }

    /**
     * @param year_ The year_ to set.
     */
    public void setYear( int year ) {
        this.year_ = year;
    }

    /**
     * @return Returns the year_.
     */
    public int getYear() {
        return year_;
    }

    /**
     * @param dateObj
     * @return DateContainer day, month, year
     */
    public static DateContainer convertDate( Date dateObj ) {
        Calendar cal = Calendar.getInstance();
        cal.setTime( dateObj );
        int year = cal.get( Calendar.YEAR );
        int calendarMonth = cal.get( Calendar.MONTH );
        String month = Convert.getMonth( calendarMonth );
        int day = cal.get( Calendar.DAY_OF_MONTH );
        DateContainer date = new DateContainer( day, month, year );
        return date;
    }
}
