package org.eso.ohs.core.utilities;

/**
  A simple encryption scheme. 
  <P>

 <strong>NOTE</strong>: This package does not really encrypt, in any
 meaningful sense of the word.  It merely obscures the data from
 prying eyes.  Given time, even a child could break this "encryption"
 scheme.
 <P>

 This class has a main program which can be used to encrypt/decrypt
 individual strings; output goes to the console. Usage:
 <BR>
 <tt>
 &nbsp;&nbsp;&nbsp;java org.eso.ohs.core.utilities.Encrypt [<em>string</em> 
 [<em>string</em> ...]]
 </tt>
 <P>

 When called with no command line arguments, it encrypts/decrypts a
 standard set of strings.
 
 * @author Bob Kemp
 * @version $Revision: 1.13 $
 */
public class Encrypt {

    private static final String rcsid = "$Id: Encrypt.java,v 1.13 2005/12/12 15:56:12 ddorigo Exp $"; 

    // problematic on SOLARIS Java1.4
    // private final static String key = "̉";
    private final static String key = "rfdufd987";

    private final static String hexChars = "0123456789abcdef";

    public static String encrypt(String s) {
        return toHex(encryptImpl(s));
    }

    public static String deCrypt(String s) throws IllegalArgumentException {
        String rc = encryptImpl(fromHex(s));
		  return rc;
    }


    public static String encryptImpl(String s) {
        StringBuffer buf = new StringBuffer();
    
        for(int i=0;i<s.length();i++) {
            char c = (char)(s.charAt(i) ^ key.charAt(i % key.length()));
    
            buf.append(c);           
        }
    
        return buf.toString();
    }

    private static String fromHex(String s) throws IllegalArgumentException {
        StringBuffer buf = new StringBuffer();
        int len = s.length();
        int nib1=-1, nib2=-1;
        char ch;
    
        for (int j=0; j < len; j+=2) {
                try {
               nib1 = hexChars.indexOf(s.charAt(j));
               nib2 = hexChars.indexOf(s.charAt(j+1));
                }
                catch(IndexOutOfBoundsException e1) {
            throw new IllegalArgumentException("String \"" + s + "\" is corrupted");
            }
            if (nib1 < 0 || nib2 < 0) {
                    throw new IllegalArgumentException("String \"" + s + "\" is corrupted");
            }
    
            ch = (char)((nib1 << 4) | nib2);
    
            buf.append(ch);
        }
    
        return buf.toString();
    }

    private static String toHex(String s) {
        StringBuffer buf = new StringBuffer();
        int len = s.length();
        int ch;
    
        for (int j=0; j < len; j++) {
            ch = s.charAt(j);
            buf.append(hexChars.charAt(ch/16));
            buf.append(hexChars.charAt(ch%16));
        }
    
        return buf.toString();
    }

    public static void main(String[] args) {

        String[] test = {
            "abcdefghijklmnopqrstuvwxyz",
            "Mary had a green dog",
            "opc70_dbo_ps",
			"auto_opc70_dbo",
            "frog23dgt",
            "tgo95vh",
            "hin9gg",
            "read4me",
			"in01ri",
			"phrs67",
			"dev67",
			"phrs_ps",
			"Prop#Sub",
			"pi10po11",
            //"She sold the lamb to buy it",
            //"ot",
            //"ntt+vlt",
            //"p2pp",
            //"phase-2",
            //"ohs_user",
            //"ipacman2",
            //"ohs_user_ps",
            //"2phase",
            ""
        };
    
        if( args.length > 0 ) 
            test = args;
    
        for (int j=0; j < test.length; j++) {
            System.out.println("Original:  " + test[j]);
    
            String enc = encrypt(test[j]);
            System.out.println("Encrypted: " + enc);
    
            String dec = deCrypt(enc);
            System.out.println("Decrypted: " + dec);
    
            System.out.println();
        }
        
        System.out.println("Decrypted esoform: " + Encrypt.deCrypt("1c12105e10084d"));
    }
}
