// -*- Java -*-
//.IDENT     $Id: BusinessVisitor.java,v 1.6 2006/02/16 10:21:21 gdonino Exp $

package org.eso.ohs.dfs;


/**
 * An interface using the "Visitor" Design Pattern to allow
 * classes to execute different methods depending on the
 * <i>run-time</i> type of their arguments.
 * 
 * For details, see the classic design patterns book:
 *   "Design Patterns: Elements of Reusable Object-Oriented Software"
 *   by E.Gamma, R.Helm, R.Johnson, J.Vlissides
 *   pub Addison Wesley, 1995
 *   ISBN: 0-201-63361-2
 * 
 */
public interface BusinessVisitor {

    /** Visitor method for an CalibrationBlock object */
    public Object visit(CalibrationBlock bo, Object arg);

    /** Visitor method for an ConstraintSet object */
    public Object visit(ConstraintSet bo, Object arg);

    /** Visitor method for an ObservationBlock object */
    public Object visit(ObservationBlock bo, Object arg);

    /** Visitor method for an ObservationDescription object */
    public Object visit(ObservationDescription bo, Object arg);

    /** Visitor method for an ObservingRun object */
    public Object visit(ObservingRun bo, Object arg);

    /** Visitor method for an Target object */
    public Object visit(Target bo, Object arg);
    
   /** Visitor method for an Target object */
    public Object visit(Queue bo, Object arg);
}


