package org.eso.ohs.dfs;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.Vector;

/**
 * These are high level methods that  appends and detach finding charts.
 * I wanted to keep them separate from the business object.
 * @author tcanavan
 *
 */
public class FindingChartSession {
    
    
    /**
     * Append finding chart to an ob.
     * @param ob
     * @param fcChart
     */


    public static void appendFindingCharts(
        ObservationBlock ob,
        FindingChart[] fcChart) {
        List<FindingChart> newVec = new ArrayList<FindingChart>();
        Map<String, FindingChart> replaceList = new HashMap<String, FindingChart>();
        FindingChart [] currCharts = ob.getFindingCharts();
        for (int i = 0; i < fcChart.length; i++) {
            boolean found = false;
            for (int j = 0; j < currCharts.length; j++) {
                if (fcChart[i].getFcName().equals(currCharts[j].getFcName())) {
                    found = true;
                    break;
                }
            }
            if (!found) {
                newVec.add(fcChart[i]);
            } else {
                replaceList.put(fcChart[i].getFcName(),fcChart[i]);
            }
        }
        Vector<FindingChart> addVec = new Vector<FindingChart>();
        for (int i = 0; i < currCharts.length; i++) {
            if(!replaceList.containsKey(currCharts[i].getFcName())) {
                addVec.add(currCharts[i]);                
            }
        }
        for (int i = 0; i < newVec.size(); i++) {
            addVec.add(newVec.get(i));
        }
        Object [] array  = replaceList.values().toArray(); 
        for(int i=0;i<array.length;i++) {
            addVec.add((FindingChart)array[i]);
        }
        
        FindingChart[] tempFcCharts = new FindingChart[addVec.size()];
        addVec.copyInto(tempFcCharts);
        ob.setFindingCharts(tempFcCharts);
    }
    
    /**
     * Detaches the finding chart from the ob. 
     * @param ob
     * @param findingCharts
     */    
    public static void detatchFindingCharts(ObservationBlock ob,FindingChart[] findingCharts) {
        FindingChart [] localFCs = ob.getFindingCharts();
        List<FindingChart> newFCsList = new ArrayList<FindingChart>();
        for(int i=0;i<localFCs.length;i++) {
            boolean found = false;
            for(int j=0;j<findingCharts.length;j++) {
                if(findingCharts[j].getCheckSum() == localFCs[i].getCheckSum()) {
                    found = true;
                    //obsRun.decFcCount(localFCs[i].getCheckSum());
                }                
            }
            if(!found) {                
                newFCsList.add(localFCs[i]);
            }
        }
        FindingChart [] newFCs = new FindingChart[newFCsList.size()];
        newFCsList.toArray(newFCs);
        ob.setFindingCharts(newFCs);
    }    
}
