package org.eso.ohs.dfs;


/**
 * A business object for representing 
 * 
 * $Id: ObTargetConstraintInfo.java,v 1.8.4.2 2006/12/01 09:08:31 pnunes Exp $
 * 
 * @author ddrorigo
 */
public class ObTargetConstraintInfo extends BusinessObject {

  
    private static final long serialVersionUID = 1L;

    
    /*
     * Members from Observation Block 
     */
    private int userId = 0;
    private int runId = 0;
    private int repeats = 0;    
    private int userPriority = 0;
    private String status = "";
    private String type = "";
    private long creationDate = 0;
    private long tiId = 0;
    private int executionTime = 0;
    
    /*
     * Members from Target
     */
     private int ra;
     private int dec;
     private double propRA;
     
     private double propDec;
     
     private double diffRA;
     private double diffDec;
    
    /*
     * Members from Constraint set
     */
    private float airmass = 5.0f;
    private float fractionalLunarIllumination = 1.0f;
    private int moonAngularDistance = 30;
    private double seeing = Seeing.MIN_SEEING;
    private String skyTransparency = "";
    private float strehlRatio =  0.0f;

    
    
    
    /* (non-Javadoc)
     * @see org.eso.ohs.dfs.BusinessObject#accept(org.eso.ohs.dfs.BusinessVisitor, java.lang.Object)
     */
    public Object accept(BusinessVisitor visitor, Object arg) {
        // TODO Auto-generated method stub
        return null;
    }

    /* (non-Javadoc)
     * @see org.eso.ohs.dfs.StorableObject#postProecess()
     */
    public void postProecess() {
        // TODO Auto-generated method stub
        
    }

 
    public long getCreationDate() {
        return creationDate;
    }
    
    public void setCreationDate(long creationDate) {
        this.creationDate = creationDate;
    }

    public int getRepeats() {
        return repeats;
    }
    public void setRepeats(int repeats) {
        this.repeats = repeats;
    }
    public int getRunId() {
        return runId;
    }
    public void setRunId(int runId) {
        this.runId = runId;
    }
    public String getStatus() {
        return status;
    }
    public void setStatus(String status) {
        this.status = status;
    }
    public String getType() {
        return type;
    }
    public void setType(String type) {
        this.type = type;
    }
    public int getUserId() {
        return userId;
    }
    public void setUserId(int userId) {
        this.userId = userId;
    }
    public int getUserPriority() {
        return userPriority;
    }
    public void setUserPriority(int userPriority) {
        this.userPriority = userPriority;
    }
    
    
	public float getAirmass() {
		return airmass;
	}
	public void setAirmass(float airmass) {
		this.airmass = airmass;
	}
	public int getDec() {
		return dec;
	}
	public void setDec(int dec) {
		this.dec = dec;
	}
	public double getDiffDec() {
		return diffDec;
	}
	public void setDiffDec(double diffDec_) {
		this.diffDec = diffDec_;
	}
	public double getDiffRA() {
		return diffRA;
	}
	public void setDiffRA(double diffRA) {
		this.diffRA = diffRA;
	}
	public float getFractionalLunarIllumination() {
		return fractionalLunarIllumination;
	}
	public void setFractionalLunarIllumination(float fractionalLunarIllumination) {
		this.fractionalLunarIllumination = fractionalLunarIllumination;
	}
	public int getMoonAngularDistance() {
		return moonAngularDistance;
	}
	public void setMoonAngularDistance(int moonAngularDistance) {
		this.moonAngularDistance = moonAngularDistance;
	}

	public double getPropDec() {
		return propDec;
	}


	public void setPropDec(double propDec) {
		this.propDec = propDec;
	}


	public double getPropRA() {
		return propRA;
	}


	public void setPropRA(double propRA) {
		this.propRA = propRA;
	}

	public int getRa() {
		return ra;
	}
	public void setRa(int ra) {
		this.ra = ra;
	}
	public double getSeeing() {
		return seeing;
	}
	public void setSeeing(double seeing) {
		this.seeing = seeing;
	}
	public String getSkyTransparency() {
		return skyTransparency;
	}
	public void setSkyTransparency(String skyTransparency) {
		this.skyTransparency = skyTransparency;
	}
	public float getStrehlRatio() {
		return strehlRatio;
	}
	public void setStrehlRatio(float strehlRatio) {
		this.strehlRatio = strehlRatio;
	}

	public long getTiId() {
		return tiId;
	}
	public void setTiId(long tiId) {
		this.tiId = tiId;
	}

	public int getExecutionTime() {
		return executionTime;
	}

	public void setExecutionTime(int executionTime) {
		this.executionTime = executionTime;
	}
}