/* $Id: ObsRun.java,v 1.27 2006/04/04 08:55:06 ddorigo Exp $ */

package org.eso.ohs.dfs;







/**
 * Observing Programme business object class.
 * <br>
 * 
 * @author Carlo Boarotto, 10-Mar-2000
 */
public class ObsRun extends BusinessObject {
    
  
    private static final long serialVersionUID = 1L;
    public static final int DEF_INVALID_RANK = -1; 
    public static final int DEF_RANK = -1; 
    public static int DEF_PROPRIETARY_PERIOD = 12;
   	public static int SHOWCOMMENT = 1;
   	public static int DONTSHOWCOMMENT = 0;

   	private boolean delayedInstrument_ = false;
   	
    private String note_ = "";
    private long runId_ = 0 ;
    private String status_ = "";
	private String telescope_ = "";
	private int period_ = 0;
    private String instrument_ = "";
    
    private String reqTime_ = "";
    private float grade_ = -1;
	private int intAssignedTime_ = -1;
    private float assignedTime_ = -1;
    private String scheduled_ = "";
    private String runDesc_ = "";
    private String runCode_ = "";
    private int rank_ = DEF_RANK;
    private int  proprietaryPeriod_= DEF_PROPRIETARY_PERIOD;
    private String obsMode_="";
    private String month_="";
    private String moon_="";
    private String seeing_ ="";
    private float sigma_=  0;
    private String skyTransparency_="";
    private long programmeId_ = -1;
    private int showCommentFlag_ = DONTSHOWCOMMENT;
//    private int suspended_ = 0;
    
    //----------------------------------------
    // Constructor
    //----------------------------------------

    /**
     * Create a ObsRun and set its id.
     */
    public ObsRun() {
	super();
    }


    //----------------------------------------
    // Public Methods
    //----------------------------------------




   /**
     * Set new value for property
     *
     * @param newValue the new value for the property
     */
    public void setProgrammeId(long newValue) {
	    programmeId_ = newValue;
	    //firePropertyChangeEvent();
    }


    /**
     * Get value for  property
     *
     * @return the current value of the property
     */
    public long getProgrammeId() {
	    return programmeId_;
    }



 /**
     * Set new value for property
     *
     * @param newValue the new value for the property
     */
    public void setTableId(long newValue) {
	    runId_ = newValue;
	    //firePropertyChangeEvent();
    }


    /**
     * Get value for  property
     *
     * @return the current value of the property
     */
    public long getTableId() {
        return runId_;
    } 
 


   public boolean isAlternate() {
      return getRunDesc().matches(".+/alt$");
   }

  /**
     * Set new value for telescope_ property
     *
     * @param newValue the new value for the property
     */
    public void setTelescope(String newValue) {
	    telescope_ = newValue;
	    //firePropertyChangeEvent();
    }


    /**
     * Get value for telescope_ property
     *
     * @return the current value of the property
     */
    public String getTelescope() {
	    return telescope_;
    }

/**
     * Set new value for telescope_ property
     *
     * @param newValue the new value for the property
     */
    public void setStatus(String newValue) {
	    status_ = newValue;
	    //firePropertyChangeEvent();
    }


    /**
     * Get value for telescope_ property
     *
     * @return the current value of the property
     */
    public String getStatus() {
	    return status_;
    }


  /**
     * Set new value for note_ property
     *
     * @param newValue the new value for the property
     */
    public void setNote(String newValue) {
	    note_ = newValue;
	    //firePropertyChangeEvent();
    }


    /**
     * Get value for note_ property
     *
     * @return the current value of the property
     */
    public String getNote() {
	    return note_;
    }



    /**
     * Set new value for instrument_ property
     *
     * @param newValue the new value for the property
     */
    public void setInstrument(String newValue) {
	    instrument_ = newValue;
	    //firePropertyChangeEvent();
    }


    /**
     * Get value for instrument_ property
     *
     * @return the current value of the property
     */
    public String getInstrument() {
	    return instrument_;
    }

    /**
     * Set new value for reqTime_ property
     *
     * @param newValue the new value for the property
     */
    public void setReqTime(String newValue) {
	    reqTime_ = newValue;
	    //firePropertyChangeEvent();
    }


    /**
     * Get value for reqTime_ property
     *
     * @return the current value of the property
     */
    public String getReqTime() {
	    return reqTime_;
    }


    /**
     * Get value for grade_ property
     *
     * @return the current value of the property
     */
    public void setGrade(float newValue) {
	grade_ = newValue;
	firePropertyChangeEvent();
    }


    /**
     * Get value for grade_ property
     *
     * @return the current value of the property
     */
    public float getGrade() {
	return grade_;
    }


    /**
     * Get value for nights_ property
     *
     * @return the current value of the property
     */
    public void setAssignedTime(float newValue) {
	assignedTime_ = newValue;
	firePropertyChangeEvent();
    }


    /**
     * Get value for nights_ property
     *
     * @return the current value of the property
     */
    public float getAssignedTime() {
	return assignedTime_;
    }


    /**
     * Get value for rank_ property
     *
     * @return the current value of the property
     */
    public void setProprietaryTime(int newValue) {
	proprietaryPeriod_ = newValue;
	firePropertyChangeEvent();
    }


    /**
     * Get value for rank_ property
     *
     * @return the current value of the property
     */
    public int getProprietaryTime() {
	return proprietaryPeriod_;
    }


    /**
     * Get value for rank_ property
     *
     * @return the current value of the property
     */
    public void setRank(int newValue) {
	rank_ = newValue;
	firePropertyChangeEvent();
    }


    /**
     * Get value for rank_ property
     *
     * @return the current value of the property
     */
    public int getRank() {
	return rank_;
    }



    /**
     * Get value for sched property
     *
     * @return the current value of the property
     */
    public String getScheduled() {
	return scheduled_;
    }



    /**
     * Get value for sched property
     *
     * @return the current value of the property
     */
    public void setScheduled(String newValue) {
	scheduled_ = newValue;
	firePropertyChangeEvent();
    }

    
    /**
     * Get value for run_desc property
     *
     * @return the current value of the property
     */
    public String getRunDesc() {
	return runDesc_;
    }



    /**
     * Get value for run desc property
     *
     * @return the current value of the property
     */
    public void setRunDesc(String newValue) {
	runDesc_ = newValue;
	firePropertyChangeEvent();
    }


    /**
     * Get value for run code property
     *
     * @return the current value of the property
     */
    public String getRunCode() {
	return runCode_;
    }



    /**
     * Get value for run code property
     *
     * @return the current value of the property
     */
    public void setRunCode(String newValue) {
	runCode_ = newValue;
	firePropertyChangeEvent();
    }


    /**
     * Get value for obsMode_ property
     *
     * @return the current value of the property
     */
    public void setObsMode(String newValue) {
	obsMode_ = newValue;
	firePropertyChangeEvent();
    }


    /**
     * Get value for obsMode_ property
     *
     * @return the current value of the property
     */
    public String getObsMode() {
	return obsMode_;
    }


    /**
     * Set new value for month_ property
     *
     * @param newValue the new value for the property
     */
    public void setMonth(String newValue) {
	    month_ = newValue;
	    //firePropertyChangeEvent();
    }


    /**
     * Get value for month_ property
     *
     * @return the current value of the property
     */
    public String getMonth() {
	    return month_;
    }


    /**
     * Set new value for moon_ property
     *
     * @param newValue the new value for the property
     */
    public void setMoon(String newValue) {
	    moon_ = newValue;
	    //firePropertyChangeEvent();
    }


    /**
     * Get value for moon_ property
     *
     * @return the current value of the property
     */
    public String getMoon() {
	    return moon_;
    }


    /**
     * Set new value for seeing_ property
     *
     * @param newValue the new value for the property
     */
    public void setSeeing(String newValue) {
	    seeing_ = newValue;
	    //firePropertyChangeEvent();
    }


    /**
     * Get value for seeing_ property
     *
     * @return the current value of the property
     */
    public String getSeeing() {
	    return seeing_;
    }

    /**
     * Get value for sigma_ property
     *
     * @return the current value of the property
     */
    public void setSigma(float newValue) {
	sigma_ = newValue;
	firePropertyChangeEvent();
    }


    /**
     * Get value for sigma_ property
     *
     * @return the current value of the property
     */
    public float getSigma() {
	return sigma_;
    }


    /**
     * Set new value for skyTransparency_ property
     *
     * @param newValue the new value for the property
     */
    public void setSkyTransparency(String newValue) {
	    skyTransparency_ = newValue;
	    //firePropertyChangeEvent();
    }


    /**
     * Get value for skyTransparency_ property
     *
     * @return the current value of the property
     */
    public String getSkyTransparency() {
	    return skyTransparency_;
    }


    public Object accept(BusinessVisitor v, Object arg) {
	return null;
    }


	/**
	 * @param showComment
	 */
	public void setShowCommentFlag(int showComment) {
		showCommentFlag_ = showComment;		
	}
    
    public int getShowCommentFlag() {
    	return showCommentFlag_;
    }    
    /**
     * @see org.eso.ohs.dfs.StorableObject#postProecess()
     */
    public void postProecess() {
    }

	public void setPeriod(int period_) {
		this.period_ = period_;
	}

	public int getPeriod() {
		return period_;
	}


	/**
	 * @param i
	 */
	public void setDBAssignedTime(int assignedTime) {
		intAssignedTime_ = assignedTime;
		
	}
	/**
	 * @param i
	 */
	public int getDBAssignedTime() {
		return intAssignedTime_ ;
		
	}


	
	/**
	 * 
	 * @return boolean
	 */
	public boolean isDelayedInstrument() {
	
		return delayedInstrument_;
	}
	
	public void setDelayedInstrument(boolean delayedInstrument_) {
		this.delayedInstrument_ = delayedInstrument_;
	}






    /**
     * @param runDesc void
     */
    public String buildRunCode(String runDesc) {
        String runCodeString = getRunCode();
        runCodeString.trim();
        int strlen = runCodeString.length();
        String run_code = runCodeString
                .substring(0, strlen - 3)
                + "(" + runDesc + ")";
        return run_code;
    }	
	
}