package org.eso.ohs.dfs;

import org.eso.ohs.core.dbb.client.DbbDataType;

public class ProposalType implements DbbDataType {

/**
	 * 
	 */
	private static final long serialVersionUID = 906641704002856525L;
public static final Integer LARGE_INT = new Integer(4);
	public static final Integer TOO_INT = new Integer(3);
	public static final Integer DDT_INT = new Integer(2);
	public static final Integer GTO_INT = new Integer(1);
	public static final Integer NORMAL_INT = new Integer(0);
	public static final String NORMAL = "NORMAL";
	public static final String GTO = "GTO";
	public static final String TOO = "TOO";
	public static final String LARGE = "LARGE";
	public static final String DDT = "DDT";
	public static final String[] PROPOSAL_TYPES =
		{ NORMAL, GTO, DDT, TOO, LARGE };
	public static final Integer[] PROPOSAL_VALUES =
		{ NORMAL_INT, GTO_INT, DDT_INT, TOO_INT, LARGE_INT };
	public static final String[] PROPOSAL_TYPES_PANELTOOL =
	{ NORMAL, GTO, TOO, LARGE };
public static final Integer[] PROPOSAL_VALUES_PANELTOOL =
	{ NORMAL_INT, GTO_INT, TOO_INT, LARGE_INT };

	private final static String DEFAULT_ = "--------";

	public int getDataTypeLength() {
		return DEFAULT_.length();
	}

	public Class getDataType() {
		return String.class;
	}

	public Class getDatabaseType() {
		return Integer.class;
	}

	public String fromDatabaseData(Object value) {

		Integer val = (Integer) value;
		int i = val.intValue();

		if (i > 0 && i < PROPOSAL_TYPES.length)
			return PROPOSAL_TYPES[i];

		return PROPOSAL_TYPES[0];
	}

	public Object toDatabaseData(String value) {

		int val = convertTypeFromStringToInt(value);

		return (new Integer(val));
	}

	/**
	 * @param value
	 * @return
	 */
	public static int convertTypeFromStringToInt(String value) {
		int val = 0;

		if (value != null) {

			value = value.trim();

			for (int i = 0; i < PROPOSAL_TYPES.length; i++)
				if (PROPOSAL_TYPES[i].equals(value)) {
					val = i;
					break;
				}
		}
		return val;
	}
	
  
	
}
