package org.eso.ohs.instruments;

import java.io.Serializable;


/** 
 * This object gets written to disk so the appserver 
 * can work out if the version of the template has changed.
 *
 * <p>
 * $Id: TemplateVersionInfo.java,v 1.7 2003/07/03 08:49:49 ddorigo Exp $
 * @author Tim Canavan
 */

public class TemplateVersionInfo implements Serializable {

    /** Version id for object serialization */
    static final long serialVersionUID = -275992709459242698L;


    /** Version of template 1.0 etc..*/


    private float version_ = -1;

    /** Name of instrument associated with template*/

    private String instrumentName_;

    /** Template name */

    private String templateName_;

    /**
     * Get value for template name
     * @return template name
     */

    public String getTemplateName() {
        return templateName_;
    }

    /**
     * Get value for instrument name
     * @return instrument name
     */

    public String getInstrumentName() {
        return instrumentName_;
    }

    /**
     * Get version of template
     * @return version
     */

    public float getVersion() {
        return version_;
    }

    /**
     * Set template name
     * @param templateName template name
     */

    public void setTemplateName(String templateName) {
        templateName_ = templateName;
    }

    /**
     * Set instrument name
     * @param instrumentName instrument name
     */

    public void setInstrumentName(String instrumentName) {
        instrumentName_ = instrumentName;
    }

    /**
     * Set version
     * @param versiob version
     */
   
    public void setVersion(float version) {
        version_ = version;
    }

}
