package org.eso.ohs.persistence.dao;

import java.util.Collection;
import java.util.Iterator;

import org.eso.ohs.dfs.account.Account;
import org.eso.ohs.dfs.account.Profile;
import org.springframework.mail.MailException;
import org.springframework.mail.MailSender;
import org.springframework.mail.SimpleMailMessage;

public class AccountEmailImpl implements AccountEmail {
	
	private MailSender mailSender;
	
	private SimpleMailMessage mailMessage;

	public void sendAccountEmail(Account account) throws MailException {
		
		Collection profiles = account.getProfile();
		Iterator it = profiles.iterator();
		Profile accProfile=null;
		while(it.hasNext()) {
			accProfile = (Profile)it.next();
			if(accProfile.getDefaultProfile() == Boolean.TRUE ) {
			    break;	
			}
		}		
		mailMessage.setTo(accProfile.getEmailAddress());
		mailSender.send(mailMessage);					 
	}

	public MailSender getMailSender() {
		return mailSender;
	}

	public void setMailSender(MailSender mailSender) {
		this.mailSender = mailSender;
	}

	public SimpleMailMessage getMailMessage() {
		return mailMessage;
	}

	public void setMailMessage(SimpleMailMessage mailMessage) {
		this.mailMessage = mailMessage;
	}

}
