package org.eso.ohs.persistence.dao;

import org.eso.ohs.dfs.phase1.EsoUsersRoles;
import org.springframework.dao.DataAccessException;

/**
 * @author fsogni
 * This interface is the main interface to the gto_managers table in the opc70 database
 * This table represents the db interface for the gto_managers business object.  
 */


public interface EsoUsersRolesDAO {
	
	/**
	 * Find a eso user role based upon
	 * the predefined attributes
	 * @param esoUserRole
	 * @return
	 * @throws DataAccessException
	 */
     
	public EsoUsersRoles find(EsoUsersRoles esoUserRole) throws DataAccessException;
	
	
	/**
	 * Create an eso user role
	 * @param esoUserRole
	 * @throws DataAccessException
	 */
	
    public void create(EsoUsersRoles esoUserRole) throws DataAccessException;
    
    /**
     * Update an eso user role. This expects the database
     * id to be initialised. 
     * @param esoUserRole
     * @throws DataAccessException
     */
    
    public void update(EsoUsersRoles esoUserRole) throws DataAccessException;
    
    /**
     * Delete an eso user role from the database. 
     * @param esoUserRole
     * @throws DataAccessException
     */
    
    public void delete(EsoUsersRoles esoUserRole) throws DataAccessException;
	
}
