/**
 * 
 */
package org.eso.ohs.persistence.dao;

import java.util.List;

import org.eso.ohs.dfs.phase1.InstrumentConfig;
import org.springframework.dao.DataAccessException;
import org.springframework.orm.hibernate3.HibernateTemplate;

/**
 * @author fsogni
 *
 */
public class InstrumentConfigDAOHibernate implements InstrumentConfigDAO {
	
	
	private HibernateTemplate hibernateTemplate;

	/* (non-Javadoc)
	 * @see org.eso.ohs.persistence.dao.InstrumentConfigDAO#find(org.eso.ohs.dfs.phase1.InstrumentConfig)
	 */
	public InstrumentConfig find(InstrumentConfig instConfig)
			throws DataAccessException {
        Object [] tokens = new Object[3];
        tokens[0] = instConfig.getMode();
        tokens[1] = instConfig.getOffered().getId().getInstrumentCode();
        tokens[2] = instConfig.getOffered().getId().getCycleId();     
        
         List l = hibernateTemplate.find("from InstrumentConfig instConf " +
         		" WHERE instConf.mode = ? " + 
                " AND instConf.offered.id.instrumentCode = ? " +
                " AND instConf.offered.id.cycleId = ?" 
                ,tokens);

        if(l.size() > 1) {
            throw new IllegalArgumentException("Duplicate username in system");            
        }
        
        if(l.size() < 1) {
            throw new IllegalArgumentException("No rows");            
        }
        
        InstrumentConfig config = (InstrumentConfig)l.get(0);
        return config;
	}

	


	public List findByCycleIdInstrument(Integer cycleId, String instrument) throws DataAccessException {
		
		Object[] tokens = new Object[2];
		tokens[0] = cycleId;
		tokens[1] = instrument;
		List instrumentConfigList = hibernateTemplate.findByNamedQuery("findInstConfByCycleIdInstrument", tokens);
		 if(instrumentConfigList.size() < 1) {
	            throw new IllegalArgumentException("No rows");            
	        }
		 return instrumentConfigList;
	}
	
	
	/* (non-Javadoc)
	 * @see org.eso.ohs.persistence.dao.InstrumentConfigDAO#create(org.eso.ohs.dfs.phase1.InstrumentConfig)
	 */
	public void create(InstrumentConfig instConfig) throws DataAccessException {
	     hibernateTemplate.saveOrUpdate(instConfig);
	}

	/* (non-Javadoc)
	 * @see org.eso.ohs.persistence.dao.InstrumentConfigDAO#update(org.eso.ohs.dfs.phase1.InstrumentConfig)
	 */
	public void update(InstrumentConfig instConfig) throws DataAccessException {
		// TODO Auto-generated method stub

	}

	/* (non-Javadoc)
	 * @see org.eso.ohs.persistence.dao.InstrumentConfigDAO#delete(org.eso.ohs.dfs.phase1.InstrumentConfig)
	 */
	public void delete(InstrumentConfig instConfig) throws DataAccessException {
		
		hibernateTemplate.delete(instConfig);
	}

	/**
	 * @return Returns the hibernateTemplate.
	 */
	public HibernateTemplate getHibernateTemplate() {
		return hibernateTemplate;
	}

	/**
	 * @param hibernateTemplate The hibernateTemplate to set.
	 */
	public void setHibernateTemplate(HibernateTemplate hibernateTemplate) {
		this.hibernateTemplate = hibernateTemplate;
	}





}
