package org.eso.ohs.persistence.dao;

import java.util.List;

import org.eso.ohs.dfs.phase1.GtoConflicts;
import org.springframework.dao.DataAccessException;

/**
 * @author gdonino
 * This interface is the main interface to the offered table in the opc70 database
 */


public interface OfferedDAO {
	
	/**
	 * Find a ProposalGtoConflicts observation based upon
	 * the predefined attributes. Returns these attributes and the database id.
	 * @param proposalGtoConflict
	 * @return
	 * @throws DataAccessException
	 */
     
	public List find(GtoConflicts gtoConflict) throws DataAccessException;
	
	
	
	/**
	 * Retrieve a specific object (it has to contain a valid id)
	 * @param proposalGtoConflict
	 * @return
	 * @throws DataAccessException
	 */
     
	public List findById(GtoConflicts gtoConflict) throws DataAccessException;
	
	
	/**
	 * Find a ProposalGtoConflicts based on the summary id
	 * Returns an observation object
	 * @param gtoObservation
	 * @return
	 * @throws DataAccessException
	 */
     
}