/**
 * 
 */
package org.eso.ohs.persistence.dao;

import java.util.List;

import org.eso.ohs.dfs.phase1.ProposalGtoConflicts;
import org.springframework.dao.DataAccessException;
import org.springframework.orm.hibernate3.HibernateTemplate;

/**
 * @author fsogni
 *
 */
public class ProposalGtoConflictsDAOHibernate implements ProposalGtoConflictsDAO {

	
	private HibernateTemplate hibernateTemplate;


	/**
	 * @return Returns the hibernateTemplate.
	 */
	public HibernateTemplate getHibernateTemplate() {
		return hibernateTemplate;
	}

	/**
	 * @param hibernateTemplate The hibernateTemplate to set.
	 */
	public void setHibernateTemplate(HibernateTemplate hibernateTemplate) {
		this.hibernateTemplate = hibernateTemplate;
	}

	
	public List find(ProposalGtoConflicts proposalGtoConflict) throws DataAccessException {
		
		Object [] paramArray = new Object[5];
		paramArray[0] = proposalGtoConflict.getId().getSummaryId();
		paramArray[1] = proposalGtoConflict.getId().getTargetId();
		paramArray[2] = proposalGtoConflict.getId().getGtoId();
		paramArray[3] = proposalGtoConflict.getTargetsDistance();
		paramArray[4] = proposalGtoConflict.getExptimeRatio();
		
		List l = hibernateTemplate.findByNamedQuery("findProposalGtoConflictsByProperties",paramArray);
		if(l.size() <=0) {
			throw new IllegalArgumentException("Not found");
		}
		return l;
		
	}
	
	
	/* (non-Javadoc)
	 * @see org.eso.ohs.persistence.dao.GtoObservationsDAO#find(org.eso.ohs.dfs.phase1.GtoObservations)
	 */
	public List findById(ProposalGtoConflicts proposalGtoConflict)
			throws DataAccessException {
		
		
		Object [] paramArray = new Object[3];
		paramArray[0] = proposalGtoConflict.getId().getSummaryId();
		paramArray[1] = proposalGtoConflict.getId().getTargetId();
		paramArray[2] = proposalGtoConflict.getId().getGtoId();
		
		
		List l = hibernateTemplate.findByNamedQuery("findProposalGtoConflictsById",paramArray);
		if(l.size() <=0) {
			throw new IllegalArgumentException("Not found");
		}
		return l;
		
	}

public List findBySummaryId(Integer summaryId) throws DataAccessException {
		
		Object [] paramArray = new Object[1];
		paramArray[0] = summaryId; 
		List l = hibernateTemplate.findByNamedQuery("findProposalGtoConflictsBySummaryId",paramArray);
		if(l.size() <=0) {
			throw new IllegalArgumentException("Not found");
		}
			
		return l;
	}
	


	/* (non-Javadoc)
	 * @see org.eso.ohs.persistence.dao.GtoObservationsDAO#create(org.eso.ohs.dfs.phase1.GtoObservations)
	 */
	public void create(ProposalGtoConflicts proposalGtoConflict)
			throws DataAccessException {
		
		
		hibernateTemplate.saveOrUpdate(proposalGtoConflict);
	

	}

	/* (non-Javadoc)
	 * @see org.eso.ohs.persistence.dao.GtoObservationsDAO#update(org.eso.ohs.dfs.phase1.GtoObservations)
	 */
	public void update(ProposalGtoConflicts proposalGtoConflict)
			throws DataAccessException {
		// TODO Auto-generated method stub

	}

	/* (non-Javadoc)
	 * @see org.eso.ohs.persistence.dao.GtoObservationsDAO#delete(org.eso.ohs.dfs.phase1.GtoObservations)
	 */
	public void delete(ProposalGtoConflicts proposalGtoConflict)
			throws DataAccessException {
		
		hibernateTemplate.delete(proposalGtoConflict);

	}

	

	

	

	

}
