package org.eso.ohs.persistence.dao;

import java.util.List;

import org.eso.ohs.dfs.account.Title;
import org.springframework.dao.DataAccessException;
import org.springframework.orm.hibernate3.HibernateTemplate;

public class TitleDAOHibernate implements TitleDAO {
	
	private HibernateTemplate hibernateTemplate;
	
    public TitleDAOHibernate() {
    }
	
    
    /**
     * 
     */
	
	public List getTitleList() throws DataAccessException {
		List list = hibernateTemplate.loadAll(Title.class);
		return list;
	}
    
    /**
     * Getter for the hibernate template.
     * @return
     */

	public HibernateTemplate getHibernateTemplate() {
		return hibernateTemplate;
	}
    
    /**
     * Setter for the hibernate template.
     * @param hibernateTemplate
     */

	public void setHibernateTemplate(HibernateTemplate hibernateTemplate) {
		this.hibernateTemplate = hibernateTemplate;
	}


    /**
     * @see 
     */
    
    
    public Title find(String titleName) throws DataAccessException,TitleNotFoundException {
        String [] tokens = new String[1];
        tokens[0] = titleName;  
        List l = hibernateTemplate.find("from Title Title where Title.title = ?",tokens);
        if(l.size() <= 0) {
              throw new TitleNotFoundException("Title not found " + titleName);
        }
        Title title = (Title)l.get(0);
        return title;

    }
    
}
