/* $Id: Phase1SelectStmt.java,v 1.15 2006/04/26 08:05:11 ddorigo Exp $ */
package org.eso.ohs.persistence.dbase.phase1;

import java.util.Calendar;

import org.eso.ohs.core.dbb.sql.DbbSqlTable;
import org.eso.ohs.core.utilities.TextUtils;
import org.eso.ohs.dfs.Affiliation;
import org.eso.ohs.persistence.ProposalSummaryStatus;

/**
 * It contains the select statements used in the phase1 application
 * 
 * @author ddorigo
 */
public class Phase1SelectStmt {
    protected static final int TRUNCATE_TEXT_LENGTH = 255;

    private static String QUESTION_MARK = " ? ";

    public static void setQuestionMark(String q) {
        QUESTION_MARK = q;
    }

    public static String getQuestionMark() {
        return QUESTION_MARK;
    }

    /**
     * Field refStarTable
     */
    public static DbbSqlTable refStarTable = new DbbSqlTable("reference_stars");

    /**
     * Field runSchedReqTable
     */
    public static DbbSqlTable runSchedReqTable = new DbbSqlTable(
            "run_sched_requirements");

    /**
     * Field runTimingConstrTable
     */
    public static DbbSqlTable runTimingConstrTable = new DbbSqlTable(
            "run_timing_constraints");

    /**
     * Field runLinksTable
     */
    public static DbbSqlTable runLinksTable = new DbbSqlTable("run_links");

    /**
     * Field instConfTable
     */
    public static DbbSqlTable instConfTable = new DbbSqlTable("ins_setup");

    /**
     * Field propSummaryLogTable
     */
    public static DbbSqlTable propSummaryLogTable = new DbbSqlTable(
            "proposal_log");

    /**
     * Field USER_ROLE
     */
    public static String[] USER_ROLE =
    { "user" };
    
 
    /** Rated database join table. */
    public final static DbbSqlTable ratedTable = new DbbSqlTable("rated");

    /**
     * Field commentsTable
     */
    public final static DbbSqlTable commentsTable = new DbbSqlTable("comments");

    public final static DbbSqlTable obsBlocksTable = new DbbSqlTable(
            "obs_blocks");

    /**
     * Field proposalSummaryTable
     */
    public final static DbbSqlTable proposalSummaryTable = new DbbSqlTable(
            "proposal_summary");

    /**
     * Field proposalSummaryTable
     */
    public final static DbbSqlTable figureSummaryTable = new DbbSqlTable(
            "proposal_pictures");

    /**
     * Field proposalSummaryTable
     */
    public final static DbbSqlTable textFieldsTable = new DbbSqlTable(
            "text_fields");

    /**
     * Field runCommentTable
     */
    public final static DbbSqlTable runCommentTable = new DbbSqlTable(
            "run_comment");

    /**
     * Field programmesTable
     */
    public final static DbbSqlTable programmesTable = new DbbSqlTable(
            "obs_programmes");
    public final static DbbSqlTable programmesTableView = new DbbSqlTable(
    "obs_programmes_view");

    /**
     * Field runsTable
     */
    public final static DbbSqlTable runsTable = new DbbSqlTable("obs_runs");

    /**
     * Field telescopeTable
     */
    public final static DbbSqlTable telescopeTable = new DbbSqlTable(
            "opc_telescopes");

    /**
     * Field instrumentTable
     */
    public final static DbbSqlTable instrumentTable = new DbbSqlTable(
            "opc_instruments");

    /**
     * Field offeredTable
     */
    public final static DbbSqlTable offeredTable = new DbbSqlTable("offered");
   
    /**
     * Field gto_instruments
     */
    public final static DbbSqlTable gtoInstrTable = new DbbSqlTable("gto_instruments");
   
    /**
     * Field instrument_config
     */
    public final static DbbSqlTable gtoInstrConfigTable = new DbbSqlTable("instrument_config");

    /**
     * Field usersTable
     */
    public final static DbbSqlTable usersTable = new DbbSqlTable("eso_users");

    /**
     * Field usersRolesTable
     */
    public final static DbbSqlTable usersRolesTable = new DbbSqlTable(
            "eso_users_roles");

    /**
     * Field usersViewTable
     */
    public final static DbbSqlTable usersViewTable = new DbbSqlTable(
            "users_view");

    /**
     * Field esoUsersRolesTable
     */
    public final static DbbSqlTable esoUsersRolesTable = new DbbSqlTable(
            "eso_users_roles");

    /**
     * Field schedRepTable
     */
    public final static DbbSqlTable schedRepTable = new DbbSqlTable("sched_rep");

    /**
     * Field proposedTable
     */
    public final static DbbSqlTable proposedTable = new DbbSqlTable("proposed");

    /**
     * Field proposedTable
     */
    public final static DbbSqlTable proposalOutputTable = new DbbSqlTable(
            "proposalOut");

    /**
     * Field affiliationsTable
     */
    public final static DbbSqlTable affiliationsTable = new DbbSqlTable(
            "user_affiliations");

    /**
     * Field targetsTable
     */
    public final static DbbSqlTable targetsTable = new DbbSqlTable("targets");

    /**
     * Field vltiTargetsTable
     */
    public final static DbbSqlTable vltiTargetsTable = new DbbSqlTable(
            "vlti_targets");

    /**
     * Field targetsTable
     */
    public final static DbbSqlTable runTargetsTable = new DbbSqlTable(
            "vlti_target_runs");

    /**
     * Field figuresTable
     */
    public final static DbbSqlTable figuresTable = new DbbSqlTable("figures");

    /**
     * Field latexTable
     */
    public final static DbbSqlTable latexTable = new DbbSqlTable("latex_source");

    /**
     * Field cutoffTable
     */
    public final static DbbSqlTable cutoffTable = new DbbSqlTable("opc_cutoff");

    /**
     * Field cyclesTable
     */
    public final static DbbSqlTable cyclesTable = new DbbSqlTable("cycles");

    /**
     * Field cyclePropertiesTable
     */
    public final static DbbSqlTable cyclePropertiesTable = new DbbSqlTable(
            "cycle_properties");

    /**
     * Field stepsTable
     */
    public final static DbbSqlTable stepsTable = new DbbSqlTable("steps");

    /**
     * Field refereesTable
     */
    public final static DbbSqlTable refereesTable = new DbbSqlTable("referees");

    /**
     * Field refAvgView
     */
    public final static DbbSqlTable refAvgView = new DbbSqlTable("referee_avg");

    /**
     * Field htmlFragTable
     */
    public final static DbbSqlTable htmlFragTable = new DbbSqlTable(
            "html_fragment");

    //MIPS requirement - Instrument Package Versioning
    /**
     * Field ipPeriodsTable
     */
    public final static DbbSqlTable ipPeriodsTable = new DbbSqlTable("obrep2",
            "ip_periods");

    /**
     * Field proposedTable
     */
    public final static DbbSqlTable proposalOutputVerifyTable = new DbbSqlTable(
            "proposalOutVerify");

    
    
    /**
     * Field beginTransaction
     */
    public static final String beginTransaction = " ";

    /**
     * Field commitTransaction
     */
    public static final String commitTransaction = " COMMIT ";

    /**
     * Method selProgrammePanels
     * 
     * @return String
     */
    public static String selProgrammePanels() {
        StringBuffer stmt = new StringBuffer();
        stmt.append("SELECT DISTINCT  panel ").append(" FROM ").append(
                programmesTableView.get()).append(" ").append(
                " WHERE panel != ' ' ").append(" ORDER by panel");
        return stmt.toString();
    } 
    
    /**
     * Method selProgrammePanels
     * 
     * @return String
     */
    public static String selProgrammeIdFromCycle(int cycleId) {
        StringBuffer stmt = new StringBuffer();
        stmt.append("SELECT DISTINCT  id ").append(" FROM ").append(
                programmesTable.get()).append(" ").append(
                " WHERE cycle_id = ").append(cycleId);
        return stmt.toString();
    }

    /**
     * Method selProgrammePanels
     * 
     * @param period
     *            String
     * @return String
     */
    public static String selProgrammePanels(String period) {
        StringBuffer stmt = new StringBuffer();
        stmt.append("SELECT DISTINCT  panel ").append(" FROM ").append(
                programmesTableView.get()).append(" ").append(
                " WHERE panel != ' ' ");
        if (!period.equals("()")) {
            stmt = stmt.append(" AND ").append(programmesTableView.get()).append(
                    ".period in ").append(period);
        }
        stmt = stmt.append(" ORDER by panel");
        return stmt.toString();
    }

    /**
     * Method selAllSubPanels
     * 
     * @return String
     */
    public static String selAllSubPanels() {
        StringBuffer stmt = new StringBuffer();
        stmt
                .append("SELECT DISTINCT  subpanel ")
                .append(" FROM ")
                .append(programmesTable.get())
                .append(" ")
                .append(" WHERE panel != ' ' ")
                .append(" AND subpanel != NULL ")
                .append(" ORDER by subpanel");
        return stmt.toString();
    }

    /**
     * Method selAllOpcSubpanel
     * 
     * @return String
     */
    public static String selAllOpcSubpanel() {
        StringBuffer stmt = new StringBuffer();
        stmt.append("SELECT DISTINCT  opc_subpanel ").append(" FROM ").append(
                programmesTable.get()).append(" ").append(
                " WHERE panel != ' ' ").append(" ORDER by opc_subpanel");
        return stmt.toString();
    }

    /**
     * Field orderByReferee
     */
    private static final String orderByReferee = "ORDER BY chair desc\n";

    /**
     * Method selRefereeAvgPeriods
     * 
     * @return String
     */
    public static String selRefereeAvgPeriods() {
        StringBuffer stmt = new StringBuffer();
        stmt.append("SELECT DISTINCT run = run_id/1000000 from ").append(
                Phase1SelectStmt.refAvgView.get());
        return stmt.toString();
    }

    /**
     * Method selAllModes
     * 
     * @return String
     */
    public static String selAllModes() {
        StringBuffer stmt = new StringBuffer();
        stmt
                .append("SELECT DISTINCT obs_mode from  ")
                .append(Phase1SelectStmt.runsTable.get())
                .append(" where id > 68000000");
        return stmt.toString();
    }

    /**
     * Method selAllAffiliations
     * 
     * @return String
     */
    public static String selAllAffiliations() {
        StringBuffer stmt = new StringBuffer();
        stmt.append("SELECT DISTINCT country_code from ").append(
                affiliationsTable.get());
        return stmt.toString();
    }

    /**
     * Method selAllCycles
     * 
     * @return String
     */
    public static String selAllCycles() {
        StringBuffer stmt = new StringBuffer();
        stmt
                .append("SELECT id ")
                .append(" FROM ")
                .append(cyclesTable.get())
                .append(" ")
                .append(" ORDER BY id DESC");
        return stmt.toString();
    }

    /**
     * Method selAllCyclesLabel
     * 
     * @return String
     */
    public static String selAllCyclesLabel() {
        StringBuffer stmt = new StringBuffer();
        stmt
                .append("SELECT label ")
                .append(" FROM ")
                .append(cyclesTable.get())
                .append(" ")
                .append(" ORDER BY label DESC");
        return stmt.toString();
    }

    /**
     * Method wcAllCycles
     * 
     * @return String
     */
    public static String wcAllCycles() {
        StringBuffer stmt = new StringBuffer();
        stmt.append(cyclesTable.get()).append(".period > 0").append(
                " ORDER BY period DESC, label ASC  ");
        return stmt.toString();
    }

    /**
     * Method wcAllSteps
     * 
     * @return String
     */
    public static String wcAllSteps() {
        StringBuffer stmt = new StringBuffer();
        stmt.append(stepsTable.get()).append(" ORDER BY id DESC, label ASC  ");
        return stmt.toString();
    }

    /**
     * Method selAllTelescopes
     * 
     * @return String
     */
    public static String selAllTelescopes() {
        StringBuffer stmt = new StringBuffer();
        stmt.append("SELECT  code ").append(" FROM ").append(
                telescopeTable.get());
        return stmt.toString();
    }

    /**
     * Method selAllCutOffTelescopes
     * 
     * @param cycleId
     *            long
     * @return String
     */
    public static String selAllCutOffTelescopes(long cycleId) {
        StringBuffer stmt = new StringBuffer();
        stmt
                .append("SELECT DISTINCT  ")
                .append(runsTable.get())
                .append(".tel_code ")
                .append(" FROM ")
                .append(runsTable.get())
                .append(", ")
                .append(programmesTable.get())
                .append(" ")
                .append(" WHERE  ")
                .append(programmesTable.get())
                .append(".id = ")
                .append(runsTable.get())
                .append(".programme_id ")
                .append("\n AND ")
                .append(programmesTable.get())
                .append(".cycle_id = ")
                .append(cycleId)
                .append("\n AND ")
                .append(programmesTable.get())
                .append(".ignored = 0");
        return stmt.toString();
    }
    /**
     * Method selAllCutOffTelescopes
     * 
     * @param cycleId
     *            long
     * @return String
     */
    public static String selAllAllocatedTelescopes() {
        StringBuffer stmt = new StringBuffer();
        stmt
                .append("SELECT DISTINCT  ")
                .append(cutoffTable.get())
                .append(".code ")
                .append(" FROM ")
                .append(cutoffTable.get())
                .append(" ");
        return stmt.toString();
    }
    
    public static String selAllocatedValue(String telescope, String panelData) {
        StringBuffer stmt = new StringBuffer();
        stmt
                .append("SELECT DISTINCT  ")
                .append(cutoffTable.get())
                .append(".cutoff ")
                .append(" FROM ")
                .append(cutoffTable.get())
                .append(" ")
                .append(" WHERE  ")
                .append(cutoffTable.get())
                .append(".code = '")
                .append(telescope)
                .append("' ")
                .append("\n AND ")
                .append(cutoffTable.get())
                .append(".category = '")
                .append(panelData.charAt(0))
                .append("' \n AND ")
                .append(cutoffTable.get())
                .append(".opc_subpanel = ")
                .append(Integer.parseInt(panelData.substring(1)))
                .append(" ");
        return stmt.toString();
    }
    
    /**
     * Method selAllCutOffTelescopes
     * 
     * @param cycleId
     *            long
     * @return String
     */
    public static String selAllAllocatedPanels() {
        StringBuffer stmt = new StringBuffer();
        stmt
                .append("SELECT DISTINCT  convert(varchar, ")
                .append(cutoffTable.get())
                .append(".category) + convert(varchar,")
                .append(cutoffTable.get())
                .append(".opc_subpanel) ")
                .append(" FROM ")
                .append(cutoffTable.get())
                .append(" ") .append(" WHERE  ")
                .append(cutoffTable.get())
                .append(".opc_subpanel >=0")
                ;
        return stmt.toString();
    }

    /**
     * Method selAllCutOffSubPanels
     * 
     * @param cycleId
     *            long
     * @return String
     */
    public static String selAllCutOffSubPanels(long cycleId) {
        StringBuffer stmt = new StringBuffer();
        stmt.append("SELECT DISTINCT  opc_subpanel ").append(" FROM ").append(
                cutoffTable.get()).append(" ").append(
                " WHERE opc_subpanel != NULL ");
        return stmt.toString();
    }

    /**
     * Method selAllObservatory
     * 
     * @return String
     */
    public static String selAllObservatory() {
        StringBuffer stmt = new StringBuffer();
        stmt.append("SELECT DISTINCT  observatory ").append(" FROM ").append(
                telescopeTable.get());
        return stmt.toString();
    }

    /**
     * Method defineTableDb
     * 
     * @param dbName
     *            String
     * @param dbOwner
     *            String
     */
    public static void definePhase1TableDb(String dbName, String dbOwner) {
        DbbSqlTable[] tables =
        { runLinksTable, instConfTable, runTimingConstrTable, runSchedReqTable,
                refStarTable, runCommentTable, commentsTable, textFieldsTable,
                ratedTable, programmesTable, runsTable, usersTable,
                proposedTable, affiliationsTable, targetsTable, figuresTable,
                cutoffTable, telescopeTable, cyclesTable, stepsTable,
                refereesTable, esoUsersRolesTable, schedRepTable,
                vltiTargetsTable, runTargetsTable, offeredTable,gtoInstrConfigTable,gtoInstrTable,
                instrumentTable, cyclePropertiesTable,proposalOutputVerifyTable ,figureSummaryTable};
        for (int i = 0; i < tables.length; i++) {
            tables[i].setDatabase(dbName);
            tables[i].setOwner(dbOwner);
        }
    }

    /**
     * Method defineTableDb
     * 
     * @param dbName
     *            String
     * @param dbOwner
     *            String
     */
    public static void definePhase2TableDb(String dbName, String dbOwner) {
        DbbSqlTable[] tables =
        { obsBlocksTable };
        for (int i = 0; i < tables.length; i++) {
            tables[i].setDatabase(dbName);
            tables[i].setOwner(dbOwner);
        }
    }

    /**
     * Method selPeriodFromCycle
     * 
     * @param cycleLabel
     *            String
     * @return String
     */
    public static final String selPeriodFromCycle(String cycleLabel) {
        StringBuffer stmt = new StringBuffer();
        stmt
                .append("SELECT DISTINCT  period ")
                .append(" FROM ")
                .append(cyclesTable.get())
                .append(" ")
                .append(" WHERE ")
                .append(cyclesTable.get())
                .append(".label = '")
                .append(cycleLabel)
                .append("' ");
        return stmt.toString();
    }

    /**
     * Method selCycleIdFromLabel
     * 
     * @param cycleLabel
     *            String
     * @return String
     */
    public static final String selCycleIdFromLabel(String cycleLabel) {
        StringBuffer stmt = new StringBuffer();
        stmt
                .append("SELECT id ")
                .append(" FROM ")
                .append(cyclesTable.get())
                .append(" ")
                .append(" WHERE ")
                .append(cyclesTable.get())
                .append(".label = '")
                .append(cycleLabel)
                .append("' ");
        return stmt.toString();
    }

    /**
     * Method selCycleLabel
     * 
     * @param cycleId
     *            int
     * @return String
     */
    public static final String selCycleLabel(int cycleId) {
        StringBuffer stmt = new StringBuffer();
        stmt
                .append("SELECT label ")
                .append(" FROM ")
                .append(cyclesTable.get())
                .append(" ")
                .append(" WHERE ")
                .append(cyclesTable.get())
                .append(".id = ")
                .append(cycleId);
        return stmt.toString();
    }

    /**
     * Method selPeriodFromCycleId
     * 
     * @param cycleId
     *            int
     * @return String
     */
    public static final String selPeriodFromCycleId(int cycleId) {
        StringBuffer stmt = new StringBuffer();
        stmt.append("SELECT DISTINCT  period ").append(" FROM ").append(
                cyclesTable.get()).append(" ").append(" WHERE ").append(
                cyclesTable.get()).append(".id = ").append(cycleId);
        return stmt.toString();
    }

    /**
     * Method selPeriods
     * 
     * @param minPeriod
     *            int
     * @return String
     */
    public static final String selPeriods(int minPeriod) {
        StringBuffer stmt = new StringBuffer();
        stmt
                .append("SELECT DISTINCT  period ")
                .append(" FROM ")
                .append(cyclesTable.get())
                .append(" ")
                .append(" WHERE ")
                .append(cyclesTable.get())
                .append(".period >= ")
                .append(minPeriod)
                .append(" ORDER BY period DESC");
        return stmt.toString();
    }

    /**
     * Method selPeriods
     * 
     * @param period
     *            int
     * @param panel
     *            String
     * @param opcSubpanel
     *            int
     * @param telescope
     *            String
     * @param proposalTypeValues
     *            String
     * @return String
     */
    public static final String selectRunsRankData(int period, String panel,
            int opcSubpanel, String telescope, String proposalTypeValues) {
        StringBuffer stmt = new StringBuffer();
        stmt
                .append(" SELECT ")
                .append(Phase1SelectStmt.runsTable.get())
                .append(".id, ")
                .append(Phase1SelectStmt.runsTable.get())
                .append(".programme_id, ")
                .append(Phase1SelectStmt.runsTable.get())
                .append(".grade, ")
                .append(Phase1SelectStmt.runsTable.get())
                .append(".rank\n")
                .append(" FROM ")
                .append(Phase1SelectStmt.runsTable.get())
                .append(", ")
                .append(Phase1SelectStmt.programmesTable.get())
                .append(" WHERE obs_programmes.id = ")
                .append(Phase1SelectStmt.runsTable.get())
                .append(".programme_id\n")
                .append(" AND  ")
                .append(Phase1SelectStmt.programmesTable.get())
                .append(".period = ")
                .append(period)
                .append(" AND  ")
                .append(Phase1SelectStmt.programmesTable.get())
                .append(".panel = '")
                .append(panel)
                .append("' AND  ")
                .append(Phase1SelectStmt.programmesTable.get())
                .append(".ignored = 0\n")
                .append(" AND  ")
                .append(Phase1SelectStmt.programmesTable.get())
                .append(".opc_subpanel = ")
                .append(opcSubpanel)
                .append("\n AND ")
                .append(Phase1SelectStmt.runsTable.get())
                .append(".tel_code like '")
                .append(telescope)
                .append("' AND ")
                .append(Phase1SelectStmt.runsTable.get())
                .append(".grade > 0\n")
                .append("\n AND ")
                .append(Phase1SelectStmt.runsTable.get())
                .append(".assigned_time > 0\n")
                .append(" AND  ")
                .append(Phase1SelectStmt.programmesTable.get())
                .append(".gto in ")
                .append(proposalTypeValues)
                .append("\n ORDER BY ")
                .append(Phase1SelectStmt.runsTable.get())
                .append(".grade, ")
                .append(Phase1SelectStmt.runsTable.get())
                .append(".rank");
        return stmt.toString();
    }

    /**
     * Method selScheduled
     * 
     * @param period
     *            int
     * @param panel
     *            String
     * @param opcSubpanel
     *            int
     * @return String
     */
    public static final String selNotRankedRuns(int period, String panel,
            int opcSubpanel) {
        StringBuffer stmt = new StringBuffer();
        stmt
                .append("SELECT ")
                .append(Phase1SelectStmt.runsTable.get())
                .append(".run_code, ")
                .append(Phase1SelectStmt.programmesTable.get())
                .append(".gto\n")
                .append("FROM ")
                .append(Phase1SelectStmt.programmesTable.get())
                .append(", ")
                .append(Phase1SelectStmt.runsTable.get())
                .append(" WHERE ")
                .append(Phase1SelectStmt.programmesTable.get())
                .append(".panel = '")
                .append(panel)
                .append("' AND ")
                .append(Phase1SelectStmt.programmesTable.get())
                .append(".opc_subpanel = ")
                .append(opcSubpanel)
                .append("\n AND ")
                .append(Phase1SelectStmt.programmesTable.get())
                .append(".id = ")
                .append(Phase1SelectStmt.runsTable.get())
                .append(".programme_id ")
                .append("\n AND ")
                .append(Phase1SelectStmt.programmesTable.get())
                .append(".ignored = 0 \n")
                .append("\n AND ")
                .append(Phase1SelectStmt.runsTable.get())
                .append(".grade <= 0 \n")
                .append("AND ")
                .append(Phase1SelectStmt.programmesTable.get())
                .append(".period = ")
                .append(period)
                .append("\n")
                .append("ORDER BY ")
                .append(Phase1SelectStmt.programmesTable.get())
                .append(".gto");
        return stmt.toString();
    }

    /**
     * Method selScheduled
     * 
     * @return String
     */
    public static final String selScheduled() {
        StringBuffer stmt = new StringBuffer();
        stmt.append("SELECT DISTINCT  scheduled ").append(" FROM ").append(
                runsTable.get()).append(" ").append(" WHERE ").append(
                " scheduled != null");
        return stmt.toString();
    }

    /**
     * Method selAccessedLetterFlag
     * 
     * @param userId
     *            long
     * @param cycleId
     *            long
     * @return String
     */
    public static String selAccessedLetterFlag(long userId, long cycleId) {
        StringBuffer stmt = new StringBuffer();
        stmt
                .append("SELECT count(*) from ")
                .append(affiliationsTable.get())
                .append(" WHERE user_id = ")
                .append(userId)
                .append(" AND   cycle_id = ")
                .append(cycleId)
                .append(" AND   accessed_letter != NULL");
        return stmt.toString();
    }

    /**
     * Method selWotEditCcFlag
     * 
     * @param userId
     *            long
     * @return String
     */
    public static String selWotEditCcFlag(long userId) {
        StringBuffer stmt = new StringBuffer();
        stmt
                .append("SELECT count(*) from ")
                .append(esoUsersRolesTable.get())
                .append(" WHERE login = '")
                .append(userId)
                .append("' AND   letters_role = 'editComment'");
        return stmt.toString();
    }

    /**
     * Method selWotEditRcFlag
     * 
     * @param panel
     *            long
     * @param opcSubpanel
     *            int
     * @param telescope
     *            String
     * @return String
     */
    public static String selCutoffValues(String panel, int opcSubpanel,
            String telescope) {
        StringBuffer stmt = new StringBuffer();
        stmt
                .append("SELECT ")
                .append(cutoffTable.get())
                .append(".cutoff FROM ")
                .append(cutoffTable.get())
                .append(" WHERE ")
                .append(cutoffTable.get())
                .append(".category = '")
                .append(panel)
                .append("' AND ")
                .append(cutoffTable.get())
                .append(".opc_subpanel = ")
                .append(opcSubpanel)
                .append("\n AND ")
                .append(cutoffTable.get())
                .append(".code = '")
                .append(telescope)
                .append("' ");
        return stmt.toString();
    }

    /**
     * Method selWotEditRcFlag
     * 
     * @param userId
     *            long
     * @return String
     */
    public static String selWotEditRcFlag(long userId) {
        StringBuffer stmt = new StringBuffer();
        stmt
                .append("SELECT count(*) from ")
                .append(esoUsersRolesTable.get())
                .append(" WHERE login = '")
                .append(userId)
                .append("' AND   letters_role = 'editReport'");
        return stmt.toString();
    }

    /**
     * Method selAllPanels
     * 
     * @param cycleId
     *            int
     * @return String
     */
    public static String selAllPanels(int cycleId) {
        StringBuffer stmt = new StringBuffer();
        stmt
                .append("SELECT DISTINCT  ")
                .append(refereesTable.get())
                .append(".panel ")
                .append(" FROM ")
                .append(refereesTable.get())
                .append(" WHERE ")
                .append(refereesTable.get())
                .append(".panel != ' ' ")
                .append("\n AND ")
                .append(refereesTable.get())
                .append(".cycle_id = ")
                .append(cycleId)
                .append("\n AND ")
                .append(refereesTable.get())
                .append(".opc_subpanel != NULL ")
                .append(" ORDER by ")
                .append(refereesTable.get())
                .append(".panel");
        return stmt.toString();
    }

    /**
     * Method selAllPanels
     * 
     * @param cycleId
     *            int
     * @return String
     */
    public static String selAllCycleSteps() {
        StringBuffer stmt = new StringBuffer();
        stmt.append("SELECT DISTINCT  ").append(stepsTable.get()).append(
                ".label ").append(" FROM ").append(stepsTable.get()).append(
                " ORDER BY id");

        return stmt.toString();
    }

    /**
     * Method getStepId
     * 
     * @param step
     *            label
     * 
     * @return int
     */
    public static String getStepId(String label) {
        StringBuffer stmt = new StringBuffer();
        stmt
                .append("SELECT  ")
                .append(stepsTable.get())
                .append(".id ")
                .append(" FROM ")
                .append(stepsTable.get())
                .append(" WHERE label= '")
                .append(label)
                .append("'");

        return stmt.toString();
    }

    /**
     * Method getStepId
     * 
     * @param step
     *            label
     * 
     * @return int
     */
    public static String updateCycleStep(String cycleLabel, int stepId) {
        StringBuffer stmt = new StringBuffer();
        stmt
                .append("UPDATE  ")
                .append(cyclesTable.get())
                .append(" SET step_id = ")
                .append(stepId)
                .append(" WHERE label= '")
                .append(cycleLabel)
                .append("'");

        return stmt.toString();
    }

    /**
     * Method selAllPanels
     * 
     * @param cycleLabel
     *            String
     * @return String
     */
    public static String selAllPanels(String cycleLabel) {
        StringBuffer stmt = new StringBuffer();
        stmt
                .append("SELECT DISTINCT  ")
                .append(refereesTable.get())
                .append(".panel ")
                .append(" FROM ")
                .append(refereesTable.get())
                .append(", ")
                .append(cyclesTable.get())
                .append(" ")
                .append(" WHERE ")
                .append(refereesTable.get())
                .append(".panel != ' ' ")
                .append("\n AND ")
                .append(refereesTable.get())
                .append(".cycle_id = ")
                .append(cyclesTable.get())
                .append(".id ")
                .append("\n AND ")
                .append(refereesTable.get())
                .append(".opc_subpanel != NULL ")
                .append("\n AND ")
                .append(cyclesTable.get())
                .append(".label =  '")
                .append(cycleLabel)
                .append("' ")
                .append(" ORDER by ")
                .append(refereesTable.get())
                .append(".panel");
        return stmt.toString();
    }

    /**
     * Method selAllSubPanels
     * 
     * @param cycleLabel
     *            String
     * @return String
     */
    public static String selAllSubPanels(String cycleLabel) {
        StringBuffer stmt = new StringBuffer();
        stmt
                .append("SELECT DISTINCT  ")
                .append(programmesTable.get())
                .append(".subpanel ")
                .append(" FROM ")
                .append(programmesTable.get())
                .append(", ")
                .append(cyclesTable.get())
                .append(" ")
                .append(" WHERE ")
                .append(programmesTable.get())
                .append(".panel != ' ' ")
                .append("\n AND ")
                .append(programmesTable.get())
                .append(".subpanel != NULL ")
                .append("\n AND ")
                .append(programmesTable.get())
                .append(".cycle_id = ")
                .append(cyclesTable.get())
                .append(".id ")
                .append("\n AND ")
                .append(cyclesTable.get())
                .append(".label =  '")
                .append(cycleLabel)
                .append("' ")
                .append(" ORDER by ")
                .append(programmesTable.get())
                .append(".subpanel");
        return stmt.toString();
    }

    /**
     * Method selTelescopeUrl
     * 
     * @param code
     *            String
     * @return String
     */
    public static String selTelescopeUrl(String code) {
        StringBuffer stmt = new StringBuffer();
        stmt
                .append("SELECT url ")
                .append(" FROM ")
                .append(telescopeTable.get())
                .append(" WHERE code = '")
                .append(code)
                .append("'");
        return stmt.toString();
    }

    /**
     * Method selInstrumentUrl
     * 
     * @param code
     *            String
     * @return String
     */
    public static String selInstrumentUrl(String code) {
        StringBuffer stmt = new StringBuffer();
        stmt
                .append("SELECT DISTINCT url ")
                .append(" FROM ")
                .append(instrumentTable.get())
                .append(" WHERE code = '")
                .append(code)
                .append("'");
        return stmt.toString();
    }

    /**
     * Method selOpcSubpanelsFromProgrammes
     * 
     * @param cycleId
     *            int
     * @return String
     */
    public static String selOpcSubpanelsFromProgrammes(int cycleId) {
        StringBuffer stmt = new StringBuffer();
        stmt
                .append("SELECT DISTINCT  ")
                .append(programmesTable.get())
                .append(".opc_subpanel ")
                .append(" FROM ")
                .append(programmesTable.get())
                .append(" ")
                .append(" WHERE ")
                .append(programmesTable.get())
                .append(".panel != ' ' ")
                .append("\n AND ")
                .append(programmesTable.get())
                .append(".cycle_id = ")
                .append(cycleId)
                .append("\n AND ")
                .append(programmesTable.get())
                .append(".opc_subpanel != NULL ");
        return stmt.toString();
    }

    /**
     * Method selAllOpcSubpanels
     * 
     * @param cycleId
     *            int
     * @return String
     */
    public static String selAllOpcSubpanels(int cycleId) {
        StringBuffer stmt = new StringBuffer();
        stmt
                .append("SELECT DISTINCT  ")
                .append(refereesTable.get())
                .append(".opc_subpanel ")
                .append(" FROM ")
                .append(refereesTable.get())
                .append(" ")
                .append(" WHERE ")
                .append(refereesTable.get())
                .append(".panel != ' ' ")
                .append("\n AND ")
                .append(refereesTable.get())
                .append(".cycle_id = ")
                .append(cycleId)
                .append("\n AND ")
                .append(refereesTable.get())
                .append(".opc_subpanel != NULL ")
                .append(" ORDER by ")
                .append(refereesTable.get())
                .append(".opc_subpanel");
        return stmt.toString();
    }

    /**
     * Method selOpcSubpanels
     * 
     * @param panel
     *            String
     * @param cycleLabel
     *            String
     * @return String
     */
    public static String selOpcSubpanels(String panel, String cycleLabel) {
        StringBuffer stmt = new StringBuffer();
        stmt
                .append("SELECT DISTINCT  ")
                .append(refereesTable.get())
                .append(".opc_subpanel ")
                .append(" FROM ")
                .append(refereesTable.get())
                .append(", ")
                .append(cyclesTable.get())
                .append(" ")
                .append(" WHERE ")
                .append(refereesTable.get())
                .append(".panel = '")
                .append(panel)
                .append("' ")
                .append("\n AND ")
                .append(refereesTable.get())
                .append(".cycle_id = ")
                .append(cyclesTable.get())
                .append(".id ")
                .append("\n AND ")
                .append(refereesTable.get())
                .append(".opc_subpanel != NULL ")
                .append("\n AND ")
                .append(cyclesTable.get())
                .append(".label =  '")
                .append(cycleLabel)
                .append("' ")
                .append(" ORDER by ")
                .append(refereesTable.get())
                .append(".opc_subpanel");
        return stmt.toString();
    }

    /**
     * Method selAllOpcSubpanels
     * 
     * @param cycleLabel
     *            String
     * @return String
     */
    public static String selAllOpcSubpanels(String cycleLabel) {
        StringBuffer stmt = new StringBuffer();
        stmt
                .append("SELECT DISTINCT  ")
                .append(refereesTable.get())
                .append(".opc_subpanel ")
                .append(" FROM ")
                .append(refereesTable.get())
                .append(", ")
                .append(cyclesTable.get())
                .append(" ")
                .append(" WHERE ")
                .append(refereesTable.get())
                .append(".panel != ' ' ")
                .append("\n AND ")
                .append(refereesTable.get())
                .append(".cycle_id = ")
                .append(cyclesTable.get())
                .append(".id ")
                .append("\n AND ")
                .append(refereesTable.get())
                .append(".opc_subpanel != NULL ")
                .append("\n AND ")
                .append(cyclesTable.get())
                .append(".label =  '")
                .append(cycleLabel)
                .append("' ")
                .append(" ORDER by ")
                .append(refereesTable.get())
                .append(".opc_subpanel");
        return stmt.toString();
    }

    /**
     * Method selCountProposals
     * 
     * @param userId
     *            long
     * @param cycleLabel
     *            String
     * @return String
     */
    public static String selCountProposals(long userId, String cycleLabel) {
        StringBuffer stmt = new StringBuffer();
        stmt
                .append("SELECT count(distinct ")
                .append(programmesTable.get())
                .append(".proposalID)")
                .append(" FROM ")
                .append(programmesTable.get())
                .append(",")
                .append(ratedTable.get())
                .append(" , ")
                .append(cyclesTable.get())
                .append(" , ")
                .append(runsTable.get())
                .append(", ")
                .append(refereesTable.get())
                .append(", ")
                .append(telescopeTable.get())
                .append("  WHERE ")
                .append(refereesTable.get())
                .append(".user_id = ")
                .append(userId)
                .append(" ")
                .append(" AND  ")
                .append(refereesTable.get())
                .append(".cycle_id = ")
                .append(cyclesTable.get())
                .append(".id ")
                .append(" AND  ")
                .append(telescopeTable.get())
                .append(".code = ")
                .append(runsTable.get())
                .append(".tel_code ")
                .append(" AND  ")
                .append(ratedTable.get())
                .append(".user_id = ")
                .append(refereesTable.get())
                .append(".user_id ")
                .append(" AND  ")
                .append(ratedTable.get())
                .append(".run_id = ")
                .append(runsTable.get())
                .append(".id ")
                .append(" AND  ")
                .append(programmesTable.get())
                .append(".id = ")
                .append(runsTable.get())
                .append(".programme_id ")
                .append(" AND  ")
                .append(programmesTable.get())
                .append(".ignored = 0 ")
                .append(" AND  ")
                .append(programmesTable.get())
                .append(".cycle_id = ")
                .append(cyclesTable.get())
                .append(".id ")
                .append(" AND  ")
                .append(cyclesTable.get())
                .append(".label = '")
                .append(cycleLabel)
                .append("' ");
        return stmt.toString();
    }

    /**
     * Method selPrRefereeComment
     * 
     * @param runId
     *            long
     * @return String
     */
    public static String selPrRefereeComment(long runId) {
        StringBuffer stmt = new StringBuffer();
        stmt
                .append("SELECT  ")
                .append(ratedTable.get())
                .append(".user_id")
                .append(" FROM ")
                .append(ratedTable.get())
                .append("  WHERE ")
                .append(ratedTable.get())
                .append(".run_id = ")
                .append(runId)
                .append(" AND    ")
                .append(ratedTable.get())
                .append(".pr_flag = 1 ");
        return stmt.toString();
    }

    /**
     * Method selAcceptedRuns
     * 
     * @param progID
     *            long
     * @return String
     */
    public static String selAcceptedRuns(long progID) {
        StringBuffer stmt = new StringBuffer();
        stmt.append("SELECT count(*) FROM ").append(runsTable.get()).append(
                " WHERE programme_id = ").append(progID).append(
                " AND status = '+'");
        return stmt.toString();
    }

    /**
     * Method selRejectedRuns
     * 
     * @param progID
     *            long
     * @return String
     */
    public static String selRejectedRuns(long progID) {
        StringBuffer stmt = new StringBuffer();
        stmt.append("SELECT count(*) FROM ").append(runsTable.get()).append(
                " WHERE programme_id = ").append(progID).append(
                " AND status = '-'");
        return stmt.toString();
    }

    /**
     * Method selCountProposalsVlt
     * 
     * @param userId
     *            long
     * @param cycleLabel
     *            String
     * @return String
     */
    public static String selCountProposalsVlt(long userId, String cycleLabel) {
        StringBuffer stmt = new StringBuffer();
        stmt
                .append(selCountProposals(userId, cycleLabel))
                .append(" AND  ")
                .append(telescopeTable.get())
                .append(".observatory = 'P' ");
        return stmt.toString();
    }

    /**
     * Method selCountProposalsL
     * 
     * @param userId
     *            long
     * @param cycleLabel
     *            String
     * @return String
     */
    public static String selCountProposalsL(long userId, String cycleLabel) {
        StringBuffer stmt = new StringBuffer();
        stmt
                .append(selCountProposals(userId, cycleLabel))
                .append(" AND  ")
                .append(telescopeTable.get())
                .append(".observatory = 'L' ");
        return stmt.toString();
    }

    /**
     * Method selPrCountProposals
     * 
     * @param userId
     *            long
     * @param cycleLabel
     *            String
     * @return String
     */
    public static String selPrCountProposals(long userId, String cycleLabel) {
        StringBuffer stmt = new StringBuffer();
        stmt
                .append(selCountProposals(userId, cycleLabel))
                .append(" AND  ")
                .append(ratedTable.get())
                .append(".pr_flag = 1 ");
        return stmt.toString();
    }

    /**
     * Method selPrCountProposalsVlt
     * 
     * @param userId
     *            long
     * @param cycleLabel
     *            String
     * @return String
     */
    public static String selPrCountProposalsVlt(long userId, String cycleLabel) {
        StringBuffer stmt = new StringBuffer();
        stmt
                .append(selCountProposalsVlt(userId, cycleLabel))
                .append(" AND  ")
                .append(ratedTable.get())
                .append(".pr_flag = 1 ");
        return stmt.toString();
    }

    /**
     * Method selPrCountProposalsL
     * 
     * @param userId
     *            long
     * @param cycleLabel
     *            String
     * @return String
     */
    public static String selPrCountProposalsL(long userId, String cycleLabel) {
        StringBuffer stmt = new StringBuffer();
        stmt
                .append(selCountProposalsL(userId, cycleLabel))
                .append(" AND  ")
                .append(ratedTable.get())
                .append(".pr_flag = 1 ");
        return stmt.toString();
    }

    /**
     * Method selCountReferProposal
     * 
     * @param id
     *            long
     * @param opcSubpanel
     *            int
     * @return String
     */
    public static String selCountReferProposal(long id, int opcSubpanel) {
        StringBuffer stmt = new StringBuffer();
        stmt
                .append(" select count(")
                .append(refereesTable.get())
                .append(".user_id)")
                .append(" from ")
                .append(programmesTable.get())
                .append(",")
                .append(refereesTable.get())
                .append(",")
                .append(proposedTable.get())
                .append(" where ")
                .append(programmesTable.get())
                .append(".id = ")
                .append(id)
                .append("\n AND ")
                .append(proposedTable.get())
                .append(".programme_id = ")
                .append(programmesTable.get())
                .append(".id ")
                .append("\n AND ")
                .append(proposedTable.get())
                .append(".user_id = ")
                .append(refereesTable.get())
                .append(".user_id ")
                .append("\n AND ")
                .append(refereesTable.get())
                .append(".panel = ")
                .append(programmesTable.get())
                .append(".panel ")
                .append("\n AND ")
                .append(refereesTable.get())
                .append(".cycle_id = ")
                .append(programmesTable.get())
                .append(".cycle_id ")
                .append("\n AND ")
                .append(refereesTable.get())
                .append(".opc_subpanel = ")
                .append(opcSubpanel);
        return stmt.toString();
    }

    /**
     * Method selAcronymOtherUser
     * 
     * @param cycleId
     *            int
     * @param userId
     *            long
     * @param refAcronym
     *            String
     * @return String
     */
    public static String selAcronymOtherUser(int cycleId, long userId,
            String refAcronym) {
        StringBuffer stmt = new StringBuffer();
        stmt
                .append("SELECT  ")
                .append(refereesTable.get())
                .append(".acronym  ")
                .append(" FROM ")
                .append(refereesTable.get())
                .append(" ")
                .append(" WHERE ")
                .append(refereesTable.get())
                .append(".cycle_id = ")
                .append(cycleId)
                .append(" ")
                .append("\n AND ")
                .append(refereesTable.get())
                .append(".user_id != ")
                .append(userId)
                .append("\n AND ")
                .append(refereesTable.get())
                .append(".acronym = '")
                .append(refAcronym)
                .append("' ");
        return stmt.toString();
    }

    /**
     * Method selCutOffTelPanSubPan
     * 
     * @param telescope
     *            String
     * @param panel
     *            String
     * @param opcSubpanel
     *            int
     * @return String
     */
    public static String selCutOffTelPanSubPan(String telescope, String panel,
            int opcSubpanel) {
        StringBuffer stmt = new StringBuffer();
        stmt
                .append("SELECT  cutoff ")
                .append(" FROM ")
                .append(cutoffTable.get())
                .append(" ")
                .append(" WHERE category = '")
                .append(panel)
                .append("' ")
                .append(" AND opc_subpanel = ")
                .append(opcSubpanel)
                .append(" AND code = '")
                .append(telescope)
                .append("' ");
        return stmt.toString();
    }

    /**
     * Method selUsersIds
     * 
     * @param idStart
     *            int
     * @return String
     */
    public static String selUsersIds(int idStart, int idEnd) {
        StringBuffer stmt = new StringBuffer();
        stmt
                .append("SELECT id ")
                .append(" FROM ")
                .append(usersTable.get())
                .append(" ")
                .append(" WHERE  id >= ")
                .append(idStart)
                .append(" AND  id < ")
                .append(idEnd)
                .append(" ORDER BY id ");
        return stmt.toString();
    }

    /**
     * Method selAllCutOffPanels
     * 
     * @param cycleId
     *            long
     * @return String
     */
    public static String selAllCutOffPanels(long cycleId) {
        StringBuffer stmt = new StringBuffer();
        stmt.append("SELECT DISTINCT panel ").append(" FROM ").append(
                refereesTable.get()).append(" ").append(
                " WHERE cycle_id = NULL ");
        return stmt.toString();
    }

    /**
     * Method wcAllPanels
     * 
     * @param cycleId
     *            long
     * @return String
     */
    public static String wcAllPanels(long cycleId) {
        StringBuffer stmt = new StringBuffer();
        stmt.append(refereesTable.get()).append(".cycle_id = ").append(cycleId);
        return stmt.toString();
    }

    /**
     * Method wcUsersFormPropIds
     * 
     * @param programme_id
     *            long
     * @return String
     */
    public static String wcUsersFormPropIds(long programme_id) {
        StringBuffer stmt = new StringBuffer();
        stmt
                .append(proposedTable.get())
                .append(".programme_id = ")
                .append(programme_id)
                .append("\n AND ")
                .append(proposedTable.get())
                .append(".user_id = ")
                .append(usersTable.get())
                .append(".id ")
                .append(" ORDER BY pi_flag ");
        return stmt.toString();
    }

    /**
     * Method wcPiFormPropIds
     * 
     * @param programme_id
     *            long
     * @return String
     */
    public static String wcPIFormPropIds(long programme_id) {
        StringBuffer stmt = new StringBuffer();
        stmt
                .append(proposedTable.get())
                .append(".programme_id = ")
                .append(programme_id)
                .append("\n AND ")
                .append(proposedTable.get())
                .append(".user_id = ")
                .append(usersTable.get())
                .append(".id ")
                .append(" AND pi_flag = 0 ");
        return stmt.toString();
    }

    /**
     * Method wcUsersFormPropIdsTable
     * 
     * @return String
     */
    public static String wcUsersFormPropIdsTable() {
        StringBuffer stmt = new StringBuffer();
        stmt.append(", ").append(proposedTable.get());
        return stmt.toString();
    }

    /**
     * Method selUser
     * 
     * @param id
     *            int
     * @return String
     */
    public static String selUser(int id) {
        StringBuffer stmt = new StringBuffer();
        stmt
                .append("SELECT id ")
                .append(" FROM ")
                .append(usersTable.get())
                .append(" ")
                .append(" WHERE  id = ")
                .append(id)
                .append(" ORDER BY id ");
        return stmt.toString();
    }

    /**
     * Method selAllTelList
     * 
     * @param period
     *            String
     * @param observatory
     *            String
     * @return String
     */
    public static final String selAllTelList(String period, String observatory) {
        StringBuffer stmt = new StringBuffer();
        stmt
                .append("SELECT DISTINCT  ")
                .append(runsTable.get())
                .append(".tel_code ")
                .append(" FROM ")
                .append(runsTable.get())
                .append(" , ")
                .append(telescopeTable.get())
                .append(" , ")
                .append(programmesTable.get())
                .append(" WHERE  ")
                .append(programmesTable.get())
                .append(".id = ")
                .append(runsTable.get())
                .append(".programme_id ")
                .append("\n AND ")
                .append(runsTable.get())
                .append(".tel_code = ")
                .append(telescopeTable.get())
                .append(".code ");
        if (!observatory.equals("()")) {
            stmt.append(" AND ").append(telescopeTable.get()).append(
                    ".observatory in ").append(observatory);
        }
        if (!period.equals("()")) {
            stmt.append(" AND ").append(programmesTable.get()).append(
                    ".period in ").append(period);
        }
        return stmt.toString();
    }

    /**
     * Method selAllTelInRun
     * 
     * @param period
     *            String
     * @return String
     */
    public static final String selAllTelInRun(String period) {
        StringBuffer stmt = new StringBuffer();
        stmt
                .append("SELECT DISTINCT  ")
                .append(runsTable.get())
                .append(".tel_code ")
                .append(" FROM ")
                .append(runsTable.get())
                .append(" , ")
                .append(programmesTable.get())
                .append("")
                .append(" WHERE  ")
                .append(programmesTable.get())
                .append(".id = ")
                .append(runsTable.get())
                .append(".programme_id ");
        if (!period.equals("()")) {
            stmt.append(" AND ").append(programmesTable.get()).append(
                    ".period in ").append(period);
        }
        return stmt.toString();
    }

    /**
     * Method selAllTelInRun
     * 
     * @param period
     *            int
     * @return String
     */
    public static final String selAllTelInRun(int period) {
        StringBuffer stmt = new StringBuffer();
        stmt
                .append("SELECT DISTINCT  ")
                .append(runsTable.get())
                .append(".tel_code ")
                .append(" FROM ")
                .append(runsTable.get())
                .append(" , ")
                .append(programmesTable.get())
                .append("")
                .append(" WHERE  ")
                .append(programmesTable.get())
                .append(".id = ")
                .append(runsTable.get())
                .append(".programme_id ")
                .append("\n AND ")
                .append(programmesTable.get())
                .append(".period = ")
                .append(period);
        return stmt.toString();
    }

    /**
     * Method selAllInstrsTelList
     * 
     * @param period
     *            String
     * @param telescope
     *            String
     * @return String
     */
    public static String selAllInstrsTelList(String period, String telescope) {
        StringBuffer stmt = new StringBuffer();
        stmt
                .append("SELECT DISTINCT ")
                .append(runsTable.get())
                .append(".inst_code ")
                .append(" FROM ")
                .append(runsTable.get())
                .append(" , ")
                .append(programmesTable.get())
                .append("")
                .append(" WHERE  ")
                .append(programmesTable.get())
                .append(".id = ")
                .append(runsTable.get())
                .append(".programme_id ");
        if (!telescope.equals("()")) {
            stmt.append(" AND tel_code in ").append(telescope).append(" ");
        }
        if (!period.equals("()")) {
            stmt.append(" AND ").append(programmesTable.get()).append(
                    ".period in ").append(period);
        }
        ;
        return stmt.toString();
    }

    /**
     * Method selAllInstrs
     * 
     * @param period
     *            String
     * @param telescope
     *            String
     * @return String
     */
    public static String selAllInstrs(String period, String telescope) {
        StringBuffer stmt = new StringBuffer();
        stmt
                .append("SELECT DISTINCT ")
                .append(runsTable.get())
                .append(".inst_code ")
                .append(" FROM ")
                .append(runsTable.get())
                .append(" , ")
                .append(programmesTable.get())
                .append("")
                .append(" WHERE  ")
                .append(programmesTable.get())
                .append(".id = ")
                .append(runsTable.get())
                .append(".programme_id ")
                .append(" AND tel_code = '")
                .append(telescope)
                .append("' ");
        if (!period.equals("()")) {
            stmt.append(" AND ").append(programmesTable.get()).append(
                    ".period in ").append(period);
        }
        ;
        return stmt.toString();
    }

    /**
     * Method selAllInstrs
     * 
     * @param period
     *            int
     * @param telescope
     *            String
     * @return String
     */
    public static String selAllInstrs(int period, String telescope) {
        StringBuffer stmt = new StringBuffer();
        stmt
                .append("SELECT DISTINCT ")
                .append(runsTable.get())
                .append(".inst_code ")
                .append(" FROM ")
                .append(runsTable.get())
                .append(" , ")
                .append(programmesTable.get())
                .append("")
                .append(" WHERE  ")
                .append(programmesTable.get())
                .append(".id = ")
                .append(runsTable.get())
                .append(".programme_id ")
                .append(" AND tel_code = '")
                .append(telescope)
                .append("' ")
                .append("\n AND ")
                .append(programmesTable.get())
                .append(".period = ")
                .append(period);
        return stmt.toString();
    }

    /**
     * List of Instruments the sched_rep tabl *
     * 
     * @param period
     *            int
     * @param telescope
     *            String
     * @param period
     *            int
     * @param telescope
     *            String
     * @param period
     *            int
     * @param telescope
     *            String
     * @param period
     *            int
     * @param telescope
     *            String
     * @return String eeee
     */
    public static String selAllSchedRepInstrs(String period, String telescope) {
        StringBuffer stmt = new StringBuffer();
        stmt
                .append("SELECT DISTINCT ")
                .append(schedRepTable.get())
                .append(".inst ")
                .append("FROM ")
                .append(schedRepTable.get())
                .append("")
                .append(" WHERE ")
                .append(schedRepTable.get())
                .append(".period in ")
                .append(period)
                .append(" AND tel in ")
                .append(telescope)
                .append(" ")
                .append(" and inst != ''")
                .append(" order by inst ");
        return stmt.toString();
    }

    /** Select entries in sched_rep with matching run_id */
    public static String selSameSchedRunId(int runId) {
        StringBuffer stmt = new StringBuffer();
        stmt
                .append("SELECT ")
                .append(schedRepTable.get())
                .append(".id  FROM ")
                .append(schedRepTable.get())
                .append(" WHERE ")
                .append(schedRepTable.get())
                .append(".run_id = ")
                .append(runId);
        return stmt.toString();
    }

    /** Select entries in sched_rep with matching run_id */
    public static String wcSameSchedRunId(int runId) {
        StringBuffer stmt = new StringBuffer();
        stmt.append(schedRepTable.get()).append(".run_id = ").append(runId);
        return stmt.toString();
    }

    /** Select count of entries in sched_rep with matching run_id */
    public static String selCountSchedRunId(int runId) {
        StringBuffer stmt = new StringBuffer();
        stmt.append("SELECT COUNT(*)").append(" FROM ").append(
                schedRepTable.get()).append(" WHERE ").append(
                schedRepTable.get()).append(".run_id = ").append(runId);
        return stmt.toString();
    }

    /**
     * List of Telescopes the sched_rep tabl *
     * 
     * @param period
     *            int
     * @param period
     *            int
     * @return String ee
     */
    public static String selAllSchedRepTeles() {
        StringBuffer stmt = new StringBuffer();
        stmt.append("SELECT DISTINCT ").append(schedRepTable.get()).append(
                ".tel ").append("FROM ").append(schedRepTable.get()).append(
                " order by tel ");
        return stmt.toString();
    }

    public static String getUserRole(int login, String password) {
        StringBuffer stmt = new StringBuffer();
        stmt
                .append("SELECT DISTINCT letters_role FROM ")
                .append(usersRolesTable.get())
                .append(", ")
                .append(usersViewTable.get())
                .append(" WHERE ")
                .append(usersViewTable.get())
                .append(".password = ")
                .append("'")
                .append(password)
                .append("'")
                .append("\n AND ")
                .append(usersViewTable.get())
                .append(".login = ")
                .append("'")
                .append(login)
                .append("'")
                .append("\n AND ")
                .append(usersRolesTable.get())
                .append(".login = ")
                .append(usersViewTable.get())
                .append(".login");
        return stmt.toString();
    }

    /**
     * Selecte Instruments in SchedRep Tabl *
     * 
     * @param period
     *            int
     * @param period
     *            int
     * @param period
     *            int
     * @return String eee
     */
    public static String selAllSchedRepInstrs() {
        StringBuffer stmt = new StringBuffer();
        stmt.append("SELECT DISTINCT ").append(schedRepTable.get()).append(
                ".inst").append(" FROM ").append(schedRepTable.get()).append(
                " where inst != ''").append(" order by inst ");
        return stmt.toString();
    }

    public static String selSchedRepPublished(long id) {
        StringBuffer stmt = new StringBuffer();
        stmt
                .append("SELECT ")
                .append(schedRepTable.get())
                .append(".published")
                .append(" FROM ")
                .append(schedRepTable.get())
                .append(" where id = ")
                .append(id);
        return stmt.toString();
    }

    /**
     * Selecte Instruments in SchedRep Tabl *
     * 
     * @param period
     *            int
     * @param period
     *            int
     * @param period
     *            int
     * @return String eee
     */
    public static String selAllSchedRepInstrs(String telescope) {
        StringBuffer stmt = new StringBuffer();
        stmt.append("SELECT DISTINCT ").append(schedRepTable.get()).append(
                ".inst").append(" FROM ").append(schedRepTable.get()).append(
                " WHERE tel = '").append(telescope).append("'").append(
                " order by inst ");
        //.append(" and opc..sched_rep.inst != ''");
        return stmt.toString();
    }

    /**
     * List of Telescopes the sched_rep tabl *
     * 
     * @param period
     *            int
     * @param period
     *            int
     * @param period
     *            int
     * @return String eee
     */
    public static String selAllSchedRepTeles(String period) {
        StringBuffer stmt = new StringBuffer();
        stmt
                .append("SELECT DISTINCT ")
                .append(schedRepTable.get())
                .append(".tel ")
                .append("FROM ")
                .append(schedRepTable.get())
                .append("")
                .append(" WHERE ")
                .append(schedRepTable.get())
                .append(".period in ")
                .append(period)
                .append("\n AND ")
                .append(schedRepTable.get())
                .append(".tel != ''")
                .append(" order by tel ");
        return stmt.toString();
    }

    /**
     * Method selAllInstrs
     * 
     * @param period
     *            String
     * @return String
     */
    public static String selAllInstrs(String period) {
        StringBuffer stmt = new StringBuffer();
        stmt
                .append("SELECT DISTINCT ")
                .append(runsTable.get())
                .append(".inst_code ")
                .append(" FROM ")
                .append(runsTable.get())
                .append(" , ")
                .append(programmesTable.get())
                .append("")
                .append(" WHERE  ")
                .append(programmesTable.get())
                .append(".id = ")
                .append(runsTable.get())
                .append(".programme_id ");
        if (!period.equals("()")) {
            stmt.append(" AND ").append(programmesTable.get()).append(
                    ".period in ").append(period);
        }
        ;
        return stmt.toString();
    }

    /**
     * Selecte Instruments in SchedRep Tabl *
     * 
     * @param period
     *            int
     * @param period
     *            int
     * @param period
     *            int
     * @param period
     *            int
     * @return String eeee
     */
    public static String selAllSchedRepInstrsPeriods(String periodList) {
        StringBuffer stmt = new StringBuffer();
        stmt
                .append("SELECT DISTINCT ")
                .append(schedRepTable.get())
                .append(".inst")
                .append(" FROM ")
                .append(schedRepTable.get())
                .append(" WHERE ")
                .append(schedRepTable.get())
                .append(".period in ")
                .append(periodList)
                .append("\n AND ")
                .append(schedRepTable.get())
                .append(".inst != '' ")
                .append(" order by inst ");
        return stmt.toString();
    }

    /**
     * Method selProgrLatexSource
     * 
     * @param proposalId
     *            long
     * @return String
     */
    public static String selProgrLatexSource(long proposalId) {
        StringBuffer stmt = new StringBuffer();
        stmt.append("SELECT  latex_text ").append(" FROM ").append(
                latexTable.get()).append(" WHERE programme_id = ").append(
                proposalId);
        return stmt.toString();
    }

    /**
     * Method selRefereeAcronym
     * 
     * @param cycleId
     *            int
     * @param refAcronym
     *            String
     * @return String
     */
    public static String selRefereeAcronym(int cycleId, String refAcronym) {
        StringBuffer stmt = new StringBuffer();
        stmt
                .append("SELECT  ")
                .append(refereesTable.get())
                .append(".acronym  ")
                .append(" FROM ")
                .append(refereesTable.get())
                .append(" ")
                .append(" WHERE ")
                .append(refereesTable.get())
                .append(".cycle_id = ")
                .append(cycleId)
                .append(" ")
                .append("\n AND ")
                .append(refereesTable.get())
                .append(".acronym = '")
                .append(refAcronym)
                .append("' ");
        return stmt.toString();
    }

    /**
     * Method selRefereeAcronym
     * 
     * @param cycleId
     *            int
     * @return String
     */
    public static String selRefereeAcronym(int cycleId) {
        StringBuffer stmt = new StringBuffer();
        stmt
                .append("SELECT  ")
                .append(refereesTable.get())
                .append(".acronym  ")
                .append(" FROM ")
                .append(refereesTable.get())
                .append(" ")
                .append(" WHERE ")
                .append(refereesTable.get())
                .append(".cycle_id = ")
                .append(cycleId)
                .append(" ")
                .append(" ORDER BY  ")
                .append(refereesTable.get())
                .append(".acronym");
        return stmt.toString();
    }

    /**
     * Method selRefAcronymInProposal
     * 
     * @param proposalId
     *            long
     * @return String
     */
    public static String selRefAcronymInProposal(long proposalId) {
        StringBuffer stmt = new StringBuffer();
        stmt
                .append("SELECT DISTINCT ")
                .append(refereesTable.get())
                .append(".acronym  ")
                .append(" FROM ")
                .append(refereesTable.get())
                .append(", ")
                .append(programmesTable.get())
                .append(", ")
                .append(proposedTable.get())
                .append(" WHERE ")
                .append(programmesTable.get())
                .append(".id = ")
                .append(proposalId)
                .append("\n AND ")
                .append(proposedTable.get())
                .append(".user_id = ")
                .append(refereesTable.get())
                .append(".user_id ")
                .append("\n AND ")
                .append(proposedTable.get())
                .append(".programme_id = ")
                .append(programmesTable.get())
                .append(".id ")
                .append("\n AND ")
                .append(programmesTable.get())
                .append(".panel = ")
                .append(refereesTable.get())
                .append(".panel ")
                .append("\n AND ")
                .append(programmesTable.get())
                .append(".opc_subpanel = ")
                .append(refereesTable.get())
                .append(".opc_subpanel ")
                .append("\n AND ")
                .append(refereesTable.get())
                .append(".cycle_id = ")
                .append(programmesTable.get())
                .append(".cycle_id ")
                .append(" order by ")
                .append(programmesTable.get())
                .append(".panel, ")
                .append(programmesTable.get())
                .append(".opc_subpanel, ")
                .append(programmesTable.get())
                .append(".proposal_code");
        return stmt.toString();
    }

    /**
     * Added by Judith 5/11/200 *
     * 
     * @param instrument
     *            String
     * @param period
     *            int *
     * @param instrument
     *            String
     * @param period
     *            int
     * @param instrument
     *            String
     * @param period
     *            int
     * @param instrument
     *            String
     * @param period
     *            int
     * @return String 3333
     */
    /** MIPS requirement - Instrument Package Versioning */
    public static String selIPVersion(String instrument, int period) {
        StringBuffer stmt = new StringBuffer();
        stmt
                .append("SELECT MAX (")
                .append(ipPeriodsTable.get())
                .append(".version) ")
                .append("FROM ")
                .append(ipPeriodsTable.get())
                .append(" WHERE ")
                .append(ipPeriodsTable.get())
                .append(".inst_name = '")
                .append(instrument)
                .append("'")
                .append("\n AND ")
                .append(ipPeriodsTable.get())
                .append(".period = ")
                .append(period);
        return stmt.toString();
    } //selIPVersion

    /**
     * Method insertCyclesMissingUser
     * 
     * @param cycleLabel
     *            String
     * @param old_user
     *            int
     * @param new_user
     *            int
     * @return String
     */
    public static String insertCyclesMissingUser(String cycleLabel,
            int old_user, int new_user) {
        StringBuffer stmt = new StringBuffer();
        stmt
                .append(" INSERT INTO ")
                .append(affiliationsTable.get())
                .append(" SELECT DISTINCT ")
                .append(new_user)
                .append(", ")
                .append(affiliationsTable.get())
                .append(".period , ")
                .append(affiliationsTable.get())
                .append(".country_code , ")
                .append(affiliationsTable.get())
                .append(".affiliation , ")
                .append(affiliationsTable.get())
                .append(".cycle_id ")
                .append(" FROM ")
                .append(cyclesTable.get())
                .append(", ")
                .append(affiliationsTable.get())
                .append(" WHERE ")
                .append(affiliationsTable.get())
                .append(".user_id = ")
                .append(old_user)
                .append("\n AND ")
                .append(cyclesTable.get())
                .append(".label = '")
                .append(cycleLabel)
                .append("' ")
                .append("\n AND ")
                .append(cyclesTable.get())
                .append(".id = ")
                .append(affiliationsTable.get())
                .append(".cycle_id \n ");
        return stmt.toString();
    }

    /**
     * Method selCyclesMissingUser
     * 
     * @param old_user
     *            int
     * @param new_user
     *            int
     * @return String
     */
    public static String selCyclesMissingUser(int old_user, int new_user) {
        StringBuffer stmt = new StringBuffer();
        stmt
                .append("SELECT DISTINCT ")
                .append(cyclesTable.get())
                .append(".label ")
                .append(" FROM ")
                .append(cyclesTable.get())
                .append(", ")
                .append(programmesTable.get())
                .append(", ")
                .append(proposedTable.get())
                .append(" WHERE ")
                .append(proposedTable.get())
                .append(".programme_id = ")
                .append(programmesTable.get())
                .append(".id ")
                .append("\n AND ")
                .append(proposedTable.get())
                .append(".user_id = ")
                .append(old_user)
                .append("\n AND ")
                .append(cyclesTable.get())
                .append(".id = ")
                .append(programmesTable.get())
                .append(".cycle_id ")
                .append("\n AND ")
                .append(programmesTable.get())
                .append(".cycle_id not in ")
                .append(" (SELECT DISTINCT ")
                .append(affiliationsTable.get())
                .append(".cycle_id ")
                .append(" FROM ")
                .append(affiliationsTable.get())
                .append(" WHERE ")
                .append(affiliationsTable.get())
                .append(".user_id = ")
                .append(new_user)
                .append(") ");
        return stmt.toString();
    }

    /**
     * Method selUserRefereeAcronym
     * 
     * @param cycleId
     *            int
     * @param user
     *            long
     * @return String
     */
    public static String selUserRefereeAcronym(int cycleId, long user) {
        StringBuffer stmt = new StringBuffer();
        stmt
                .append("SELECT  ")
                .append(refereesTable.get())
                .append(".acronym ")
                .append(" FROM ")
                .append(refereesTable.get())
                .append(" ")
                .append(" WHERE ")
                .append(refereesTable.get())
                .append(".cycle_id = ")
                .append(cycleId)
                .append(" ")
                .append("\n AND ")
                .append(refereesTable.get())
                .append(".user_id = ")
                .append(user)
                .append(" ")
                .append(" ORDER BY  ")
                .append(refereesTable.get())
                .append(".acronym");
        return stmt.toString();
    }

    /**
     * Method selUserReferees
     * 
     * @param user
     *            long
     * @return String
     */
    public static String selUserReferees(long user) {
        StringBuffer stmt = new StringBuffer();
        stmt
                .append(" SELECT DISTINCT ")
                .append(refereesTable.get())
                .append(".acronym ")
                .append(" FROM ")
                .append(refereesTable.get())
                .append(" ")
                .append(" WHERE ")
                .append(refereesTable.get())
                .append(".user_id = ")
                .append(user)
                .append(" ")
                .append(" ORDER BY  ")
                .append(refereesTable.get())
                .append(".acronym");
        return stmt.toString();
    }

    /**
     * Method selUserFromProposed
     * 
     * @param programmeId
     *            long
     * @return String
     */
    public static String selUserFromProposed(long programmeId) {
        StringBuffer stmt = new StringBuffer();
        stmt
                .append(" SELECT  ")
                .append(proposedTable.get())
                .append(".user_id ")
                .append(" FROM ")
                .append(proposedTable.get())
                .append(" ")
                .append(" WHERE ")
                .append(proposedTable.get())
                .append(".programme_id = ")
                .append(programmeId)
                .append(" AND pi_flag = 0");
        return stmt.toString();
    }

    /**
     * Method selRatedCount
     * 
     * @param user
     *            long
     * @return String
     */
    public static String selRatedCount(long user) {
        StringBuffer stmt = new StringBuffer();
        stmt
                .append(" SELECT count(*)")
                .append(" FROM ")
                .append(ratedTable.get())
                .append(" ")
                .append(" WHERE ")
                .append(ratedTable.get())
                .append(".user_id = ")
                .append(user)
                .append(" ");
        return stmt.toString();
    }

    /**
     * Method selRatedCycles
     * 
     * @param user
     *            long
     * @return String
     */
    public static String selRatedCycles(long user) {
        StringBuffer stmt = new StringBuffer();
        stmt
                .append("SELECT DISTINCT ")
                .append(cyclesTable.get())
                .append(".label ")
                .append(" FROM ")
                .append(cyclesTable.get())
                .append(", ")
                .append(ratedTable.get())
                .append(", ")
                .append(runsTable.get())
                .append(", ")
                .append(programmesTable.get())
                .append(" WHERE ")
                .append(ratedTable.get())
                .append(".user_id = ")
                .append(user)
                .append(" ")
                .append("\n AND ")
                .append(ratedTable.get())
                .append(".run_id = ")
                .append(runsTable.get())
                .append(".id ")
                .append("\n AND ")
                .append(programmesTable.get())
                .append(".id = ")
                .append(runsTable.get())
                .append(".programme_id ")
                .append("\n AND ")
                .append(programmesTable.get())
                .append(".cycle_id = ")
                .append(cyclesTable.get())
                .append(".id ");
        return stmt.toString();
    }

    /**
     * Method selRunNotRated
     * 
     * @param cycleLabel
     *            String
     * @param panel
     *            String
     * @return String
     */
    public static String selRunNotRated(String cycleLabel, String panel) {
        StringBuffer stmt = new StringBuffer();
        stmt
                .append("SELECT DISTINCT convert(char(15),")
                .append(runsTable.get())
                .append(".run_code) + convert(char(12),")
                .append(programmesTable.get())
                .append(".panel) + convert(char(16),")
                .append(programmesTable.get())
                .append(".opc_subpanel) + convert(char(12),")
                .append(runsTable.get())
                .append(".tel_code) + convert(char(14),")
                .append(runsTable.get())
                .append(".inst_code) + convert(char(12),")
                .append(refereesTable.get())
                .append(".acronym) + convert(char(30),")
                .append(refereesTable.get())
                .append(".email) ")
                .append(" FROM ")
                .append(cyclesTable.get())
                .append(", ")
                .append(ratedTable.get())
                .append(", ")
                .append(runsTable.get())
                .append(", ")
                .append(programmesTable.get())
                .append(", ")
                .append(refereesTable.get())
                .append(" WHERE ")
                .append(ratedTable.get())
                .append(".user_id = ")
                .append(refereesTable.get())
                .append(".user_id ")
                .append("\n AND ")
                .append(ratedTable.get())
                .append(".run_id = ")
                .append(runsTable.get())
                .append(".id ")
                .append("\n AND ")
                .append(programmesTable.get())
                .append(".id = ")
                .append(runsTable.get())
                .append(".programme_id ")
                .append("\n AND ")
                .append(programmesTable.get())
                .append(".cycle_id = ")
                .append(cyclesTable.get())
                .append(".id ")
                .append("\n AND ")
                .append(refereesTable.get())
                .append(".cycle_id = ")
                .append(cyclesTable.get())
                .append(".id ")
                .append("\n AND ")
                .append(programmesTable.get())
                .append(".panel = '")
                .append(panel)
                .append("' ")
                .append("\n AND ")
                .append(programmesTable.get())
                .append(".ignored = 0 ")
                .append(" AND ( ")
                .append(ratedTable.get())
                .append(".grade = -1 ")
                .append(" OR ")
                .append(ratedTable.get())
                .append(".grade = null) ")
                .append("\n AND ")
                .append(cyclesTable.get())
                .append(".label = '")
                .append(cycleLabel)
                .append("' ")
                .append(" order by ")
                .append(programmesTable.get())
                .append(".panel, ")
                .append(programmesTable.get())
                .append(".opc_subpanel,  ")
                .append(refereesTable.get())
                .append(".acronym  ");
        return stmt.toString();
    }

    /**
     * Method moveProposed
     * 
     * @param oldUser
     *            int
     * @param newUser
     *            int
     * @return String
     */
    public static String moveProposed(int oldUser, int newUser) {
        StringBuffer stmt = new StringBuffer();
        stmt
                .append(" UPDATE ")
                .append(proposedTable.get())
                .append(" ")
                .append(" SET  ")
                .append(proposedTable.get())
                .append(".user_id =  ")
                .append(newUser)
                .append(" WHERE ")
                .append(proposedTable.get())
                .append(".user_id = ")
                .append(oldUser)
                .append(" ");
        return stmt.toString();
    }

    /**
     * Method moveReferee
     * 
     * @param oldUser
     *            long
     * @param newUser
     *            long
     * @param cycleId
     *            int
     * @return String
     */
    public static String moveReferee(long oldUser, long newUser, int cycleId) {
        StringBuffer stmt = new StringBuffer();
        stmt
                .append("UPDATE ")
                .append(refereesTable.get())
                .append(" ")
                .append(" SET  ")
                .append(refereesTable.get())
                .append(".user_id =  ")
                .append(newUser)
                .append(" WHERE ")
                .append(refereesTable.get())
                .append(".cycle_id = ")
                .append(cycleId)
                .append(" ")
                .append("\n AND ")
                .append(refereesTable.get())
                .append(".user_id = ")
                .append(oldUser)
                .append(" ");
        return stmt.toString();
    }

    /**
     * Method deleteUser
     * 
     * @param user
     *            long
     * @return String
     */
    public static String deleteUser(long user) {
        StringBuffer stmt = new StringBuffer();
        stmt.append("\n DELETE FROM ").append(affiliationsTable.get()).append(
                " ").append(" WHERE ").append(affiliationsTable.get()).append(
                ".user_id = ").append(user).append(" ").append(
                "\n DELETE FROM ").append(usersTable.get()).append(" ").append(
                " WHERE ").append(usersTable.get()).append(".id = ").append(
                user).append(" ");
        return stmt.toString();
    }

    /**
     * Added by Judith 24/09/2003 *
     * 
     * @param id
     *            int *
     * @param id
     *            int
     * @param id
     *            int
     * @param id
     *            int
     * @return String
     */
    /** Deletes a row from the sched_rep table */
    public static String schedRepDbDelete(int id) {
        StringBuffer stmt = new StringBuffer();
        stmt
                .append("DELETE ")
                .append("FROM ")
                .append(schedRepTable.get())
                .append(" WHERE ")
                .append(schedRepTable.get())
                .append(".id = ")
                .append(id);
        return stmt.toString();
    }

    /**
     * Added by Judith 10/10/200 *
     * 
     * @param id
     *            int
     * @param published
     *            int *
     * @param id
     *            int
     * @param published
     *            int
     * @param id
     *            int
     * @param published
     *            int
     * @param id
     *            int
     * @param published
     *            int
     * @return String 3333
     */
    /** Set the published flag in the sched_rep table */
    public static String schedRepSetPublishedFlag(long id, int published) {
        StringBuffer stmt = new StringBuffer();
        stmt
                .append("UPDATE ")
                .append(schedRepTable.get())
                .append(" SET published = ")
                .append(published)
                .append(" WHERE ")
                .append(schedRepTable.get())
                .append(".id = ")
                .append(id);
        return stmt.toString();
    }

    /**
     * Added by Judith 16/10/200 *
     * 
     * @param id
     *            int *
     * @param id
     *            int
     * @param id
     *            int
     * @param id
     *            int
     * @return String 3333
     */
    /** Select a row from the obs_runs table */
    public static String obsRunGetRow(int id) {
        StringBuffer stmt = new StringBuffer();
        stmt.append("select programme_id, run_desc from ").append(
                runsTable.get()).append(" where id = ").append(id);
        return stmt.toString();
    }

    /**
     * Added by Judith 16/10/200 *
     * 
     * @param id
     *            int *
     * @param id
     *            int
     * @param id
     *            int
     * @return String 333
     */
    /** Select a row from the obs_runs table */
    public static String obsRunGetCountRow(int id) {
        StringBuffer stmt = new StringBuffer();
        stmt.append("select count(id) from ").append(runsTable.get()).append(
                " where id = ").append(id);
        return stmt.toString();
    }

    /**
     * Method selNotAuthorizedReferees param userIdArray String[] *
     * 
     * @param userIdArray
     *            String[]
     * @return String
     */
    public static String selNotAuthorizedReferees(String[] userIdArray) {
        String userList = TextUtils.arrayToString(userIdArray, "', '", false);
        StringBuffer stmt = new StringBuffer();
        stmt
                .append("\n SELECT DISTINCT ")
                .append(esoUsersRolesTable.get())
                .append(".login ")
                .append(" FROM ")
                .append(esoUsersRolesTable.get())
                .append(" WHERE ")
                .append(esoUsersRolesTable.get())
                .append(".login in ( '")
                .append(userList)
                .append(" ') ")
                .append(" AND (")
                .append(esoUsersRolesTable.get())
                .append(".login not in ( ")
                .append("\n SELECT DISTINCT ")
                .append(esoUsersRolesTable.get())
                .append(".login ")
                .append(" FROM ")
                .append(esoUsersRolesTable.get())
                .append(" WHERE ")
                .append(esoUsersRolesTable.get())
                .append(".letters_role  = 'viewComment' ")
                .append("\n AND ")
                .append(esoUsersRolesTable.get())
                .append(".login in ( '")
                .append(userList)
                .append(" ') )  ")
                .append(" OR ")
                .append(esoUsersRolesTable.get())
                .append(".login not in ( ")
                .append("\n SELECT DISTINCT ")
                .append(esoUsersRolesTable.get())
                .append(".login ")
                .append(" FROM ")
                .append(esoUsersRolesTable.get())
                .append(" WHERE ")
                .append(esoUsersRolesTable.get())
                .append(".letters_role  = 'viewReport' ")
                .append("\n AND ")
                .append(esoUsersRolesTable.get())
                .append(".login in ( '")
                .append(userList)
                .append(" ') ))  ");
        return stmt.toString();
    }

    /**
     * Method insertWotViewCcRcFlag
     * 
     * @param userIdArray
     *            String[]
     * @return String
     */
    public static String insertWotViewCcRcFlag(String[] userIdArray) {
        String userList = TextUtils.arrayToString(userIdArray, "', '", false);
        StringBuffer stmt = new StringBuffer();
        stmt
                .append("\n DELETE FROM ")
                .append(esoUsersRolesTable.get())
                .append(" ")
                .append("\n WHERE ")
                .append(esoUsersRolesTable.get())
                .append(".login in ( '")
                .append(userList)
                .append(" ') ")
                .append("\n AND (")
                .append(esoUsersRolesTable.get())
                .append(".letters_role = 'viewComment' ")
                .append("\n OR ")
                .append(esoUsersRolesTable.get())
                .append(".letters_role = 'viewReport' )");
        for (int i = 0; i < userIdArray.length; i++) {
            stmt
                    .append("\n INSERT INTO ")
                    .append(esoUsersRolesTable.get())
                    .append("(login, letters_role)")
                    .append(" VALUES ('")
                    .append(userIdArray[i])
                    .append("', 'viewComment')");
            stmt
                    .append("\n INSERT INTO ")
                    .append(esoUsersRolesTable.get())
                    .append("(login, letters_role)")
                    .append(" VALUES ('")
                    .append(userIdArray[i])
                    .append("', 'viewReport')");
        }
        return stmt.toString();
    }

    /**
     * Method insertRefDdtRole
     * 
     * @param userIdArray
     *            String[]
     * @return String
     */
    public static String insertRefDdtRole(String[] userIdArray) {
        StringBuffer stmt = new StringBuffer();
        stmt
                .append("\n DELETE FROM ")
                .append(esoUsersRolesTable.get())
                .append(" ")
                .append("\n WHERE ")
                .append(esoUsersRolesTable.get())
                .append(".letters_role = 'refDdt' ");
        for (int i = 0; i < userIdArray.length; i++) {
            stmt
                    .append("\n INSERT INTO ")
                    .append(esoUsersRolesTable.get())
                    .append("(login, letters_role)")
                    .append(" VALUES ('")
                    .append(userIdArray[i])
                    .append("', 'refDdt')");
        }
        return stmt.toString();
    }

    /**
     * Method selProgrPicture
     * 
     * @param proposalId
     *            long
     * @param figureName
     *            String
     * @return String
     */
    public static String selProgrPicture(long proposalId, String figureName) {
        StringBuffer stmt = new StringBuffer();
        stmt
                .append("SELECT  postscript_text ")
                .append(" FROM ")
                .append(figuresTable.get())
                .append(" ")
                .append(" WHERE programme_id = ")
                .append(proposalId)
                .append(" AND file_name = '")
                .append(figureName)
                .append("' ")
                .append(" AND received_flag = 1 ");
        return stmt.toString();
    }

    /**
     * Method selProgrPicture
     * 
     * @param proposalCode
     *            String
     * @param figureName
     *            String
     * @return String
     */
    public static String selProgrPicture(String proposalCode, String figureName) {
        StringBuffer stmt = new StringBuffer();
        stmt.append("SELECT  postscript_text ").append(" FROM ").append(
                figuresTable.get()).append(" ").append(",").append(
                programmesTable.get()).append(" WHERE ").append(
                figuresTable.get()).append(".programme_id = ").append(
                programmesTable.get()).append(".id").append(" AND ").append(
                programmesTable.get()).append(".proposal_code = '").append(
                proposalCode).append("'").append(" AND file_name = '").append(
                figureName).append("' ").append(" AND received_flag = 1 ");
        return stmt.toString();
    }

    /**
     * Method selReceivedFigures
     * 
     * @param proposalId
     *            long
     * @return String
     */
    public static String selReceivedFigures(long proposalId) {
        StringBuffer stmt = new StringBuffer(selFigures(proposalId));
        stmt.append(" AND received_flag = 1 ");
        return stmt.toString();
    }

    /**
     * @param proposalId
     * @return StringBuffer
     */
    public static String selFigures(long proposalId) {
        StringBuffer stmt = new StringBuffer();
        stmt
                .append("SELECT   file_name ")
                .append(" FROM ")
                .append(figuresTable.get())
                .append(" ")
                .append(" WHERE programme_id = ")
                .append(proposalId);
        return stmt.toString();
    }

    /**
     * Method selReceivedFiguresInCache
     * 
     * @param proposalId
     *            long
     * @return String
     */
    public static String selReceivedFiguresInCache(long proposalId) {
        StringBuffer stmt = new StringBuffer();
        stmt.append("SELECT   picture_name ").append(" FROM ").append(
                figureSummaryTable.get()).append(" ").append(
                " WHERE summary_id = ").append(proposalId).append(
                " AND status in (").append(
                ProposalSummaryStatus.FIGURE_RECEIVED).append(", ").append(
                ProposalSummaryStatus.FIGURE_SAVED).append(")");
        return stmt.toString();
    }

    /**
     * Method selReceivedFiguresInCache
     * 
     * @param proposalId
     *            long
     * @return String
     */
    public static String selEmptyFiguresInCache(long proposalId) {
        StringBuffer stmt = new StringBuffer();
        stmt.append("SELECT  count(*) ").append(" FROM ").append(
                figureSummaryTable.get()).append(" ").append(
                " WHERE summary_id = ").append(proposalId).append(
                " AND status = ").append(ProposalSummaryStatus.FIGURE_EMPTY);
        return stmt.toString();
    }

    /**
     * Method selReceivedFigure
     * 
     * @param proposalId
     *            long
     * @param figureName
     *            String
     * @return String
     */
    public static String selReceivedFigure(long proposalId, String figureName) {
        StringBuffer stmt = new StringBuffer();
        stmt
                .append("SELECT file_name ")
                .append(" FROM ")
                .append(figuresTable.get())
                .append(" ")
                .append(" WHERE programme_id = ")
                .append(proposalId)
                .append(" AND file_name = ")
                .append("'")
                .append(figureName)
                .append("'");
        return stmt.toString();
    }

    /**
     * Method selAttachedFigures
     * 
     * @param proposalId
     *            long
     * @return String
     */
    public static String selAttachedFigures(long proposalId) {
        StringBuffer stmt = new StringBuffer();
        stmt
                .append("SELECT count(*) ")
                .append(" FROM ")
                .append(figuresTable.get())
                .append(" ")
                .append(" WHERE programme_id = ")
                .append(proposalId);
        return stmt.toString();
    }

    /**
     * Method selReceivedFigures
     * 
     * @param proposalCode
     *            String
     * @return String
     */
    public static String selReceivedFigures(String proposalCode) {
        StringBuffer stmt = new StringBuffer();
        stmt.append("SELECT   file_name ").append(" FROM ").append(
                figuresTable.get()).append(" ").append(",").append(
                programmesTable.get()).append(" WHERE ").append(
                figuresTable.get()).append(".programme_id = ").append(
                programmesTable.get()).append(".id").append(" AND ").append(
                programmesTable.get()).append(".proposal_code = '").append(
                proposalCode).append("'").append(" AND received_flag = 1 ");
        return stmt.toString();
    }

    /**
     * Method selMissingFigures
     * 
     * @param proposalId
     *            long
     * @return String
     */
    public static String selMissingFigures(long proposalId) {
        StringBuffer stmt = new StringBuffer();
        stmt
                .append("SELECT   file_name ")
                .append(" FROM ")
                .append(figuresTable.get())
                .append(" ")
                .append(" WHERE programme_id = ")
                .append(proposalId)
                .append(" AND received_flag = 0 ");
        return stmt.toString();
    }

    /**
     * Method selCardReferee
     * 
     * @param runId
     *            long
     * @return String
     */
    public static String selCardReferee(long runId) {
        StringBuffer stmt = new StringBuffer();
        stmt
                .append("SELECT  DISTINCT ")
                .append(refereesTable.get())
                .append(".acronym ")
                .append("FROM ")
                .append(ratedTable.get())
                .append(" , ")
                .append(commentsTable.get())
                .append(" , ")
                .append(usersTable.get())
                .append(", ")
                .append(refereesTable.get())
                .append(", ")
                .append(programmesTable.get())
                .append(", ")
                .append(runsTable.get())
                .append(" WHERE ")
                .append(ratedTable.get())
                .append(".run_id = ")
                .append(runId)
                .append("\n AND ")
                .append(programmesTable.get())
                .append(".id = ")
                .append(runsTable.get())
                .append(".programme_id ")
                .append("\n AND ")
                .append(ratedTable.get())
                .append(".run_id = ")
                .append(runsTable.get())
                .append(".id ")
                .append("\n AND ")
                .append(usersTable.get())
                .append(".id = ")
                .append(ratedTable.get())
                .append(".user_id ")
                .append("\n AND ")
                .append(ratedTable.get())
                .append(".run_id = ")
                .append(commentsTable.get())
                .append(".run_id ")
                .append("\n AND ")
                .append(commentsTable.get())
                .append(".user_id = ")
                .append(ratedTable.get())
                .append(".user_id ")
                .append("\n AND ")
                .append(refereesTable.get())
                .append(".cycle_id = ")
                .append(programmesTable.get())
                .append(".cycle_id ")
                .append("\n AND ")
                .append(usersTable.get())
                .append(".id = ")
                .append(refereesTable.get())
                .append(".user_id ")
                .append(" ORDER BY  ")
                .append(refereesTable.get())
                .append(".acronym");
        return stmt.toString();
    }

    /**
     * Method selPrimaryReferee
     * 
     * @param runId
     *            long
     * @return String
     */
    public static String selPrimaryReferee(long runId) {
        StringBuffer stmt = new StringBuffer();
        stmt
                .append(" SELECT  DISTINCT ")
                .append(refereesTable.get())
                .append(".acronym ")
                .append("FROM ")
                .append(ratedTable.get())
                .append(" , ")
                .append(usersTable.get())
                .append(", ")
                .append(refereesTable.get())
                .append(", ")
                .append(programmesTable.get())
                .append(", ")
                .append(runsTable.get())
                .append(" WHERE ")
                .append(ratedTable.get())
                .append(".run_id = ")
                .append(runId)
                .append(" AND  ")
                .append(ratedTable.get())
                .append(".pr_flag = 1 ")
                .append("\n AND ")
                .append(programmesTable.get())
                .append(".id = ")
                .append(runsTable.get())
                .append(".programme_id ")
                .append("\n AND ")
                .append(ratedTable.get())
                .append(".run_id = ")
                .append(runsTable.get())
                .append(".id ")
                .append("\n AND ")
                .append(usersTable.get())
                .append(".id = ")
                .append(ratedTable.get())
                .append(".user_id ")
                .append("\n AND ")
                .append(refereesTable.get())
                .append(".cycle_id = ")
                .append(programmesTable.get())
                .append(".cycle_id ")
                .append("\n AND ")
                .append(usersTable.get())
                .append(".id = ")
                .append(refereesTable.get())
                .append(".user_id ");
        return stmt.toString();
    }

    /**
     * Method selSubpanelRefereeAcronym
     * 
     * @param id
     *            long
     * @return String
     */
    public static String selSubpanelRefUserId(long id) {
        StringBuffer stmt = new StringBuffer();
        stmt
                .append("SELECT DISTINCT ")
                .append(refereesTable.get())
                .append(".user_id ")
                .append("FROM  ")
                .append(refereesTable.get())
                .append(", ")
                .append(runsTable.get())
                .append(", ")
                .append(programmesTable.get())
                .append(" WHERE ")
                .append(runsTable.get())
                .append(".id = ")
                .append(id)
                .append("\n AND ")
                .append(programmesTable.get())
                .append(".id = ")
                .append(runsTable.get())
                .append(".programme_id ")
                .append("\n AND ")
                .append(programmesTable.get())
                .append(".panel = ")
                .append(refereesTable.get())
                .append(".panel ")
                .append("\n AND ")
                .append(programmesTable.get())
                .append(".cycle_id = ")
                .append(refereesTable.get())
                .append(".cycle_id ")
                .append("\n AND ")
                .append(programmesTable.get())
                .append(".opc_subpanel = ")
                .append(refereesTable.get())
                .append(".opc_subpanel ");
        return stmt.toString();
    }

    /**
     * Method selDateStart
     * 
     * @param runId
     *            long
     * @return String
     */
    public static String selDateStart(long runId) {
        StringBuffer stmt = new StringBuffer();
        stmt
                .append("SELECT DISTINCT ")
                .append(schedRepTable.get())
                .append(".from_date ")
                .append("FROM  ")
                .append(schedRepTable.get())
                .append(" ")
                .append(" WHERE ")
                .append(schedRepTable.get())
                .append(".run_id = ")
                .append(runId);
        return stmt.toString();
    }

    /**
     * Method selDateEnd
     * 
     * @param runId
     *            long
     * @return String
     */
    public static String selDateEnd(long runId) {
        StringBuffer stmt = new StringBuffer();
        stmt
                .append("SELECT DISTINCT ")
                .append(schedRepTable.get())
                .append(".to_date ")
                .append("FROM  ")
                .append(schedRepTable.get())
                .append(" ")
                .append(" WHERE ")
                .append(schedRepTable.get())
                .append(".run_id = ")
                .append(runId);
        return stmt.toString();
    }

    /**
     * Method selCommentShort
     * 
     * @param runId
     *            long
     * @return String
     */
    public static String selCommentShort(long runId) {
        StringBuffer stmt = new StringBuffer();
        stmt
                .append("SELECT DISTINCT ")
                .append(commentsTable.get())
                .append(".comment_short ")
                .append("FROM  ")
                .append(commentsTable.get())
                .append(" ")
                .append(" WHERE ")
                .append(commentsTable.get())
                .append(".run_id = ")
                .append(runId)
                .append("\n AND ")
                .append(commentsTable.get())
                .append(".comment_flag = 1");
        return stmt.toString();
    }

    /**
     * Method selCommentLong
     * 
     * @param runId
     *            long
     * @return String
     */
    public static String selCommentLong(long runId) {
        StringBuffer stmt = new StringBuffer();
        stmt
                .append("SELECT ")
                .append(commentsTable.get())
                .append(".comment_long ")
                .append("FROM  ")
                .append(commentsTable.get())
                .append(" ")
                .append(" WHERE ")
                .append(commentsTable.get())
                .append(".run_id = ")
                .append(runId)
                .append("\n AND ")
                .append(commentsTable.get())
                .append(".comment_flag = 1");
        return stmt.toString();
    }

    /**
     * Method selRunComment.
     * 
     * @param runId
     * @return String
     */
    public static String selRunComment(long runId) {
        StringBuffer stmt = new StringBuffer();
        stmt
                .append("SELECT ")
                .append(runCommentTable.get())
                .append(".comment ")
                .append("FROM ")
                .append(runCommentTable.get())
                .append(" ")
                .append(" WHERE ")
                .append(runCommentTable.get())
                .append(".run_id = ")
                .append(runId);
        return stmt.toString();
    }

    /**
     * Method selHtlmFragmentText
     * 
     * @param keyword
     *            String
     * @return String
     */
    public static String selHtlmFragmentText(String keyword) {
        StringBuffer stmt = new StringBuffer();
        stmt
                .append("SELECT ")
                .append(htmlFragTable.get())
                .append(".fragment ")
                .append("FROM  ")
                .append(htmlFragTable.get())
                .append(" WHERE ")
                .append(htmlFragTable.get())
                .append(".keyword = '")
                .append(keyword)
                .append("' ");
        return stmt.toString();
    }

    /**
     * Method selHtlmFragmentTitle
     * 
     * @param keyword
     *            String
     * @return String
     */
    public static String selHtlmFragmentTitle(String keyword) {
        StringBuffer stmt = new StringBuffer();
        stmt
                .append("SELECT ")
                .append(htmlFragTable.get())
                .append(".title ")
                .append("FROM  ")
                .append(htmlFragTable.get())
                .append(" WHERE ")
                .append(htmlFragTable.get())
                .append(".keyword = '")
                .append(keyword)
                .append("' ");
        return stmt.toString();
    }

    /**
     * Method selHtlmFragmentKeywords
     * 
     * @return String
     */
    public static String selHtlmFragmentKeywords() {
        StringBuffer stmt = new StringBuffer();
        stmt
                .append("SELECT ")
                .append(htmlFragTable.get())
                .append(".keyword ")
                .append("FROM  ")
                .append(htmlFragTable.get());
        return stmt.toString();
    }

    /**
     * Method selLargeRefAcronym
     * 
     * @param cycleId
     *            int
     * @param run_id
     *            long
     * @return String
     */
    public static String selLargeRefAcronym(int cycleId, long run_id) {
        StringBuffer stmt = new StringBuffer();
        stmt
                .append("SELECT  ")
                .append(refereesTable.get())
                .append(".acronym ")
                .append("FROM  ")
                .append(refereesTable.get())
                .append(" ")
                .append(" WHERE ")
                .append(refereesTable.get())
                .append(".opc_member = 1 ")
                .append("\n AND ")
                .append(refereesTable.get())
                .append(".cycle_id = ")
                .append(cycleId)
                .append(" UNION ")
                .append("SELECT DISTINCT ")
                .append(refereesTable.get())
                .append(".acronym ")
                .append("FROM  ")
                .append(refereesTable.get())
                .append(", ")
                .append(runsTable.get())
                .append(", ")
                .append(programmesTable.get())
                .append(" WHERE ")
                .append(runsTable.get())
                .append(".id = ")
                .append(run_id)
                .append("\n AND ")
                .append(programmesTable.get())
                .append(".id = ")
                .append(runsTable.get())
                .append(".programme_id ")
                .append("\n AND ")
                .append(programmesTable.get())
                .append(".panel = ")
                .append(refereesTable.get())
                .append(".panel ")
                .append("\n AND ")
                .append(programmesTable.get())
                .append(".cycle_id = ")
                .append(refereesTable.get())
                .append(".cycle_id ")
                .append(" ORDER BY  ")
                .append(refereesTable.get())
                .append(".acronym");
        return stmt.toString();
    }

    /**
     * Method selRefereeId
     * 
     * @param id
     *            long
     * @param acronym
     *            String
     * @return String
     */
    public static String selRefereeId(long id, String acronym) {
        StringBuffer stmt = new StringBuffer();
        stmt
                .append("SELECT   ")
                .append(refereesTable.get())
                .append(".user_id ")
                .append("FROM  ")
                .append(refereesTable.get())
                .append(", ")
                .append(runsTable.get())
                .append(", ")
                .append(programmesTable.get())
                .append("")
                .append(" WHERE ")
                .append(runsTable.get())
                .append(".id = ")
                .append(id)
                .append("\n AND ")
                .append(programmesTable.get())
                .append(".id = ")
                .append(runsTable.get())
                .append(".programme_id ")
                .append(" AND  ")
                .append(refereesTable.get())
                .append(".acronym =  '")
                .append(acronym)
                .append("' ")
                .append("\n AND ")
                .append(programmesTable.get())
                .append(".cycle_id = ")
                .append(refereesTable.get())
                .append(".cycle_id ");
        return stmt.toString();
    }

    /**
     * Method selActiveReferee
     * 
     * @param runId
     *            long
     * @param cycleId
     *            int
     * @return String
     */
    public static String selActiveReferee(long runId, int cycleId) {
        StringBuffer stmt = new StringBuffer();
        stmt
                .append("SELECT   ")
                .append(refereesTable.get())
                .append(".acronym ")
                .append("FROM ")
                .append(ratedTable.get())
                .append(" , ")
                .append(refereesTable.get())
                .append(" ")
                .append(" WHERE ")
                .append(ratedTable.get())
                .append(".run_id = ")
                .append(runId)
                .append("\n AND ")
                .append(refereesTable.get())
                .append(".user_id = ")
                .append(ratedTable.get())
                .append(".user_id ")
                .append("\n AND ")
                .append(refereesTable.get())
                .append(".cycle_id = ")
                .append(cycleId)
                .append(" ORDER BY  ")
                .append(refereesTable.get())
                .append(".acronym");
        return stmt.toString();
    }

    /**
     * Method wcReferees
     * 
     * @param panel
     *            String
     * @param cycle
     *            String
     * @return String
     */
    public static String wcReferees(String panel, String cycle) {
        StringBuffer stmt = new StringBuffer();
        stmt
                .append(refereesTable.get())
                .append(".acronym != ''  ")
                .append(" AND  ")
                .append(refereesTable.get())
                .append(".panel = '")
                .append(panel)
                .append("' ")
                .append("\n AND ")
                .append(cyclesTable.get())
                .append(".label = '")
                .append(cycle)
                .append("' ")
                .append("   order by ")
                .append(refereesTable.get())
                .append(".opc_subpanel, ")
                .append(refereesTable.get())
                .append(".user_id desc ");
        return stmt.toString();
    }

    /**
     * Method wcRefereesByCycle
     * 
     * @param cycleId
     *            int
     * @return String
     */
    public static String wcRefereesByCycle(int cycleId) {
        StringBuffer stmt = new StringBuffer();
        stmt
                .append(refereesTable.get())
                .append(".acronym != ''  ")
                .append("\n AND ")
                .append(refereesTable.get())
                .append(".cycle_id =")
                .append(cycleId)
                .append(" ");
        return stmt.toString();
    }

    /**
     * Method wcRefereesByCycle
     * 
     * @param cycleLabel
     *            int
     * @return String
     */
    public static String wcRefereesByCycleLabel(String cycleLabel) {
        StringBuffer stmt = new StringBuffer();
        stmt.append(refereesTable.get()).append(".acronym != ''  ").append(
                " AND ").append(cyclesTable.get()).append(".label ='").append(
                cycleLabel).append("' ");
        return stmt.toString();
    }

    /**
     * Method wcReferees
     * 
     * @param userId
     *            long
     * @return String
     */
    public static String wcReferees(long userId) {
        StringBuffer stmt = new StringBuffer();
        stmt.append(" user_id = ").append(userId).append(" ").append(
                orderByReferee);
        return stmt.toString();
    }

    /**
     * Method wcReferees
     * 
     * @param cycleLabel
     *            String
     * @param panel
     *            char
     * @param subpanel
     *            int
     * @return String
     */
    public static String wcReferees(String cycleLabel, char panel, int subpanel) {
        StringBuffer stmt = new StringBuffer();
        stmt
                .append(refereesTable.get())
                .append(".acronym != '' ")
                .append(" AND  ")
                .append(refereesTable.get())
                .append(".panel = '")
                .append(panel)
                .append("' ")
                .append(" AND  ")
                .append(refereesTable.get())
                .append(".opc_subpanel = ")
                .append(subpanel)
                .append(" ")
                .append("\n AND ")
                .append(cyclesTable.get())
                .append(".label = '")
                .append(cycleLabel)
                .append("' ")
                .append(orderByReferee);
        return stmt.toString();
    }

    /**
     * Method wcCurrReferee
     * 
     * @param cycleId
     *            int
     * @param acronym
     *            String
     * @return String
     */
    public static String wcCurrReferee(int cycleId, String acronym) {
        StringBuffer stmt = new StringBuffer();
        stmt
                .append(refereesTable.get())
                .append(".acronym = '")
                .append(acronym)
                .append("' ")
                .append("\n AND ")
                .append(refereesTable.get())
                .append(".cycle_id = ")
                .append(cycleId)
                .append(" ");
        return stmt.toString();
    }

    /**
     * Method wcRefereeOpcMembers
     * 
     * @param cycleLabel
     *            String
     * @param panel
     *            char
     * @param subpanel
     *            int
     * @return String
     */
    public static String wcRefereeOpcMembers(String cycleLabel, char panel,
            int subpanel) {
        StringBuffer stmt = new StringBuffer();
        stmt
                .append(refereesTable.get())
                .append(".acronym != '' ")
                .append(" AND  ")
                .append(refereesTable.get())
                .append(".panel = '")
                .append(panel)
                .append("' ")
                .append("\n AND ")
                .append(refereesTable.get())
                .append(".opc_subpanel = ")
                .append(subpanel)
                .append(" ")
                .append("\n AND ")
                .append(cyclesTable.get())
                .append(".label = '")
                .append(cycleLabel)
                .append("' ")
                .append("\n AND ")
                .append(refereesTable.get())
                .append(".opc_member = 1 ")
                .append(orderByReferee);
        return stmt.toString();
    }

    /**
     * Method wcRefereeOpcMembers
     * 
     * @param cycleLabel
     *            String
     * @param panel
     *            char
     * @return String
     */
    public static String wcRefereesPanel(String cycleLabel, char panel) {
        StringBuffer stmt = new StringBuffer();
        stmt
                .append(refereesTable.get())
                .append(".acronym != '' ")
                .append(" AND  ")
                .append(refereesTable.get())
                .append(".panel = '")
                .append(panel)
                .append("' ")
                .append("\n AND ")
                .append(cyclesTable.get())
                .append(".label = '")
                .append(cycleLabel)
                .append("' ")
                .append(orderByReferee);
        return stmt.toString();
    }

    /**
     * Method wcRefereeOpcMembers
     * 
     * @param cycleLabel
     *            String
     * @return String
     */
    public static String wcRefereeOpcMembers(String cycleLabel) {
        StringBuffer stmt = new StringBuffer();
        stmt.append(refereesTable.get()).append(".acronym != '' ").append(
                " AND ").append(cyclesTable.get()).append(".label = '").append(
                cycleLabel).append("' ").append(" AND ").append(
                refereesTable.get()).append(".opc_member = 1 ").append(
                orderByReferee);
        return stmt.toString();
    }

    /**
     * Method wcOpcReferees
     * 
     * @param cycleLabel
     *            String
     * @param panel
     *            char
     * @param subpanel
     *            int
     * @return String
     */
    public static String wcOpcReferees(String cycleLabel, char panel,
            int subpanel) {
        StringBuffer stmt = new StringBuffer();
        stmt
                .append(refereesTable.get())
                .append(".acronym != '' ")
                .append(" AND  ")
                .append(refereesTable.get())
                .append(".panel = '")
                .append(panel)
                .append("' ")
                .append("\n AND ")
                .append(refereesTable.get())
                .append(".opc_subpanel = ")
                .append(subpanel)
                .append(" ")
                .append("\n AND ")
                .append(cyclesTable.get())
                .append(".label = '")
                .append(cycleLabel)
                .append("' ")
                .append("\n AND ")
                .append(refereesTable.get())
                .append(".opc_member = 1 ")
                .append(orderByReferee);
        return stmt.toString();
    }

    /**
     * Method wcAssignedReferees
     * 
     * @param runId
     *            long
     * @param cycleId
     *            long
     * @return String
     */
    public static String wcAssignedReferees(long runId, long cycleId) {
        StringBuffer stmt = new StringBuffer();
        stmt
                .append(ratedTable.get())
                .append(".run_id = ")
                .append(runId)
                .append(" ")
                .append("\n AND ")
                .append(refereesTable.get())
                .append(".user_id = ")
                .append(ratedTable.get())
                .append(".user_id ")
                .append("\n AND ")
                .append(refereesTable.get())
                .append(".cycle_id = ")
                .append(cycleId)
                .append(" ORDER BY ")
                .append(ratedTable.get())
                .append(".pr_flag desc \n\n");
        return stmt.toString();
    }

    /**
     * Method wcAssignedReferees
     * 
     * @param runId
     *            long
     * @param cycleId
     *            long
     * @return String
     */
    public static String wcAssignedPrimaryReferees(long runId, long cycleId) {
        StringBuffer stmt = new StringBuffer();
        stmt
                .append(ratedTable.get())
                .append(".run_id = ")
                .append(runId)
                .append(" ")
                .append("\n AND ")
                .append(refereesTable.get())
                .append(".user_id = ")
                .append(ratedTable.get())
                .append(".user_id ")
                .append("\n AND ")
                .append(refereesTable.get())
                .append(".cycle_id = ")
                .append(cycleId)
                .append("\n AND ")
                .append(ratedTable.get())
                .append(".pr_flag = 1 ");
        return stmt.toString();
    }

    /**
     * Method wcAssignedRefereesTables
     * 
     * @return String
     */
    public static String wcAssignedRefereesTables() {
        StringBuffer stmt = new StringBuffer();
        stmt.append(", ").append(ratedTable.get());
        return stmt.toString();
    }

    /**
     * Method wcAssignedRefereesTables return String
     */
    public static String wcAssignedPrimaryRefereesTables() {
        StringBuffer stmt = new StringBuffer();
        stmt.append(", ").append(ratedTable.get());
        return stmt.toString();
    }

    /**
     * Method wcProgrammeTel
     * 
     * @param panel
     *            char
     * @param cycle
     *            String
     * @param isLarge
     *            boolean
     * @param is_vlt
     *            boolean
     * @return String
     */
    public static String wcProgrammeTel(char panel, String cycle,
            boolean isLarge, boolean is_vlt) {
        StringBuffer tel_clause = new StringBuffer();
        if (is_vlt) {

            tel_clause.append(" AND ").append(telescopeTable.get()).append(
                    ".observatory = 'P' ");
        } else {
            tel_clause.append(" AND ").append(telescopeTable.get()).append(
                    ".observatory = 'L' ");
        }
        StringBuffer stmt = new StringBuffer();
        stmt
                .append(programmesTable.get())
                .append(".panel = '")
                .append(panel)
                .append("' ")
                .append("\n AND ")
                .append(programmesTable.get())
                .append(".ignored = 0")
                .append("\n AND ")
                .append(runsTable.get())
                .append(".programme_id = ")
                .append(programmesTable.get())
                .append(".id ")
                .append("\n AND ")
                .append(runsTable.get())
                .append(".tel_code = ")
                .append(telescopeTable.get())
                .append(".code ")
                .append("\n AND ")
                .append(cyclesTable.get())
                .append(".id = ")
                .append(programmesTable.get())
                .append(".cycle_id ")
                .append("\n AND ")
                .append(cyclesTable.get())
                .append(".label = '")
                .append(cycle)
                .append("' ");
        if (isLarge) {
            stmt.append(" AND ").append(programmesTable.get()).append(
                    ".gto = 4 ");
        } else {
            stmt.append(" AND ").append(programmesTable.get()).append(
                    ".gto in (0,1,3) ");
        }
        stmt.append(tel_clause.toString());
        return stmt.toString();
    }
    
    public static String wcProposalNoConflicts(char panel, String cycle,  boolean isLarge, boolean is_vlt){
    	//StringBuffer tel_clause = new StringBuffer();
    	StringBuffer stmt = new StringBuffer(wcProgrammeTel(panel, cycle, isLarge, is_vlt));
    	stmt.append(" AND ")
    	    .append(programmesTable.get())
    		.append(".id NOT IN (")
    		.append("SELECT DISTINCT ")
    		.append(programmesTable.get())
    		.append(".id")
    		.append(" FROM ")
    		.append(programmesTable.get())
    		.append(", ")
    		.append(proposedTable.get())
    		.append(", ")
    		.append(cyclesTable.get())
    		.append(" WHERE ")
    		.append(proposedTable.get())
    		.append(".programme_id = ")
    		.append(programmesTable)
    		.append(".id")
    		.append(" \nAND ")
    		.append(cyclesTable.get())
    		.append(".id = ")
    		.append(programmesTable)
    		.append(".cycle_id")
    		.append(" \nAND ")
    		.append(programmesTable.get())
    		.append(".panel = '")
    		.append(panel)
    		.append("' \nAND ")
    		.append(cyclesTable.get())
    		.append(".label = '")
    		.append(cycle)
    		.append("' \nAND ")
    		
    		.append("ignored = 0")
    		.append(" \nAND ")
    		.append(proposedTable.get())
    		.append(".user_id IN ( SELECT ")
    		.append(refereesTable.get())
    		.append(".user_id")
    		.append(" \nFROM ")
    		.append(refereesTable.get())
    		.append(", ")
    		.append(cyclesTable.get())
    		.append(" \nWHERE ")
    		.append(cyclesTable.get())
    		.append(".id = ")
    		.append(refereesTable.get())
    		.append(".cycle_id ")
    		.append(" \nAND ")
    		.append(cyclesTable.get())
    		.append(".label = '")
    		.append(cycle)
    		.append("' \nAND ")
    		
    		.append("panel = '")
    		.append(panel)
    		.append("' ))");
    		
    	return stmt.toString();
  
    }
    
    public static String wcProposalConflicts(char panel, String cycle,  boolean isLarge, boolean is_vlt){
    	//StringBuffer tel_clause = new StringBuffer();
    	StringBuffer stmt = new StringBuffer(wcProgrammeTel(panel, cycle, isLarge, is_vlt));
    	stmt.append(" \nAND ")
    		.append(proposedTable.get())
    		.append(".programme_id = ")
    		.append(programmesTable)
    		.append(".id")
    		.append(" \nAND ")
    		.append(programmesTable.get())
    		.append(".panel = '")
    		.append(panel)
    		.append("' \nAND ")
    		.append(programmesTable.get())
    		.append(".ignored = 0")
    		.append(" \nAND ")
    		.append(proposedTable.get())
    		.append(".user_id IN ( SELECT ")
    		.append(refereesTable.get())
    		.append(".user_id")
    		.append(" \nFROM ")
    		.append(refereesTable.get())
    		.append(", ")
    		.append(cyclesTable.get())
    		.append(" \nWHERE ")
    		.append(cyclesTable.get())
    		.append(".id = ")
    		.append(refereesTable.get())
    		.append(".cycle_id ")
    		.append(" \nAND ")
    		.append(cyclesTable.get())
    		.append(".label = '")
    		.append(cycle)
    		.append("' \nAND ")
    		.append(refereesTable.get())
    		.append(".panel = '")
    		.append(panel)
    		.append("' )");
    		
    	return stmt.toString();
  
    }

    /**
     * Method wcProgrammeTable
     * 
     * @return String
     */
    public static String wcProgrammeTable() {
        StringBuffer stmt = new StringBuffer();
        stmt.append(" ,").append(runsTable.get());
        return stmt.toString();
    }

  
    /**
     * Method wcProgrammeTableTel
     * 
     * @return String
     */
    public static String wcProgrammeTableTelNoConflicts() {
        StringBuffer stmt = new StringBuffer();
        stmt.append(" ,").append(runsTable.get()).append(" ,").append(
                telescopeTable.get());
        return stmt.toString();
    }
    
    public static String wcProgrammeTableTelConflicts() {
        StringBuffer stmt = new StringBuffer();
        stmt.append(" ,").append(runsTable.get()).append(" ,").append(
                proposedTable.get()).append(" ,").append(
                telescopeTable.get());
        return stmt.toString();
    }

    /**
     * Method wcRunTable
     * 
     * @return String
     */
    public static String wcRunTable() {
        StringBuffer stmt = new StringBuffer();
        stmt.append(" ,").append(runsTable.get());
        return stmt.toString();
    }

    /**
     * Method wcProgramme
     * 
     * @param panel
     *            char
     * @param subpanel
     *            int
     * @param cycle
     *            String
     * @return String
     */
    public static String wcProgramme(char panel, int subpanel, String cycle) {
        StringBuffer stmt = new StringBuffer();
        stmt
                .append(programmesTable.get())
                .append(".panel = '")
                .append(panel)
                .append("' ")
                .append("\n AND ")
                .append(programmesTable.get())
                .append(".opc_subpanel = ")
                .append(subpanel)
                .append(" ")
                .append("\n AND ")
                .append(programmesTable.get())
                .append(".ignored = 0")
                .append(" AND " + cyclesTable.get())
                .append(".id = ")
                .append(programmesTable.get())
                .append(".cycle_id ")
                .append("\n AND ")
                .append(cyclesTable.get())
                .append(".label = '")
                .append(cycle)
                .append("' ");
        return stmt.toString();
    }

    public static String wcProgrammeObsRun(long userID, int cycleId) {
        String stmt = programmesTable.get() + ".id = " + proposedTable.get()
                + ".programme_id" + " AND " + programmesTable.get()
                + ".ignored = 0" + " AND " + proposedTable.get()
                + ".user_id = " + userID + " AND " + proposedTable.get()
                + ".pi_flag = 0" + " AND " + runsTable.get()
                + ".programme_id = " + programmesTable.get() + ".id " + " AND "
                + programmesTable.get() + ".cycle_id = " + cycleId
                + " ORDER BY " + programmesTable.get() + ".id ";
        return stmt;
    }

    /**
     * Method wcProgrammeSched
     * 
     * @param userID
     *            long
     * @param period
     *            int
     * @return String
     */
    public static String wcProgrammeSched(long userID, int period) {
        StringBuffer stmt = new StringBuffer();
        stmt
                .append(programmesTable.get())
                .append(".id = ")
                .append(proposedTable.get())
                .append(".programme_id")
                .append("\n AND ")
                .append(programmesTable.get())
                .append(".ignored = 0")
                .append("\n AND ")
                .append(proposedTable.get())
                .append(".user_id = ")
                .append(userID)
                .append("\n AND ")
                .append(proposedTable.get())
                .append(".pi_flag = 0")
                .append("\n AND ")
                .append(runsTable.get())
                .append(".programme_id = ")
                .append(programmesTable.get())
                .append(".id ")
                .append("\n AND ")
                .append(runsTable.get())
                .append(".id = ")
                .append(schedRepTable.get())
                .append(".run_id ")
                .append("\n AND ")
                .append(schedRepTable.get())
                .append(".period = ")
                .append(period)
                .append(" ORDER BY ")
                .append(programmesTable.get())
                .append(".id ");
        return stmt.toString();
    }

    /**
     * Method wcRunsRatedTables
     * 
     * @return String
     */
    public static String wcRunsRatedTables() {
        StringBuffer stmt = new StringBuffer();
        stmt.append(" ,").append(ratedTable.get()).append(" ,").append(
                programmesTable.get()).append(" ,").append(cyclesTable.get());
        return stmt.toString();
    }

    /**
     * Method wcProgrammeSchedTable
     * 
     * @return String
     */
    public static String wcProgrammeSchedTable() {
        StringBuffer stmt = new StringBuffer();
        stmt.append(" ,").append(proposedTable.get()).append(" ,").append(
                runsTable.get()).append(" ,").append(schedRepTable.get());
        return stmt.toString();
    }

    /**
     * Method wcProgrammeObsRunTable
     * 
     * @return String
     */
    public static String wcProgrammeObsRunTable() {
        StringBuffer stmt = new StringBuffer();
        stmt.append(" ,").append(proposedTable.get()).append(" ,").append(
                runsTable.get());
        return stmt.toString();
    }

    /**
     * Method wcRatedRefRunsTable.
     * 
     * @return long
     */
    public static String wcRatedRefRunsTable() {
        StringBuffer stmt = new StringBuffer();
        stmt.append(" ,").append(ratedTable.get()).append(" ,").append(
                programmesTable.get());
        return stmt.toString();
    }

    /**
     * Method wcRatedRefRuns
     * 
     * @param progId
     *            long
     * @param user_id
     *            long
     * @return String
     */
    public static String wcRatedRefRuns(long progId, long user_id) {
        StringBuffer stmt = new StringBuffer();
        stmt
                .append(ratedTable.get())
                .append(".run_id = ")
                .append(runsTable.get())
                .append(".id ")
                .append("\n AND ")
                .append(runsTable.get())
                .append(".programme_id = ")
                .append(progId)
                .append("\n AND ")
                .append(programmesTable.get())
                .append(".id = ")
                .append(runsTable.get())
                .append(".programme_id ")
                .append("\n AND ")
                .append(programmesTable.get())
                .append(".ignored = 0")
                .append("\n AND ")
                .append(ratedTable.get())
                .append(".user_id = ")
                .append(user_id)
                .append(" ORDER BY ")
                .append(runsTable.get())
                .append(".id ");
        return stmt.toString();
    }

    /**
     * Method wcProgrammeCommentRef. the programmes having this referee. Primary
     * is a subset
     * 
     * @param cycleLabel
     * @param userId
     * @return Class
     */
    public static String wcProgrammeCommentRef(String cycleLabel, long userId) {
        StringBuffer stmt = new StringBuffer();
        stmt
                .append(ratedTable.get())
                .append(".run_id = ")
                .append(runsTable.get())
                .append(".id ")
                .append("\n AND ")
                .append(programmesTable.get())
                .append(".id = ")
                .append(runsTable.get())
                .append(".programme_id ")
                .append("\n AND ")
                .append(programmesTable.get())
                .append(".ignored = 0")
                .append("\n AND ")
                .append(programmesTable.get())
                .append(".cycle_id = ")
                .append(cyclesTable.get())
                .append(".id ")
                .append("\n AND ")
                .append(cyclesTable.get())
                .append(".label = '")
                .append(cycleLabel)
                .append("'")
                .append("\n AND ")
                .append(ratedTable.get())
                .append(".user_id = ")
                .append(refereesTable.get())
                .append(".user_id ")
                .append("\n AND ")
                .append(refereesTable.get())
                .append(".cycle_id = ")
                .append(cyclesTable.get())
                .append(".id ")
                .append("\n AND ")
                .append(refereesTable.get())
                .append(".user_id = ")
                .append(userId);
        return stmt.toString();
    }

    /**
     * Method wcProgrammeRefTable.
     * 
     * @return long
     */
    public static String wcProgrammeCommentRefTable() {
        StringBuffer stmt = new StringBuffer();
        stmt.append(" ,").append(runsTable.get()).append(" ,").append(
                ratedTable.get()).append(" ,").append(refereesTable.get());
        return stmt.toString();
    }

    /**
     * Method wcRuns
     * 
     * @param programmeId
     *            long
     * @return String
     */
    public static String wcRuns(long programmeId) {
        StringBuffer stmt = new StringBuffer();
        stmt
                .append(runsTable.get())
                .append(".programme_id = ")
                .append(programmeId)
                .append(" ORDER BY ")
                .append(runsTable.get())
                .append(".id ");
        return stmt.toString();
    }

    /**
     * Method wcRunProgrammesTables
     * 
     * @return String
     */
    public static String wcRunProgrammesTables() {
        StringBuffer stmt = new StringBuffer();
        stmt.append(" ,").append(programmesTable.get());
        return stmt.toString();
    }

    /**
     * Method wcReportCard.
     * 
     * @param runId
     * @return Class
     */
    public static String wcReportCard(long runId) {
        StringBuffer stmt = new StringBuffer();
        stmt
                .append(ratedTable.get())
                .append(".run_id = ")
                .append(runId)
                .append(" ORDER BY ")
                .append(ratedTable.get())
                .append(".run_id");
        return stmt.toString();
    }

    /**
     * Method wcReportCard.
     * 
     * @param runId
     * @return Class
     */
    public static String wcReportAndCommentCard(long runId) {
        StringBuffer stmt = new StringBuffer();
        stmt
                .append(commentsTable.get())
                .append(".run_id = ")
                .append(runId)
                .append(" ORDER BY ")
                .append(commentsTable.get())
                .append(".run_id");
        return stmt.toString();
    }

    /**
     * Method wcReportCard.
     * 
     * @param runId
     * @return Class
     */
    public static String wcCommentCard(long runId) {
        StringBuffer stmt = new StringBuffer();
        stmt
                .append(commentsTable.get())
                .append(".run_id = ")
                .append(runId)
                .append("\n AND ")
                .append(commentsTable.get())
                .append(".comment_flag = 1 ");
        return stmt.toString();
    }

    /**
     * Method wcRunCutOff
     * 
     * @param panel
     *            String
     * @param opcSubpanel
     *            int
     * @param telescope
     *            String
     * @param cycleId
     *            int
     * @param run_code
     *            String
     * @return String
     */
    public static String wcRunCutOff(String panel, int opcSubpanel,
            String telescope, int cycleId, String run_code) {
        StringBuffer stmt = new StringBuffer();
        stmt
                .append(runsTable.get())
                .append(".run_code like '%-")
                .append(run_code)
                .append("'")
                .append("\n AND ")
                .append(runsTable.get())
                .append(".tel_code = '")
                .append(telescope)
                .append("' AND ")
                .append(programmesTable.get())
                .append(".cycle_id = ")
                .append(cycleId)
                .append("\n AND ")
                .append(programmesTable.get())
                .append(".opc_subpanel = ")
                .append(opcSubpanel)
                .append("\n AND ")
                .append(programmesTable.get())
                .append(".panel = '")
                .append(panel)
                .append("' AND ")
                .append(programmesTable.get())
                .append(".ignored = 0")
                .append(" AND   ")
                .append(programmesTable.get())
                .append(".id = ")
                .append(runsTable.get())
                .append(".programme_id");
        return stmt.toString();
    }

    /**
     * Method wcRunCutOff param panel String
     * 
     * @param opcSubpanel
     *            int
     * @param telescope
     *            String
     * @param cycleId
     *            int
     * @return String
     */
    public static String selectRunCodeList(String panel, int opcSubpanel,
            String telescope, int cycleId) {
        StringBuffer stmt = new StringBuffer();
        stmt
                .append(" SELECT ")
                .append(runsTable.get())
                .append(".run_code ")
                .append(" FROM ")
                .append(runsTable.get())
                .append(", ")
                .append(programmesTable.get())
                .append(" WHERE ")
                .append(runsTable.get())
                .append(".tel_code = '")
                .append(telescope)
                .append("' AND ")
                .append(programmesTable.get())
                .append(".cycle_id = ")
                .append(cycleId)
                .append("\n AND ")
                .append(programmesTable.get())
                .append(".opc_subpanel = ")
                .append(opcSubpanel)
                .append("\n AND ")
                .append(programmesTable.get())
                .append(".panel = '")
                .append(panel)
                .append("' AND ")
                .append(programmesTable.get())
                .append(".ignored = 0")
                .append(" AND   ")
                .append(programmesTable.get())
                .append(".id = ")
                .append(runsTable.get())
                .append(".programme_id");
        return stmt.toString();
    }

    /**
     * Method wcBelowRuns
     * 
     * @param telCode
     *            String
     * @param panel
     *            String
     * @param opcSubpanel
     *            int
     * @param rank
     *            int
     * @param cycleId
     *            int
     * @return String
     */
    public static String wcBelowRuns(String telCode, String panel,
            int opcSubpanel, int rank, int cycleId) {
        StringBuffer stmt = new StringBuffer();
        stmt
                .append(runsTable.get())
                .append(".tel_code = '")
                .append(telCode)
                .append("' ")
                .append(" AND   ")
                .append(programmesTable.get())
                .append(".panel = '")
                .append(panel)
                .append("' ")
                .append(" AND   ")
                .append(programmesTable.get())
                .append(".opc_subpanel = ")
                .append(opcSubpanel)
                .append("\n AND ")
                .append(programmesTable.get())
                .append(".cycle_id = ")
                .append(cycleId)
                .append(" AND   ")
                .append(runsTable.get())
                .append(".assigned_time > 0 ")
                .append("\n AND ")
                .append(programmesTable.get())
                .append(".ignored = 0")
                .append(" AND   ")
                .append(programmesTable.get())
                .append(".id = ")
                .append(runsTable.get())
                .append(".programme_id")
                .append(" AND   ")
                .append(runsTable.get())
                .append(".rank > ")
                .append(rank);
        return stmt.toString();
    }

    /**
     * Method wcAboveRuns
     * 
     * @param telCode
     *            String
     * @param panel
     *            String
     * @param opcSubpanel
     *            int
     * @param rank
     *            int
     * @param cycleId
     *            int
     * @return String
     */
    public static String wcAboveRuns(String telCode, String panel,
            int opcSubpanel, int rank, int cycleId) {
        StringBuffer stmt = new StringBuffer();
        stmt
                .append(runsTable.get())
                .append(".tel_code = '")
                .append(telCode)
                .append("' ")
                .append(" AND   ")
                .append(programmesTable.get())
                .append(".panel = '")
                .append(panel)
                .append("' ")
                .append(" AND   ")
                .append(programmesTable.get())
                .append(".opc_subpanel = ")
                .append(opcSubpanel)
                .append(" AND   ")
                .append(programmesTable.get())
                .append(".cycle_id = ")
                .append(cycleId)
                .append("\n AND ")
                .append(programmesTable.get())
                .append(".ignored = 0")
                .append(" AND   ")
                .append(runsTable.get())
                .append(".assigned_time > 0 ")
                .append(" AND   ")
                .append(programmesTable.get())
                .append(".id = ")
                .append(runsTable.get())
                .append(".programme_id")
                .append(" AND   ")
                .append(runsTable.get())
                .append(".rank <= ")
                .append(rank);
        return stmt.toString();
    }

    /**
     * Method wcSchedRuns
     * 
     * @param programmeId
     *            long
     * @return String
     */
    public static String wcSchedRuns(long programmeId) {
        StringBuffer stmt = new StringBuffer();
        stmt.append(runsTable.get()).append(".programme_id = ").append(
                programmeId).append(" AND ").append(runsTable.get()).append(
                ".id = ").append(schedRepTable.get()).append(".run_id").append(
                " ORDER BY ").append(runsTable.get()).append(".id ");
        return stmt.toString();
    }

    /**
     * Method wcSchedRunsPublished
     * 
     * @param programmeId
     *            long
     * @return String
     */
    public static String wcSchedRunsPublished(long programmeId) {
        StringBuffer stmt = new StringBuffer();
        stmt
                .append(runsTable.get())
                .append(".programme_id = ")
                .append(programmeId)
                .append("\n AND ")
                .append(runsTable.get())
                .append(".id = ")
                .append(schedRepTable.get())
                .append(".run_id")
                .append("\n AND ")
                .append(schedRepTable.get())
                .append(".published = 1")
                .append(" ORDER BY ")
                .append(runsTable.get())
                .append(".id ");
        return stmt.toString();
    }

    /**
     * Method wcSchedRunsPrivate
     * 
     * @param programmeId
     *            long
     * @return String
     */
    public static String wcSchedRunsPrivate(long programmeId) {
        StringBuffer stmt = new StringBuffer();
        stmt
                .append(runsTable.get())
                .append(".programme_id = ")
                .append(programmeId)
                .append("\n AND ")
                .append(runsTable.get())
                .append(".id = ")
                .append(schedRepTable.get())
                .append(".run_id")
                .append("\n AND ")
                .append(schedRepTable.get())
                .append(".published = 0")
                .append(" ORDER BY ")
                .append(runsTable.get())
                .append(".id ");
        return stmt.toString();
    }

    /**
     * Method delRated
     * 
     * @param run_id
     *            long
     * @return String
     */
    public static String delRated(long run_id) {
        StringBuffer stmt = new StringBuffer();
        stmt
                .append("DELETE ")
                .append(" FROM ")
                .append(ratedTable.get())
                .append(" ")
                .append("WHERE run_id  = ")
                .append(run_id)
                .append("\n\n");
        return stmt.toString();
    }

    /**
     * Method updateObserver
     * 
     * @param observerName
     *            String
     * @param observerEmail
     *            String
     * @param runId
     *            long
     * @return String
     */
    public static String updateObserver(String observerName,
            String observerEmail, long runId) {
        StringBuffer stmt = new StringBuffer();
        stmt
                .append("UPDATE ")
                .append(schedRepTable.get())
                .append("")
                .append(" SET observer = '")
                .append(observerName)
                .append("' ")
                .append(", observerEmail = '")
                .append(observerEmail)
                .append("' ")
                .append(" WHERE run_id  = ")
                .append(runId)
                .append(" ");
        return stmt.toString();
    }

    /**
     * Method updateCommentLong
     * 
     * @param commentLong
     *            String
     * @param runId
     *            long
     * @return String
     */
    public static String updateCommentLong(String commentLong, long runId) {
        StringBuffer stmt = new StringBuffer();
        stmt
                .append("UPDATE ")
                .append(commentsTable.get())
                .append("")
                .append(" SET comment_short = NULL")
                .append(", comment_long = '")
                .append(commentLong)
                .append("' ")
                .append(" WHERE run_id  = ")
                .append(runId)
                .append(" AND comment_flag = 1");
        return stmt.toString();
    }

    /**
     * Method updatePrintedFlag
     * 
     * @param id
     *            long
     * @param flag
     *            int
     * @return String
     */
    public static String updatePrintedFlag(long id, int flag) {
        StringBuffer stmt = new StringBuffer();
        stmt.append("UPDATE ").append(programmesTable.get()).append("").append(
                " SET printed = ").append(flag).append(" WHERE id  = ").append(
                id);
        return stmt.toString();
    }

    /**
     * Method insertCommentRow
     * 
     * @param userId
     *            long
     * @param runId
     *            long
     * @return String
     */
    public static String insertCommentRow(long userId, long runId) {
        StringBuffer stmt = new StringBuffer();
        stmt.append("INSERT ").append(commentsTable.get()).append("").append(
                "(user_id, run_id, comment_flag) ").append(" VALUES (").append(
                userId).append(", ").append(runId).append(", 1) ");
        return stmt.toString();
    }

    /**
     * Method updateRunComment
     * 
     * @param comment
     *            String
     * @param runId
     *            long
     * @return String
     */
    public static String updateRunComment(String comment, long runId) {
        StringBuffer stmt = new StringBuffer();
        stmt.append("UPDATE ").append(runCommentTable.get()).append("").append(
                " SET comment = '").append(comment).append("' ").append(
                " WHERE run_id  = ").append(runId);
        return stmt.toString();
    }

    /**
     * Method updateActiveReferee
     * 
     * @param runId
     *            long
     * @param user_id
     *            long
     * @return String
     */
    public static String insertActiveReferee(long runId, long user_id) {
        StringBuffer stmt = new StringBuffer();
        stmt
                .append(" INSERT ")
                .append(" INTO ")
                .append(ratedTable.get())
                .append(" ")
                .append(" (user_id, run_id, pr_flag, card_id, grade, nights, ")
                .append(
                        " strengths, weaknesses, feasibility, overall1, overall2)")
                .append("VALUES (")
                .append(user_id)
                .append(", ")
                .append(runId)
                .append(", 0, 0, -1, 0, '', '', '', '', '') ");
        return stmt.toString();
    }

    /**
     * Method updatePrimaryReferee
     * 
     * @param id
     *            long
     * @param user_id
     *            long
     * @return String
     */
    public static String updatePrimaryReferee(long id, long user_id) {
        StringBuffer stmt = new StringBuffer();
        stmt
                .append(" INSERT ")
                .append(" INTO ")
                .append(ratedTable.get())
                .append(" ")
                .append(" (user_id, run_id, pr_flag, card_id, grade, nights, ")
                .append(
                        " strengths, weaknesses, feasibility, overall1, overall2)")
                .append("VALUES (")
                .append(user_id)
                .append(", ")
                .append(id)
                .append(", 1, 0, -1, 0, '', '', '', '', '') ");
        return stmt.toString();
    }

    /**
     * Method updatePicture
     * 
     * @param programme_id
     *            int
     * @param fileName
     *            String
     * @return String
     */
    public static String updatePicture(int programme_id, String fileName) {
        StringBuffer stmt = new StringBuffer();
        stmt.append("UPDATE ").append(figuresTable.get()).append(
                " set postscript_text = ").append(getQuestionMark()).append(
                " WHERE file_name = '").append(fileName).append("'").append(
                " AND programme_id = ").append(programme_id).append("\n\n");
        return stmt.toString();
    }

    /**
     * Method updateReceivedFiguresFlag
     * 
     * @param programme_id
     *            int
     * @param fileName
     *            String
     * @return String
     */
    public static String updateReceivedFiguresFlag(long programme_id,
            String fileName) {
        StringBuffer stmt = new StringBuffer();
        stmt
                .append("UPDATE ")
                .append(figuresTable.get())
                .append(" set received_flag = 1 ")
                .append(" WHERE file_name = '")
                .append(fileName)
                .append("'")
                .append(" AND programme_id = ")
                .append(programme_id)
                .append("\n\n");
        return stmt.toString();
    }

    /**
     * Method selExpectedFigures
     * 
     * @param id
     *            int
     * @return String
     */
    public static String selExpectedFigures(int id) {
        StringBuffer stmt = new StringBuffer();
        stmt
                .append("SELECT attachments FROM ")
                .append(programmesTable.get())
                .append(" WHERE id = ")
                .append(id);
        return stmt.toString();
    }

    /**
     * Method updateAccessedLetterFlag
     * 
     * @param userId
     *            long
     * @param cycleId
     *            long
     * @param time
     *            long
     * @return String
     */
    public static String updateAccessedLetterFlag(long userId, long cycleId,
            long time) {
        StringBuffer stmt = new StringBuffer();
        stmt
                .append("UPDATE ")
                .append(affiliationsTable.get())
                .append(" SET accessed_letter = ")
                .append(time)
                .append(" WHERE user_id = ")
                .append(userId)
                .append(" AND   cycle_id = ")
                .append(cycleId);
        return stmt.toString();
    }

    /**
     * Method insertWotEditCcFlag
     * 
     * @param userId
     *            long
     * @return String
     */
    public static String insertWotEditCcFlag(long userId) {
        StringBuffer stmt = new StringBuffer();
        stmt
                .append("INSERT INTO ")
                .append(esoUsersRolesTable.get())
                .append("(login, letters_role)")
                .append(" VALUES('")
                .append(userId)
                .append("', 'editComment')");
        return stmt.toString();
    }

    /**
     * Method insertWotEditRcFlag
     * 
     * @param userId
     *            long
     * @return String
     */
    public static String insertWotEditRcFlag(long userId) {
        StringBuffer stmt = new StringBuffer();
        stmt
                .append("INSERT INTO ")
                .append(esoUsersRolesTable.get())
                .append("(login, letters_role)")
                .append(" VALUES('")
                .append(userId)
                .append("', 'editReport')");
        return stmt.toString();
    }

    /**
     * Method deleteWotEditCcFlag
     * 
     * @param userId
     *            long
     * @return String
     */
    public static String deleteWotEditCcFlag(long userId) {
        StringBuffer stmt = new StringBuffer();
        stmt.append("DELETE ").append(esoUsersRolesTable.get()).append(
                " WHERE login ='").append(userId).append(
                "' AND letters_role = 'editComment'");
        return stmt.toString();
    }

    /**
     * Method insertWotPermissionFlag
     * 
     * @param userId
     *            long
     * @return String
     */
    public static String insertReportCardPermissionFlag(long userId) {
        StringBuffer stmt = new StringBuffer();
        stmt.append("DELETE ").append(esoUsersRolesTable.get()).append(
                " WHERE  login ='").append(userId).append(
                "' AND (letters_role = 'editReport'").append(
                " OR letters_role = 'viewReport')\n");
        stmt
                .append("INSERT INTO ")
                .append(esoUsersRolesTable.get())
                .append("(login, letters_role)")
                .append(" VALUES('")
                .append(userId)
                .append("', 'editReport')\n");
        stmt
                .append("INSERT INTO ")
                .append(esoUsersRolesTable.get())
                .append("(login, letters_role)")
                .append(" VALUES('")
                .append(userId)
                .append("', 'viewReport')\n");
        return stmt.toString();
    }

    /**
     * Method insertWotPermissionFlag
     * 
     * @param userId
     *            long
     * @return String
     */
    public static String insertCommentCardPermissionFlag(long userId) {
        StringBuffer stmt = new StringBuffer();
        stmt.append("DELETE ").append(esoUsersRolesTable.get()).append(
                " WHERE  login ='").append(userId).append(
                "' AND (letters_role = 'editComment'").append(
                " OR letters_role = 'viewComment')\n");
        stmt
                .append("INSERT INTO ")
                .append(esoUsersRolesTable.get())
                .append("(login, letters_role)")
                .append(" VALUES('")
                .append(userId)
                .append("', 'editComment')\n");
        stmt
                .append("INSERT INTO ")
                .append(esoUsersRolesTable.get())
                .append("(login, letters_role)")
                .append(" VALUES('")
                .append(userId)
                .append("', 'viewComment')\n");
        return stmt.toString();
    }

    /**
     * Method deleteWotEditRcFlag
     * 
     * @param userId
     *            long
     * @return String
     */
    public static String deleteWotEditRcFlag(long userId) {
        StringBuffer stmt = new StringBuffer();
        stmt.append("DELETE ").append(esoUsersRolesTable.get()).append(
                " WHERE login ='").append(userId).append(
                "' AND letters_role = 'editReport'");
        return stmt.toString();
    }

    /**
     * Method insRated
     * 
     * @param referee_id
     *            long
     * @param run_id
     *            long
     * @param pr_flag
     *            int
     * @param j
     *            int
     * @return String
     */
    public static String insRated(long referee_id, long run_id, int pr_flag,
            int j) {
        StringBuffer stmt = new StringBuffer();
        stmt
                .append("INSERT INTO ")
                .append(ratedTable.get())
                .append(
                        " (user_id, run_id, pr_flag, card_id, comment_card_id) ")
                .append("VALUES (")
                .append(referee_id)
                .append(", ")
                .append(run_id)
                .append(", ")
                .append(pr_flag)
                .append(", -1, -1)\n\n");
        return stmt.toString();
    }

    /**
     * Method transferRatedFlagCommentRow
     * 
     * @param userId
     *            long
     * @param runId
     *            long
     * @return String
     */
    public static String setPrimaryRef(long userId, long runId) {
        StringBuffer stmt = new StringBuffer();
        stmt
                .append(" \n\n UPDATE ")
                .append(ratedTable.get())
                .append(" SET pr_flag = 0 ")
                .append(" WHERE ")
                .append(ratedTable.get())
                .append(".run_id = ")
                .append(runId)
                .append(" \n\n UPDATE ")
                .append(ratedTable.get())
                .append(" SET pr_flag = 1 ")
                .append(" WHERE ")
                .append(ratedTable.get())
                .append(".run_id = ")
                .append(runId)
                .append("\n AND ")
                .append(ratedTable.get())
                .append(".user_id = ")
                .append(userId);
        return stmt.toString();
    }

    /**
     * Method transferRatedAndComment
     * 
     * @param oldRef
     *            long
     * @param newRef
     *            long
     * @param runId
     *            long
     * @return String
     */
    public static String moveRatedCommentCycle(long oldRef, long newRef,
            int cycleId) {
        StringBuffer stmt = new StringBuffer();
        stmt
                .append("INSERT INTO ")
                .append(ratedTable.get())
                .append(
                        " (user_id, run_id, pr_flag, grade, nights, card_id, comment_card_id, conflicts) ")
                .append("SELECT ")
                .append(newRef)
                .append(", ")
                .append(ratedTable.get())
                .append(".run_id,  ")
                .append(ratedTable.get())
                .append(".pr_flag, ")
                .append(ratedTable.get())
                .append(".grade, ")
                .append(ratedTable.get())
                .append(".nights, ")
                .append(ratedTable.get())
                .append(".card_id, ")
                .append(ratedTable.get())
                .append(".comment_card_id, ")
                .append(ratedTable.get())
                .append(".conflicts ")
                .append(" FROM ")
                .append(ratedTable.get())
                .append(", ")
                .append(programmesTable.get())
                .append(", ")
                .append(runsTable.get())
                .append("\n WHERE ")
                .append(ratedTable.get())
                .append(".run_id = ")
                .append(runsTable.get())
                .append(".id ")
                .append("\n AND ")
                .append(runsTable.get())
                .append(".programme_id = ")
                .append(programmesTable.get())
                .append(".id ")
                .append("\n AND ")
                .append(programmesTable.get())
                .append(".cycle_id = ")
                .append(cycleId)
                .append("\n AND ")
                .append(ratedTable.get())
                .append(".user_id = ")
                .append(oldRef)
                .append("  \n\n UPDATE ")
                .append(commentsTable.get())
                .append(" SET ")
                .append(commentsTable.get())
                .append(".user_id = ")
                .append(newRef)
                .append(" \n FROM ")
                .append(commentsTable.get())
                .append(", ")
                .append(programmesTable.get())
                .append(", ")
                .append(runsTable.get())
                .append(" WHERE ")
                .append(commentsTable.get())
                .append(".run_id = ")
                .append(runsTable.get())
                .append(".id ")
                .append("\n AND ")
                .append(runsTable.get())
                .append(".programme_id = ")
                .append(programmesTable.get())
                .append(".id ")
                .append("\n AND ")
                .append(programmesTable.get())
                .append(".cycle_id = ")
                .append(cycleId)
                .append("\n AND ")
                .append(commentsTable.get())
                .append(".user_id = ")
                .append(oldRef)
                .append("  \n\n DELETE ")
                .append(ratedTable.get())
                .append(" FROM ")
                .append(ratedTable.get())
                .append(", ")
                .append(programmesTable.get())
                .append(", ")
                .append(runsTable.get())
                .append("\n WHERE ")
                .append(ratedTable.get())
                .append(".run_id = ")
                .append(runsTable.get())
                .append(".id ")
                .append("\n AND ")
                .append(runsTable.get())
                .append(".programme_id = ")
                .append(programmesTable.get())
                .append(".id ")
                .append("\n AND ")
                .append(programmesTable.get())
                .append(".cycle_id = ")
                .append(cycleId)
                .append("\n AND ")
                .append(ratedTable.get())
                .append(".user_id = ")
                .append(oldRef);
        return stmt.toString();
    }

    /**
     * Method transferRatedAndComment
     * 
     * @param oldRef
     *            long
     * @param newRef
     *            long
     * @param runId
     *            long
     * @return String
     */
    public static String copyRatedComment(long oldRef, long newRef, long runId) {
        StringBuffer stmt = new StringBuffer();
        stmt
                .append("INSERT INTO ")
                .append(ratedTable.get())
                .append(
                        " (user_id, run_id, pr_flag, grade, nights, card_id, comment_card_id, conflicts) ")
                .append("SELECT ")
                .append(newRef)
                .append(
                        ", run_id,  pr_flag, grade, nights, card_id, comment_card_id, 0 ")
                .append(" FROM ")
                .append(ratedTable.get())
                .append(" WHERE ")
                .append(ratedTable.get())
                .append(".run_id = ")
                .append(runId)
                .append("\n AND ")
                .append(ratedTable.get())
                .append(".user_id = ")
                .append(oldRef)
                .append("  \n\n UPDATE ")
                .append(commentsTable.get())
                .append(" SET user_id = ")
                .append(newRef)
                .append(" WHERE ")
                .append(commentsTable.get())
                .append(".run_id = ")
                .append(runId)
                .append("\n AND ")
                .append(commentsTable.get())
                .append(".user_id = ")
                .append(oldRef);
        return stmt.toString();
    }

    /**
     * Method transferRatedAndComment
     * 
     * @param oldRef
     *            long
     * @param runId
     *            long
     * @return String
     */
    public static String deleteRatedComment(long oldRef, long runId) {
        StringBuffer stmt = new StringBuffer();
        stmt
                .append(" \n\n DELETE ")
                .append(commentsTable.get())
                .append(" WHERE ")
                .append(commentsTable.get())
                .append(".run_id = ")
                .append(runId)
                .append("\n AND ")
                .append(commentsTable.get())
                .append(".user_id = ")
                .append(oldRef)
                .append(" \n\n DELETE ")
                .append(ratedTable.get())
                .append(" WHERE ")
                .append(ratedTable.get())
                .append(".run_id = ")
                .append(runId)
                .append("\n AND ")
                .append(ratedTable.get())
                .append(".user_id = ")
                .append(oldRef);
        return stmt.toString();
    }

    /**
     * Method insertRunComment.
     * 
     * @param comment
     * @param runId
     * @return String
     */
    public static String insertRunComment(String comment, long runId) {
        StringBuffer stmt = new StringBuffer();
        stmt.append("INSERT INTO ").append(runCommentTable.get()).append(
                " values(").append(runId).append(",'").append(comment).append(
                "')");
        return stmt.toString();
    }

    /**
     * Method insertLatexSource
     * 
     * @param programme_id
     *            long
     * @param abstractText
     *            String
     * @return String
     */
    public static String insertLatexSourceRow(long programme_id,
            String abstractText) {
        StringBuffer stmt = new StringBuffer();
        stmt.append("INSERT INTO ").append(latexTable.get()).append(
                " (programme_id, abstract_text, latex_text) ").append(
                " VALUES (").append(programme_id).append(",\'").append(
                TextUtils.quoteSqlString(abstractText)).append("\',\'\')");
        return stmt.toString();
    }

    /**
     * Method insertPicture
     * 
     * @param programme_id
     *            int
     * @param fileName
     *            String
     * @return String
     */
    public static String insertPicture(int programme_id, String fileName) {
        StringBuffer stmt = new StringBuffer();
        stmt
                .append("INSERT INTO ")
                .append(figuresTable.get())
                .append(
                        " (programme_id, file_name, postscript_text , received_flag) ")
                .append("VALUES (")
                .append(programme_id)
                .append(",'")
                .append(fileName)
                .append("','")
                .append(fileName)
                .append("',1)\n\n");
        return stmt.toString();
    }

    /**
     * Method insertLatexSource param programme_id long *
     * 
     * @param programme_id
     *            long
     * @return String
     */
    public static String insertLatexSource(long programme_id) {
        StringBuffer stmt = new StringBuffer();
        stmt.append("UPDATE ").append(latexTable.get()).append(
                " set latex_text = ").append(getQuestionMark()).append(
                " WHERE programme_id = ").append(programme_id);
        return stmt.toString();
    }

    /**
     * Method insertLatexSource param programme_id long *
     * 
     * @param programme_id
     *            long
     * @param figureName
     *            String
     * @return String
     */
    public static String insertFigureSource(long programme_id, String figureName) {
        StringBuffer stmt = new StringBuffer();
        stmt.append("UPDATE ").append(figuresTable.get()).append(
                " set postscript_text = ").append(getQuestionMark()).append(
                " WHERE programme_id = ").append(programme_id).append(
                " AND file_name = \'").append(figureName).append("\'");
        return stmt.toString();
    }

    /**
     * Method
     * 
     * @param label
     *            String
     * @return String
     */
    public static String wcCycleLabel(String label) {
        StringBuffer stmt = new StringBuffer();
        stmt
                .append(cyclesTable.get())
                .append(".label = '")
                .append(label)
                .append("' ");
        return stmt.toString();
    }

    /**
     * @param runId
     *            long
     * @param cycleId
     *            int
     * @return referee list
     */
    public static String wcRefWithConflicts(long runId, int cycleId) {
        StringBuffer stmt = new StringBuffer();
        stmt
                .append(refereesTable.get())
                .append(".cycle_id = ")
                .append(cycleId)
                .append("\n AND ")
                .append(refereesTable.get())
                .append(".user_id = ")
                .append(ratedTable.get())
                .append(".user_id ")
                .append("\n AND ")
                .append(ratedTable.get())
                .append(".run_id = ")
                .append(runId)
                .append("\n AND ")
                .append(ratedTable.get())
                .append(".conflicts = 1 ");
        return stmt.toString();
    }

    /**
     * @return referee list table
     */
    public static String wcRefWithConflictsTables() {
        StringBuffer stmt = new StringBuffer();
        stmt.append(", ").append(ratedTable.get());
        return stmt.toString();
    }

    /**
     * @param runId
     *            long
     * @param cycleId
     *            int
     * @return referee list
     */
    public static String wcRefRated(long runId, int cycleId) {
        StringBuffer stmt = new StringBuffer();
        stmt
                .append(refereesTable.get())
                .append(".cycle_id = ")
                .append(cycleId)
                .append("\n AND ")
                .append(refereesTable.get())
                .append(".user_id = ")
                .append(ratedTable.get())
                .append(".user_id ")
                .append("\n AND ")
                .append(ratedTable.get())
                .append(".run_id = ")
                .append(runId);
        return stmt.toString();
    }

    /**
     * @return referee list table
     */
    public static String wcRefRatedTables() {
        StringBuffer stmt = new StringBuffer();
        stmt.append(", ").append(ratedTable.get());
        return stmt.toString();
    }

    /**
     * @param cycleId
     *            int
     * @return referee list
     */
    public static String wcRefUsersList(int cycleId) {
        StringBuffer stmt = new StringBuffer();
        stmt
                .append(refereesTable.get())
                .append(".cycle_id = ")
                .append(cycleId)
                .append("\n AND ")
                .append(refereesTable.get())
                .append(".user_id = ")
                .append(usersTable.get())
                .append(".id ")
                .append(" ORDER by ")
                .append(refereesTable.get())
                .append(".panel, ")
                .append(refereesTable.get())
                .append(".opc_subpanel, ")
                .append(refereesTable.get())
                .append(".chair DESC, ")
                .append(refereesTable.get())
                .append(".opc_member DESC, ")
                .append(refereesTable.get())
                .append(".acronym ");
        return stmt.toString();
    }

    /**
     * @return referee list table
     */
    public static String wcRefUsersListTables() {
        StringBuffer stmt = new StringBuffer();
        stmt.append(", ").append(refereesTable.get());
        return stmt.toString();
    }

    /**
     * @param user
     * @param run
     * @return report card cycle
     */
    public static String selCycleFromReportCard(long user, long run) {
        StringBuffer stmt = new StringBuffer();
        stmt
                .append("SELECT DISTINCT  ")
                .append(refereesTable.get())
                .append(".cycle_id ")
                .append(" FROM ")
                .append(runsTable.get())
                .append(", ")
                .append(refereesTable.get())
                .append(", ")
                .append(ratedTable.get())
                .append(", ")
                .append(programmesTable.get())
                .append(" WHERE  ")
                .append(refereesTable.get())
                .append(".user_id = ")
                .append(ratedTable.get())
                .append(".user_id ")
                .append("\n AND ")
                .append(programmesTable.get())
                .append(".id = ")
                .append(runsTable.get())
                .append(".programme_id ")
                .append("\n AND ")
                .append(ratedTable.get())
                .append(".run_id = ")
                .append(runsTable.get())
                .append(".id ")
                .append("\n AND ")
                .append(runsTable.get())
                .append(".id = ")
                .append(run)
                .append("\n AND ")
                .append(programmesTable.get())
                .append(".cycle_id = ")
                .append(refereesTable.get())
                .append(".cycle_id ");
        return stmt.toString();
    }

    /**
     * @param userId
     * @param cycleId_
     * @param isComment
     *            boolean
     * @return count of empty comment cards
     */
    public static String selCountEmptyCards(long userId, int cycleId_,
            boolean isComment) {
        int commentFlag = 0;
        if (isComment) {
            commentFlag = 1;
        }
        StringBuffer stmt = new StringBuffer();
        stmt
                .append("SELECT  count(*) ")
                .append(" FROM ")
                .append(commentsTable.get())
                .append(",")
                .append(programmesTable.get())
                .append(",")
                .append(runsTable.get())
                .append(",")
                .append(ratedTable.get())
                .append(" WHERE ")
                .append(commentsTable.get())
                .append(".user_id = ")
                .append(userId)
                .append("\n AND ")
                .append(commentsTable.get())
                .append(".run_id = ")
                .append(runsTable.get())
                .append(".id")
                .append("\n AND ")
                .append(runsTable.get())
                .append(".programme_id = ")
                .append(programmesTable.get())
                .append(".id")
                .append("\n AND ")
                .append(runsTable.get())
                .append(".run_desc = 'A'")
                .append("\n AND ")
                .append(programmesTable.get())
                .append(".cycle_id = ")
                .append(cycleId_)
                .append("\n AND ")
                .append(commentsTable.get())
                .append(".comment_flag = ")
                .append(commentFlag)
                .append(" AND (")
                .append(commentsTable.get())
                .append(".comment_long like '' OR convert(varchar(1), ")
                .append(commentsTable.get())
                .append(".comment_long) = null) AND (")
                .append(commentsTable.get())
                .append(".comment_short = '' OR  ")
                .append(commentsTable.get())
                .append(".comment_short = null)")
                .append("\n AND ")
                .append(ratedTable.get())
                .append(".conflicts = 0")
                .append("\n AND ")
                .append(ratedTable.get())
                .append(".user_id = ")
                .append(commentsTable.get())
                .append(".user_id")
                .append("\n AND ")
                .append(ratedTable.get())
                .append(".run_id = ")
                .append(commentsTable.get())
                .append(".run_id");
        return stmt.toString();
    }

    /**
     * @param userId
     * @param runIdStart
     * @param runIdEnd
     * @return count of rows marked as conflicts.
     */
    public static String selCountConflicts(long userId, long runIdStart,
            long runIdEnd) {

        StringBuffer stmt = new StringBuffer();
        stmt
                .append("SELECT  count(*) ")
                .append(" FROM ")
                .append(ratedTable.get())
                .append(" WHERE ")
                .append(ratedTable.get())
                .append(".user_id = ")
                .append(userId)
                .append("\n AND ")
                .append(ratedTable.get())
                .append(".conflicts = 1")
                .append("\n AND ")
                .append(ratedTable.get())
                .append(".run_id > ")
                .append(runIdStart)
                .append("\n AND ")
                .append(ratedTable.get())
                .append(".run_id < ")
                .append(runIdEnd);
        return stmt.toString();
    }

    /**
     * @param userId
     * @param cycleId
     * @param primary
     *            boolean
     * @return count of rated rows
     */
    public static String selCountRated(long userId, int cycleId, boolean primary) {
        StringBuffer stmt = new StringBuffer();
        stmt
                .append("SELECT count(*) FROM ")
                .append(ratedTable.get())
                .append(",")
                .append(programmesTable.get())
                .append(",")
                .append(runsTable.get())
                .append(" WHERE ")
                .append(ratedTable.get())
                .append(".run_id = ")
                .append(runsTable.get())
                .append(".id")
                .append("\n AND ")
                .append(runsTable.get())
                .append(".run_desc = 'A'")
                .append("\n AND ")
                .append(runsTable.get())
                .append(".programme_id = ")
                .append(programmesTable.get())
                .append(".id")
                .append("\n AND ")
                .append(programmesTable.get())
                .append(".cycle_id = ")
                .append(cycleId)
                .append("\n AND ")
                .append(programmesTable.get())
                .append(".ignored = 0")
                .append("\n AND ")
                .append(ratedTable.get())
                .append(".user_id=")
                .append(userId)
                .append("\n AND ")
                .append(ratedTable.get())
                .append(".conflicts = 0");

        if (primary) {
            stmt.append(" AND ").append(ratedTable.get()).append(
                    ".pr_flag = 1 ");
        }
        return stmt.toString();
    }

    /**
     * @param userId
     * @param cycleId
     * @param primary
     *            boolean
     * @return count of rated rows by programme
     */
    public static String selCountRatedProgrammme(long userId, int cycleId,
            boolean primary) {
        StringBuffer stmt = new StringBuffer();
        stmt
                .append("SELECT count(*) FROM ")
                .append(ratedTable.get())
                .append(",")
                .append(programmesTable.get())
                .append(",")
                .append(runsTable.get())
                .append(" WHERE ")
                .append(ratedTable.get())
                .append(".run_id = ")
                .append(runsTable.get())
                .append(".id")
                .append("\n AND ")
                .append(runsTable.get())
                .append(".run_desc = 'A'")
                .append("\n AND ")
                .append(runsTable.get())
                .append(".programme_id = ")
                .append(programmesTable.get())
                .append(".id")
                .append("\n AND ")
                .append(programmesTable.get())
                .append(".cycle_id = ")
                .append(cycleId)
                .append("\n AND ")
                .append(programmesTable.get())
                .append(".ignored = 0")
                .append("\n AND ")
                .append(ratedTable.get())
                .append(".user_id=")
                .append(userId)
                .append("\n AND ")
                .append(ratedTable.get())
                .append(".conflicts = 0");

        if (primary) {
            stmt.append("\n AND ").append(ratedTable.get()).append(
                    ".pr_flag = 1 ");
        }
        return stmt.toString();
    }

    /**
     * @param conflicts
     * @param runId
     * @return count of rated rows
     */
    public static String updateConflictsRated(int conflicts, long runId) {
        StringBuffer stmt = new StringBuffer();
        stmt
                .append("UPDATE ")
                .append(ratedTable.get())
                .append(" SET ")
                .append(ratedTable.get())
                .append(".conflicts = ")
                .append(conflicts)
                .append(" WHERE ")
                .append(ratedTable.get())
                .append(".run_id = ")
                .append(runId);

        return stmt.toString();
    }

    /**
     * @param userId
     * @param runId
     * @return count of rated rows
     */
    public static String selCountPrimaryRow(long userId, long runId) {
        StringBuffer stmt = new StringBuffer();
        stmt
                .append("SELECT count(*) FROM ")
                .append(ratedTable.get())
                .append(" WHERE ")
                .append(ratedTable.get())
                .append(".run_id = ")
                .append(runId)
                .append("\n AND ")
                .append(ratedTable.get())
                .append(".user_id=")
                .append(userId)
                .append("\n AND ")
                .append(ratedTable.get())
                .append(".pr_flag = 1 ");
        return stmt.toString();
    }

    /**
     * @param cycleId
     * @return count of rated rows
     */
    public static String selCountReferees(int cycleId) {
        StringBuffer stmt = new StringBuffer();
        stmt
                .append("SELECT count(*) FROM ")
                .append(refereesTable.get())
                .append(" WHERE ")
                .append(refereesTable.get())
                .append(".cycle_id = ")
                .append(cycleId);
        return stmt.toString();
    }

    /**
     * @param userId
     * @param cycleId
     * @return return count of comment cards
     */
    public static String selCountCommentCards(long userId, int cycleId) {
        StringBuffer stmt = new StringBuffer();
        stmt
                .append("SELECT count(*) FROM ")
                .append(commentsTable.get())
                .append(",")
                .append(programmesTable.get())
                .append(",")
                .append(runsTable.get())
                .append(" WHERE ")
                .append(commentsTable.get())
                .append(".run_id = ")
                .append(runsTable.get())
                .append(".id")
                .append("\n AND ")
                .append(runsTable.get())
                .append(".run_desc = 'A'")
                .append("\n AND ")
                .append(runsTable.get())
                .append(".programme_id = ")
                .append(programmesTable.get())
                .append(".id")
                .append("\n AND ")
                .append(programmesTable.get())
                .append(".cycle_id = ")
                .append(cycleId)
                .append("\n AND ")
                .append(programmesTable.get())
                .append(".ignored = 0")
                .append("\n AND ")
                .append(commentsTable.get())
                .append(".comment_flag=1")
                .append("\n AND ")
                .append(commentsTable.get())
                .append(".user_id=")
                .append(userId);
        return stmt.toString();
    }

    /**
     * @param userId
     * @param cycleId
     * @return return count of comment cards
     */
    public static String selCountReportCards(long userId, int cycleId) {
        StringBuffer stmt = new StringBuffer();
        stmt
                .append("SELECT count(*) FROM ")
                .append(commentsTable.get())
                .append(",")
                .append(programmesTable.get())
                .append(",")
                .append(runsTable.get())
                .append(",")
                .append(ratedTable.get())
                .append(" WHERE ")
                .append(commentsTable.get())
                .append(".run_id = ")
                .append(runsTable.get())
                .append(".id")
                .append("\n AND ")
                .append(runsTable.get())
                .append(".run_desc = 'A'")
                .append("\n AND ")
                .append(runsTable.get())
                .append(".programme_id = ")
                .append(programmesTable.get())
                .append(".id")
                .append("\n AND ")
                .append(programmesTable.get())
                .append(".cycle_id = ")
                .append(cycleId)
                .append("\n AND ")
                .append(programmesTable.get())
                .append(".ignored = 0")
                .append("\n AND ")
                .append(commentsTable.get())
                .append(".comment_flag=0")
                .append("\n AND ")
                .append(commentsTable.get())
                .append(".user_id=")
                .append(userId)
                .append("\n AND ")
                .append(ratedTable.get())
                .append(".conflicts = 0")
                .append("\n AND ")
                .append(ratedTable.get())
                .append(".user_id = ")
                .append(commentsTable.get())
                .append(".user_id")
                .append("\n AND ")
                .append(ratedTable.get())
                .append(".run_id = ")
                .append(commentsTable.get())
                .append(".run_id");
        return stmt.toString();
    }

    /**
     * @return String
     */
    public static String wcObserverEmpty() {
        StringBuffer stmt = new StringBuffer();
        stmt.append("( observer = '' or observer = NULL ").append(
                " or observer_email = '' or observer_email = NULL ) ");
        return stmt.toString();
    }

    /**
     * @param affil
     * @return String
     */
    public static String insertAffiliation(Affiliation affil) {
        StringBuffer stmt = new StringBuffer();
        stmt
                .append("INSERT INTO ")
                .append(affiliationsTable.get())
                .append(
                        " (user_id,period,country_code,affiliation, cycle_id, accessed_letter) ")
                .append("VALUES (")
                .append(affil.getUserId())
                .append(", ")
                .append(affil.getPeriod())
                .append(", '")
                .append(affil.getCountryCode())
                .append("', '")
                .append(affil.getInstitution())
                .append("', ")
                .append(affil.getCycleId())
                .append(", null)\n\n");
        return stmt.toString();
    }

    /**
     * @param listRunId
     * @return String
     */
    public static String selCyclesFromRun(String listRunId) {
        StringBuffer stmt = new StringBuffer();
        stmt
                .append("SELECT DISTINCT ")
                .append(programmesTable.get())
                .append(".cycle_id ")
                .append(" FROM ")
                .append(programmesTable.get())
                .append(", ")
                .append(runsTable.get())
                .append(" WHERE ")
                .append(runsTable.get())
                .append(".programme_id = ")
                .append(programmesTable.get())
                .append(".id ")
                .append("\n AND ")
                .append(runsTable.get())
                .append(".id in ( ")
                .append(listRunId)
                .append(") ");
        return stmt.toString();
    }

    /**
     * @param progId
     * @param userId
     *            long
     * @return String
     */
    public static String selPrFlagFromRun(long progId, long userId) {
        StringBuffer stmt = new StringBuffer();
        stmt
                .append("SELECT DISTINCT ")
                .append(ratedTable.get())
                .append(".pr_flag ")
                .append(" FROM ")
                .append(ratedTable.get())
                .append(", ")
                .append(runsTable.get())
                .append(" WHERE ")
                .append(runsTable.get())
                .append(".programme_id = ")
                .append(progId)
                .append(" ")
                .append("\n AND ")
                .append(ratedTable.get())
                .append(".user_id = ")
                .append(userId)
                .append("\n AND ")
                .append(ratedTable.get())
                .append(".run_id = ")
                .append(runsTable.get())
                .append(".id ");
        return stmt.toString();
    }

    /**
     * @param progId
     * @param userId
     *            long
     * @param prFlag
     *            int
     * @return String
     */
    public static String countRatedCommented(long progId, long userId,
            int prFlag) {
        StringBuffer stmt = new StringBuffer();
        stmt
                .append("SELECT count(*) ")
                .append(" FROM ")
                .append(ratedTable.get())
                .append(", ")
                .append(commentsTable.get())
                .append(", ")
                .append(runsTable.get())
                .append(" WHERE ")
                .append(ratedTable.get())
                .append(".run_id = ")
                .append(commentsTable.get())
                .append(".run_id ")
                .append("\n AND ")
                .append(commentsTable.get())
                .append(".user_id = ")
                .append(ratedTable.get())
                .append(".user_id ")
                .append("\n AND ")
                .append(commentsTable.get())
                .append(".comment_flag = 0  ")
                .append("\n AND ")
                .append(runsTable.get())
                .append(".programme_id = ")
                .append(progId)
                .append("\n AND ")
                .append(ratedTable.get())
                .append(".user_id = ")
                .append(userId)
                .append("\n AND ")
                .append(ratedTable.get())
                .append(".pr_flag  = ")
                .append(prFlag)
                .append("\n AND ")
                .append(ratedTable.get())
                .append(".run_id = ")
                .append(runsTable.get())
                .append(".id ");
        return stmt.toString();
    }

    /**
     * @param id
     * @return String
     */
    public static String selAbstractFromRunId(long id) {
        StringBuffer stmt = new StringBuffer();
        stmt
                .append("SELECT abstract_text FROM ")
                .append(runsTable.get())
                .append(", ")
                .append(latexTable.get())
                .append(" WHERE ")
                .append(latexTable.get())
                .append(".programme_id = ")
                .append(runsTable.get())
                .append(".programme_id ")
                .append("\n AND ")
                .append(runsTable.get())
                .append(".id=")
                .append(id);
        return stmt.toString();
    }

    /**
     * @return String
     */
    public static String wcAllWebLettersUsersTables() {
        StringBuffer stmt = new StringBuffer();
        stmt
                .append(" ,")
                .append(schedRepTable.get())
                .append(" ,")
                .append(runsTable.get())
                .append(" ,")
                .append(proposedTable.get())
                .append(" ,")
                .append(programmesTable.get());
        return stmt.toString();
    }

    /**
     * @param period
     * @return String
     */
    public static String wcAllWebLettersUsers(int period) {
        StringBuffer stmt = new StringBuffer();
        stmt
                .append(proposedTable.get())
                .append(".pi_flag = 0 ")
                .append(" AND  ")
                .append(schedRepTable.get())
                .append(".period = ")
                .append(period)
                .append(" AND  ")
                .append(schedRepTable.get())
                .append(".published = 1 ")
                .append(" AND  ")
                .append(schedRepTable.get())
                .append(".run_id =  ")
                .append(runsTable.get())
                .append(".id ")
                .append(" AND  ")
                .append(programmesTable.get())
                .append(".id =  ")
                .append(runsTable.get())
                .append(".programme_id ")
                .append(" AND  ")
                .append(programmesTable.get())
                .append(".id =  ")
                .append(proposedTable.get())
                .append(".programme_id ")
                .append(" AND  ")
                .append(usersTable.get())
                .append(".id =  ")
                .append(proposedTable.get())
                .append(".user_id ");
        return stmt.toString();
    }

    /**
     * @return String
     */
    public static String wcUserCycleTables() {
        StringBuffer stmt = new StringBuffer();
        stmt.append(" ,").append(usersTable.get()).append(" ,").append(
                proposedTable.get()).append(" ,").append(programmesTable.get());
        return stmt.toString();
    }

    /**
     * @param userId
     * @return String
     */
    public static String wcUserCycle(int userId) {
        StringBuffer stmt = new StringBuffer();
        stmt
                .append(usersTable.get())
                .append(".id = ")
                .append(userId)
                .append(" AND  ")
                .append(usersTable.get())
                .append(".id =  ")
                .append(proposedTable.get())
                .append(".user_id ")
                .append(" AND  ")
                .append(programmesTable.get())
                .append(".id =  ")
                .append(proposedTable.get())
                .append(".programme_id ")
                .append(" AND  ")
                .append(programmesTable.get())
                .append(".cycle_id =  ")
                .append(cyclesTable.get())
                .append(".id ")
                .append(" AND  ")
                .append(programmesTable.get())
                .append(".ignored =  0");
        return stmt.toString();
    }

    /**
     * @param cycleLabel
     * @param step_id
     *            int
     * @return String
     */
    public static String wcCycleList(int step_id) {
        StringBuffer stmt = new StringBuffer();
        stmt.append(cyclesTable.get()).append(".step_id = ").append(step_id);
        return stmt.toString();
    }

    /**
     * * param id param id long
     * 
     * @param category
     * @param description
     * @param origin
     *            String
     * @return String
     */
    public static String insertWriterProposalLogEntry(long id, int category,
            String description, String origin) {
        long date = Calendar.getInstance().getTimeInMillis();
        StringBuffer stmt = new StringBuffer();
        stmt
                .append("INSERT INTO ")
                .append(propSummaryLogTable.getTable())
                .append(
                        "\n (summary_id, reference_obj, creation_date,  category,event_desc, originator )\n")
                .append(" VALUES ( ")
                .append(id)
                .append(",1,")
                .append(date)
                .append(",")
                .append(category)
                .append(",\'")
                .append(TextUtils.quoteSqlString(description))
                .append("\',\'")
                .append(origin)
                .append("\')");
        return stmt.toString();
    }

    /**
     * @param userId
     * @return String
     */
    public static String wcRefereeDdt(long userId) {
        StringBuffer stmt = new StringBuffer();
        stmt
                .append(refereesTable.get())
                .append(".user_id = ")
                .append(userId)
                .append("\n AND ")
                .append(esoUsersRolesTable.get())
                .append(".login = convert(varchar(32), ")
                .append(refereesTable.get())
                .append(".user_id) ")
                .append("\n AND ")
                .append(esoUsersRolesTable.get())
                .append(".letters_role = 'refDdt' ")
                .append("\n AND ")
                .append(cyclesTable.get())
                .append(".step_id = 1 ")
                .append("\n OR ")
                .append(cyclesTable.get())
                .append(".step_id = 11 ");
        return stmt.toString();
    }

    /**
     * @return String
     */
    public static String wcRefereeDdtTables() {
        StringBuffer stmt = new StringBuffer();
        stmt.append(" ,").append(esoUsersRolesTable.get());
        return stmt.toString();
    }

    /**
     * @param userId
     * @return String
     */
    public static String wcUserRole(String role) {
        StringBuffer stmt = new StringBuffer();
        stmt
                .append(esoUsersRolesTable.get())
                .append(".login = convert(varchar(32), ")
                .append(usersTable.get())
                .append(".id) ")
                .append("\n AND ")
                .append(esoUsersRolesTable.get())
                .append(".letters_role = '")
                .append(role)
                .append("'");
        return stmt.toString();
    }

    /**
     * @return String
     */
    public static String wcUserRoleTables() {
        StringBuffer stmt = new StringBuffer();
        stmt.append(" ,").append(esoUsersRolesTable.get());
        return stmt.toString();
    }

    /**
     * @param proposalId
     * @param extensionFormat
     * @return String
     */
    public static String updateProposalOutput(String proposalId,
            String extensionFormat) {

        StringBuffer stmt = new StringBuffer();

        stmt.append("UPDATE ").append(proposalOutputTable.get()).append(
                " set data = ").append(getQuestionMark()).append(
                " WHERE programme_id = ").append(proposalId);
        return stmt.toString();
    }

    /**
     * @param proposalId
     * @return String
     */
    public static String deleteProposalOutput(long programmeId) {

        StringBuffer stmt = new StringBuffer();
        stmt.append("DELETE ").append(proposalOutputTable.get()).append(
                " WHERE programme_id = ").append(programmeId);
        return stmt.toString();
    }

    /**
     * @param proposalId
     * @param extensionFormat
     * @return String
     */
    public static String insertProposalOutput(String proposalId,
            String extensionFormat) {

        StringBuffer stmt = new StringBuffer();
        stmt.append("INSERT INTO ").append(proposalOutputTable.get()).append(
                " (programme_id, format)").append(" VALUES (").append(
                proposalId).append(" , '").append(extensionFormat).append(
                "')\n ");
        stmt.append(updateProposalOutput(proposalId, extensionFormat));
        return stmt.toString();
    }

    /**
     * @param proposalId
     * @return String
     */
    public static String getProposalOut(long proposalId) {
        StringBuffer stmt = new StringBuffer();
        stmt.append("SELECT ").append(proposalOutputTable.get()).append(
                ".data FROM ").append(proposalOutputTable.get()).append(
                " WHERE ").append(proposalOutputTable.get()).append(
                ".programme_id =  ").append(proposalId);
        return stmt.toString();
    }

    /**
     * @param proposalId
     * @return String
     */
    public static String getProposalOutFormat(long proposalId) {
        StringBuffer stmt = new StringBuffer();
        stmt.append("SELECT ").append(proposalOutputTable.get()).append(
                ".format FROM ").append(proposalOutputTable.get()).append(
                " WHERE ").append(proposalOutputTable.get()).append(
                ".programme_id =  ").append(proposalId);
        return stmt.toString();
    }

    /**
     * @param proposalId
     * @return String
     */
    public static String countProposalOutEntry(long proposalId) {
        StringBuffer stmt = new StringBuffer();
        stmt.append("SELECT count(*) ").append(" FROM ").append(
                proposalOutputTable.get()).append(" WHERE ").append(
                proposalOutputTable.get()).append(".programme_id =  ").append(
                proposalId);
        return stmt.toString();
    }

    /**
     * @return String
     */
    public static String getNewUserId() {
        StringBuffer stmt = new StringBuffer();
        stmt
                .append("UPDATE unique_keys ")
                .append("SET keyvalue = keyvalue + 1 ")
                .append("WHERE keyname = 'ESOUSERS' \n")
                .append("SELECT  keyvalue ")
                .append("FROM unique_keys ")
                .append("WHERE keyname = 'ESOUSERS' ");
        return stmt.toString();
    }

    /**
     * @param progId
     * @param pictureName
     * @return String
     */
    public static String insertRowPicture(long progId, String pictureName) {
        StringBuffer stmt = new StringBuffer();
        stmt
                .append("INSERT INTO ")
                .append(figuresTable.getTable())
                .append(
                        "\n ( programme_id, file_name,postscript_text, received_flag )\n")
                .append(" \nVALUES ( ")
                .append(progId)
                .append(",'")
                .append(TextUtils.quoteSqlString(pictureName))
                .append("','',0)");
        return stmt.toString();
    }

    /**
     * @param progId
     * @param pictureName
     * @return String
     */
    public static String countPicture(long progId, String pictureName) {
        StringBuffer stmt = new StringBuffer();
        stmt
                .append("SELECT count(*) FROM ")
                .append(figuresTable.getTable())
                .append(" WHERE ")
                .append(" programme_id = ")
                .append(progId)
                .append("\n AND file_name = '")
                .append(pictureName)
                .append("'");
        return stmt.toString();
    }

    /**
     * @param proposalId
     *            long
     * @return String
     */
    public static String selProposalSummaryCycle(long summaryId) {
        StringBuffer stmt = new StringBuffer();
        stmt
                .append("SELECT DISTINCT ")
                .append(proposalSummaryTable.get())
                .append(".cycle_label ")
                .append(" FROM ")
                .append(proposalSummaryTable.get())
                .append(" WHERE ")
                .append(proposalSummaryTable.get())
                .append(".id = ")
                .append(summaryId);
        return stmt.toString();
    }

    /**
     * @param proposalId
     *            long
     * @return String
     */
    public static String selProposalSummaryStatus(long summaryId) {
        StringBuffer stmt = new StringBuffer();
        stmt
                .append("SELECT  ")
                .append(proposalSummaryTable.get())
                .append(".status ")
                .append(" FROM ")
                .append(proposalSummaryTable.get())
                .append(" WHERE ")
                .append(proposalSummaryTable.get())
                .append(".id = ")
                .append(summaryId);
        return stmt.toString();
    }

    /**
     * @param proposalId
     *            long
     * @return String
     */

    /**
     * @param id
     * @return String
     */
    public static String getLatexSourceCache(long id) {
        StringBuffer stmt = new StringBuffer();
        stmt
                .append("SELECT ")
                .append(Phase1SelectStmt.proposalSummaryTable.get())
                .append(".latex_source FROM ")
                .append(Phase1SelectStmt.proposalSummaryTable.get())
                .append(" WHERE ")
                .append(Phase1SelectStmt.proposalSummaryTable.get())
                .append(".id =  ")
                .append(id);
        return stmt.toString();
    }

  

    /**
     * @param id
     * @param name
     *            String
     * @return String
     */
    public static String getFigureBinaryInCache(long id, String name) {
        StringBuffer stmt = new StringBuffer();
        stmt
                .append("SELECT ")
                .append(Phase1SelectStmt.figureSummaryTable.get())
                .append(".picture FROM ")
                .append(Phase1SelectStmt.figureSummaryTable.get())
                .append(" WHERE ")
                .append(Phase1SelectStmt.figureSummaryTable.get())
                .append(".summary_id =  ")
                .append(id)
                .append("\n AND ")
                .append(Phase1SelectStmt.figureSummaryTable.get())
                .append(".picture_name = \'")
                .append(name)
                .append("\'");
        return stmt.toString();
    }

    /**
     * @return String
     */
    public static String wcRunsScheduledTables() {
        StringBuffer stmt = new StringBuffer();
        stmt.append(" ,").append(programmesTable.get());
        return stmt.toString();
    }

    /**
     * @param cycleId
     * @return String
     */
    public static String wcRunsScheduled(int cycleId) {
        StringBuffer stmt = new StringBuffer();
        stmt
                .append(runsTable.get())
                .append(".programme_id = ")
                .append(programmesTable.get())
                .append(".id ")
                .append(" \nAND ")
                .append(runsTable.get())
                .append(".scheduled = 'S' ")
                .append(" \nAND ")
                .append(programmesTable.get())
                .append(".ignored = 0 ")
                .append(" \nAND ")
                .append(programmesTable.get())
                .append(".cycle_id = ")
                .append(cycleId);
        return stmt.toString();
    }

    /**
     * @param runId
     * @return String
     */
    public static String countSchedRuns(long runId) {
        StringBuffer stmt = new StringBuffer();
        stmt
                .append("SELECT count(*) FROM ")
                .append(schedRepTable.get())
                .append(" WHERE run_id = ")
                .append(runId);
        return stmt.toString();
    }

    /**
     * Store procedure cannot be unit tested
     * 
     * @param cycle
     *            String
     * @return String
     */
    public static String getSchedRepId() {
        StringBuffer stmt = new StringBuffer();
        stmt.append(" opc_get_key \'SCHEDREP\' ");
        return stmt.toString();
    }

    /**
     * Store procedure cannot be unit tested
     * 
     * @param cycle
     *            String
     * @return String
     */
    public static String getProposalSummaryId() {
        StringBuffer stmt = new StringBuffer();
        stmt.append(" opc_get_key \'PROPOSAL_SUMMARY\' ");
        return stmt.toString();
    }

    /**
     * Store procedure cannot be unit tested
     * 
     * @param cycle
     *            String
     * @return String
     */
    public static String getGtoId() {
        StringBuffer stmt = new StringBuffer();
        stmt.append(" opc_get_key \'GTO_ID\' ");
        return stmt.toString();
    }

    
    
    
    /**
     * @param userID
     * @return String stmt
     */
    public static String countReferee(int userID) {
        StringBuffer stmt = new StringBuffer();
        stmt
                .append(" SELECT count(*) FROM ")
                .append(refereesTable.get())
                .append(" WHERE user_id = ")
                .append(userID);
        ;
        return stmt.toString();
    }

    /**
     * @param userID
     * @return String stmt
     */
    public static String countObsBlocks(int userID) {
        StringBuffer stmt = new StringBuffer();
        stmt
                .append(" SELECT count(*) FROM ")
                .append(obsBlocksTable.get())
                .append(" WHERE user_id = ")
                .append(userID);
        ;
        return stmt.toString();
    }

    /**
     * @param userID
     * @return String stmt
     */
    public static String countSchedObsBlocks(String progId) {
        StringBuffer stmt = new StringBuffer();
        stmt
                .append(" SELECT count(*) FROM ")
                .append(obsBlocksTable.get())
                .append(" WHERE prog_id = ")
                .append(progId);
        ;
        return stmt.toString();
    }

    /**
     * @return String stmt
     */
    public static String selObsRunProgramme() {

        return null;
    }

    /**
     * @return String stmt
     */
    public static String selAllSchedModes() {
        StringBuffer stmt = new StringBuffer();
        stmt.append(" SELECT distinct obs_mode FROM ").append(
                schedRepTable.get()).append(" WHERE period > 70 ");
        ;
        return stmt.toString();
    }

    /**
     * @param userID
     * @param passwd
     * @return String
     */
    public static String getCountUser(int userID, String passwd) {
        StringBuffer stmt = new StringBuffer();
        stmt
                .append("SELECT count(*) FROM ")
                .append(usersViewTable.get())
                .append(" WHERE ")
                .append(usersViewTable.get())
                .append(".password = ")
                .append("'")
                .append(passwd)
                .append("'")
                .append("\n AND ")
                .append(usersViewTable.get())
                .append(".login = ")
                .append("'")
                .append(userID)
                .append("'");
        return stmt.toString();
    }

    /**
     * @return String
     */
    public static String getRoles(String[] userId) {
        StringBuffer stmt = new StringBuffer();
        String userList = TextUtils.arrayToString(userId, "', '", true);
        stmt
                .append("SELECT DISTINCT letters_role FROM ")
                .append(usersRolesTable.get())
                .append(" WHERE ")
                .append(usersRolesTable.get())
                .append(".login in ('")
                .append(userList)
                .append("') ");
        return stmt.toString();
    }

    /**
     * @return String
     */
    public static String getRoles(String userId) {
        StringBuffer stmt = new StringBuffer();
        stmt
                .append("SELECT DISTINCT letters_role FROM ")
                .append(usersRolesTable.get())
                .append(" WHERE ")
                .append(usersRolesTable.get())
                .append(".login = '")
                .append(userId)
                .append("' ");
        return stmt.toString();
    }

    /**
     * @param userList
     * @param roleSelected
     * @return String
     */
    public static String deleteRole(String[] userList, String roleSelected) {
        StringBuffer stmt = new StringBuffer();
        String userListString = TextUtils.arrayToString(userList, "', '", true);
        stmt
                .append("DELETE ")
                .append(usersRolesTable.get())
                .append(" WHERE ")
                .append(usersRolesTable.get())
                .append(".login in ('")
                .append(userListString)
                .append("')  ")
                .append("\n AND ")
                .append(usersRolesTable.get())
                .append(".letters_role = '")
                .append(roleSelected)
                .append("' ");
        return stmt.toString();
    }

    /**
     * @param userList
     * @param roleSelected
     * @return String
     */
    public static String addRole(String[] userIdArray, String roleSelected) {
        String userList = TextUtils.arrayToString(userIdArray, "', '", false);
        StringBuffer stmt = new StringBuffer();
        stmt
                .append("\n DELETE FROM ")
                .append(esoUsersRolesTable.get())
                .append(" ")
                .append("\n WHERE ")
                .append(esoUsersRolesTable.get())
                .append(".login in ( '")
                .append(userList)
                .append(" ') ")
                .append("\n AND ")
                .append(esoUsersRolesTable.get())
                .append(".letters_role = '")
                .append(roleSelected)
                .append("'");
        for (int i = 0; i < userIdArray.length; i++) {
            stmt
                    .append("\n INSERT INTO ")
                    .append(esoUsersRolesTable.get())
                    .append("(login, letters_role)")
                    .append(" VALUES ('")
                    .append(userIdArray[i])
                    .append("', '")
                    .append(roleSelected)
                    .append("')");
        }
        return stmt.toString();
    }

    /**
     * @param id
     * @param instrument
     * @return String
     */
    public static String getTelescope(long cycleId, String instrument) {
        StringBuffer stmt = new StringBuffer();
        stmt
                .append("SELECT ")
                .append(offeredTable.get())
                .append(".telescope_code FROM ")
                .append(offeredTable.get())
                .append(" WHERE ")
                .append(offeredTable.get())
                .append(".cycle_id =  ")
                .append(cycleId)
                .append(" AND ")
                .append(offeredTable.get())
                .append(".instrument_code =  '")
                .append(instrument)
                .append("'");
        return stmt.toString();
    }

    /**
     * @param proposalId
     * @param name
     * @return String
     */
    public static String countReceivedFigures(long proposalId, String name) {
        StringBuffer stmt = new StringBuffer();
        stmt.append("select count(*) from ").append(figuresTable.get()).append(
                " WHERE file_name = '").append(name).append("'").append(
                " AND programme_id = ").append(proposalId).append("\n\n");
        return stmt.toString();
    }

    public static String updateAllocationTime(String telescope, String panelData, int timeValue) {
        StringBuffer stmt = new StringBuffer();
        stmt
                .append("UPDATE  ")
                .append(cutoffTable.get())
                .append(" SET ")
                .append(cutoffTable.get())
                .append(".cutoff = ")
                .append(timeValue)
                .append(" \n WHERE ")
                .append(cutoffTable.get())
                .append(".code = '")
                .append(telescope)
                .append("' ")
                .append("\n AND ")
                .append(cutoffTable.get())
                .append(".category = '")
                .append(panelData.charAt(0))
                .append("' \n AND ")
                .append(cutoffTable.get())
                .append(".opc_subpanel = ")
                .append(Integer.parseInt(panelData.substring(1)))
                .append(" ");
        return stmt.toString();
    }

    public static String getPanelSubpanelPair(String cycleLabel){
    	 StringBuffer stmt = new StringBuffer();
         stmt
                 .append("SELECT DISTINCT  ")
                 .append(refereesTable.get())
                 .append(".panel, convert(varchar, ")
                 .append(refereesTable.get())
                 .append(".opc_subpanel)")
                 .append(" FROM ")
                 .append(refereesTable.get())
                 .append(", ")
                 .append(cyclesTable.get())       
                 .append(" \n WHERE ")
                 .append(refereesTable.get())
                 .append(".cycle_id = ")
                 .append(cyclesTable.get())
                 .append(".id AND ")
                 .append(cyclesTable.get())
                 .append(".label = '")
                 .append(cycleLabel)            
                 .append("' ");
        return stmt.toString();
 
    }

    public static String wcCyclesFromReferee(long userId) {
        StringBuffer stmt = new StringBuffer();
        stmt
                .append(cyclesTable.get())
                .append(".id = ")
                .append(refereesTable.get())
                .append(".cycle_id ")
                .append(" \n AND ")
                .append(refereesTable.get())
                .append(".user_id = ").append(userId);
        return stmt.toString();
    }
    public static String wcCyclesFromRefereeTables() {
        StringBuffer stmt = new StringBuffer();
        stmt.append(", ")
                .append(refereesTable.get());
        return stmt.toString();
    }
  

}