package org.eso.ohs.phase2.apps.ipacman;

import org.apache.log4j.Logger;
import org.eso.ohs.core.utilities.ObjectIOException;
import org.eso.ohs.persistence.AppConfig;
import org.eso.ohs.persistence.Config;
import org.eso.ohs.persistence.DirectoryNode;
import org.eso.ohs.persistence.Media;

/**
 * Clearing house for low-level configuration information
 * <p>
 * $Id: MyPersistCfg.java,v 1.14 2007/10/11 11:41:38 pnunes Exp $
 * @version $Revision: 1.14 $
 * @author Ron J Lobo
 */
// TODO should inherit from apps.DefaultPersistConfig

public class MyPersistCfg extends Config {

    private static Logger stdlog_ =
        Logger.getLogger( MyPersistCfg.class );

    public String[] folderColumnProperties(Class objType) {
        return AppConfig.getAppConfig().folderColumnProperties(objType);
    }

    public String getDbUserName() {
        return AppConfig.getAppConfig().getDbUserName();
    }

    public String getDbPassword() {
        return AppConfig.getAppConfig().getDbPassword();
    }

    public String getUrl(String key) {
        return AppConfig.getAppConfig().getUrl(key);
    }

    public String getDbName(String key) {
        return AppConfig.getAppConfig().getDbName(key);
    }

//    public boolean isOperationsModeId(int uid) {
//        return AppConfig.getAppConfig().isOperationsModeId(uid);
//    }
//
//    public boolean isEngineeringModeId(int uid) {
//        return AppConfig.getAppConfig().isEngineeringModeId(uid);
//    }
//
//    public boolean isVisitorModeId(int uid) {
//        return AppConfig.getAppConfig().isVisitorModeId(uid);
//    }
//
//    public boolean isStandardModeId(int uid) {
//        return AppConfig.getAppConfig().isStandardModeId(uid);
//    }

    public boolean isCloneModeId() {
        return false;
    }


    /**
     * What is the first period for which IP versioning info
     * is expected in the data. 0 indicates no start period, no
     * version info is expected.
     */
    public int getStartPeriodForIPVersioning() {
        int rc = 0;
        if (AppConfig.getAppConfig().isIPVersioningEnabled()) {
            rc = AppConfig.getAppConfig().getIPVersionStartPeriod();
        }
        return rc;
    }


    /**
     * Ask for authentification before action can take place
     * @param device Media referreed to DBASE,LOCAL_STORAGE
     * @exception ObjectIOException Object I/O Excpetion
     */

    public void askForAuthentication(Media device)
        throws ObjectIOException {
        throw new ObjectIOException("IPACMAN doesn't authenticate");
    }






    public boolean isUserLevel(Class cls) {
        return cls != null && cls != DirectoryNode.class;
    }


    public void initPersistenceObjInfo() {
    }


}

