package org.eso.ohs.phase2.apps.p2ppAppServer;

import java.rmi.Remote;
import java.rmi.RemoteException;
import java.sql.SQLException;

import org.eso.ohs.core.dbb.rmi.DbbRemoteEngine;
import org.eso.ohs.core.utilities.ObjectIOException;
import org.eso.ohs.persistence.Media;

/**
 * @author nkornwei
 *
 * Created to solve cyclic reference error reported by in Java 1.4 compiler.
 * (moved from inner class of AppServer).
 */
public interface AppServerFactory extends Remote, DbbFactoryP2PP {

        // Obselete: Backwards compatibility only
        public RmiManagerInterface getStorageManager()
            throws RemoteException, ObjectIOException;

        public RmiManagerInterface getStorageManager(Media device)
            throws RemoteException, ObjectIOException;

        // Will be replaced by (eg) getDbbEngine(key)
        public DbbRemoteEngine getPhase1Engine()
            throws SQLException, RemoteException;

        // Will be replaced by (eg) getDbbEngine(key)
        public DbbRemoteEngine getPhase2Engine()
            throws SQLException, RemoteException;

    }