package org.eso.ohs.scripting;

import java.io.ByteArrayInputStream;
import java.io.InputStream;

import org.eso.ohs.core.utilities.ImageInfo;
import org.eso.ohs.dfs.FindingChart;

public class FindingChartAdaptor  implements FindingChartAPI  {

	private FindingChart findingChart;
	private ImageInfo image;

	public FindingChartAdaptor(FindingChart findingChart) {
		this.findingChart = findingChart;
	}

	/* (non-Javadoc)
	 * @see org.eso.ohs.scripting.FindingChartAPI#getHeight()
	 */
	public int getHeight() {
		ImageInfo img = getImage();
        return(img.getHeight());
	}

	/**
	 * @return
	 */
	private ImageInfo getImage() {
		if (image == null) {
			InputStream stream = new ByteArrayInputStream(findingChart.getFcData());
			image= new ImageInfo();
			image.setInput(stream);
			image.check();
		}

		return(image);
	}

	/* (non-Javadoc)
	 * @see org.eso.ohs.scripting.FindingChartAPI#getName()
	 */
	public String getName() {
		return(findingChart.getFcName());
	}

	/* (non-Javadoc)
	 * @see org.eso.ohs.scripting.FindingChartAPI#getWidth()
	 */
	public int getWidth() {
		ImageInfo img = getImage();
        return(img.getWidth());
	}


	/* (non-Javadoc)
	 * @see org.eso.ohs.scripting.FindingChartAPI#fileSize()
	 */
	public int getSize() {
		return(findingChart.getFcData().length);
	}



}
